"use strict";
var ims;
var isiOS;
var i;
// var url_interfaz        = '';
var json;
var config_json;
var palabrasResueltas   = 0;
var cantidadPalabras    = 0;
var letrasCompletadas   = 0;
var correctas           = 0;
var incorrectas         = 0;
var palabras            = [];
var audios              = [];
var imagenes            = [];
var ordenPalabras       = [];
var dificultadActual    = 0;
var titulo;
var click               = (('ontouchend' in window)) ? 'touchend' : 'click';
var url_files,url_files2;

 var _dificultadUnica = false;

var posicionar = function(){
    ims.interfaz.resize();
    $("#visor").height($("#carcasa").height());
};

var init = function() {
    ims.interfaz.disableIE();
    // if($("#url_interfaz").text() !== "") {
    //     url_interfaz = $("#url_interfaz").text();
    // }
    $("#url_interfaz").remove();
    
    ims.interfaz.init();
    inicializar();
    // ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    // ims.interfaz.setSound('bad', url_interfaz + 'audio/bad.mp3');
    // ims.interfaz.setSound('result', url_interfaz + 'audio/result.mp3');
    // ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
    ims.interfaz.setSound('result_bad', url_interfaz + 'audio/result_bad.mp3');
    ims.interfaz.setSound('result_good', url_interfaz + 'audio/result_good.mp3');
    // $("#overall").remove();
    // $("#right2").remove();
    // $("#left2").remove();
    if(!document.addEventListener) {
        document.attachEvent("touchmove", function(){
            return false;
        },false);
    }else{
      document.addEventListener("touchmove",function(){
         return false;
      }, false);
    }
    if (isiOS){
      $("body").css("margin-top", "-20px");
    }
};

if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener ) {
    window.addEventListener( 'DOMContentLoaded', function(  ) {

        init();
        window.addEventListener( "scroll", posicionar, false );
        window.addEventListener( "resize", posicionar, false );
        window.addEventListener( "load",  posicionar, false );
    });
}else{
    $(window).ready(function(){
        init();
    });
    $(window).resize(function(){
        posicionar();
    });
    $(window).load(function(){
        posicionar();
    });
    $(window).scroll(function(){
        posicionar();
    });
}

$(document).ready(function() {
    ims.interfaz.resize();
});

function inicializar() {
//    config_json = $.parseJSON(json);
    //console.dir(config_json);
    titulo = config_json.textos.titulo;
    ims.interfaz.setTitle(titulo);

    url_files = config_json.path;
    cargar_herramienta();
}

function cargar_herramienta() {   
    desplegarMenuDificultad();
}

function desplegarMenuDificultad(){
    
    var cantDificultades = config_json.dificultades.length;

    var _numeroDificultadesConContenido = 0;
    var _idDificultadUnica = false;

    for( var i = 0; i < cantDificultades; i++ ){
        if ( typeof ( config_json.dificultades[i].palabras ) != "undefined") {
            _numeroDificultadesConContenido++;
             _idDificultadUnica = i;
        }
    }

    if ( _numeroDificultadesConContenido == 1 ){
        _dificultadUnica = true;
        introduce_retorno();
        jugarDificultad( _idDificultadUnica );
        return;
    }

    //pintar fondo
    $("#visor").addClass('fondoAnimales');
    //dibujar los botones de dificultad
    $('#visor').append('<div id="menuBotones"></div>');

    for( var i=0; i<cantDificultades; i++ ){
        if ( typeof (config_json.dificultades[i].palabras) != "undefined") {
            $('#menuBotones').append('<div id="'+i+'" class="botones-dificultad">'+config_json.dificultades[i].dificultad+'</div>');
        }
        else{
             //$('#menuBotones').append('<div id="'+i+'" class="desactivado botones-dificultad">'+config_json.dificultades[i].dificultad+'</div>');           
        }
    }
    
    $('.botones-dificultad').bind('click', function() {
        jugarDificultad(this.id);
    });

    $("#overall").remove();
    $("#right2").remove();
    $("#left2").remove();
    mostrarBotonVolver();
}

function jugarDificultad(idDificultad){
    dificultadActual = idDificultad;

    //obtener las palabras correspondientes a la dificultad escogida
    palabras = obtenerPalabras(idDificultad);
    cantidadPalabras = palabras.length;
    audios = obtenerAudios(idDificultad);
    imagenes = obtenerImagenes(idDificultad);

    //determinar un orden aleatorio para mostrar las palabras
    ordenPalabras = desordenarPalabras(palabras.length);
    //console.dir(ordenPalabras);
    //console.dir(palabras);

    //iniciar el juego con la primera palabra
    jugarPalabra(ordenPalabras[0]);
}

/**
 * asocia una palabra a la pantalla, muesta la imagen y asocia la locucion al elemento audio
 * @@param int palabra: numero de orden dentro del array palabras 
 * @return array
 */
function jugarPalabra(palabra){
  var code, cajasRespuesta;
    emptyStage();
    cargarCommonStage();
    $("#menuBotones").remove();
    $('#overall').remove();
    $('#visor').append('<div id="overall"><div id="ilustracion"></div><div id="inferior"><div id="megafono"></div><div id="respuestas"></div></div></div>');

    ims.interfaz.enable("aleatorio");
    if ( !_dificultadUnica ){
        ims.interfaz.bind("Anterior", 'volverInicio()');
        ims.interfaz.enable("Anterior");
    }
    ims.interfaz.enableSound('result_good');
    ims.interfaz.enableSound('result_bad');
	if(imagenes[palabra] != null && imagenes[palabra] !=  ""){
   		var url_imagen = url_files+imagenes[palabra];
        $('#ilustracion').append('<div id="imagenCentral" class="centradoVH imagenCentral" style="background-image: url('+url_imagen+')">');
        console.log( "imagen", url_imagen );
    }
        cajasRespuesta = '';
    for(i=0;i<palabras[palabra].length;i++){
        cajasRespuesta = cajasRespuesta+'<input type="text" class="respuesta" id="respuesta_'+i+'"  maxlength="1" autocapitalize="off">';
    }

    $('#respuestas').append(cajasRespuesta);
    
    if(audios[palabra] != null && audios[palabra] !=  ""){
	    // if( url_files2 ){
	    //     $('#respuestas').append('<audio id="audioPalabra" src="'+url_files2+'/'+audios[palabra]+'" preload="auto"></audio>');
	    // }
     //    else{
    		
        console.log( "AUDIO", audios[palabra] );

        $('#carcasa').append('<audio id="audioPalabra"></audio>');
        var _obj = url_files+'/'+audios[palabra];
        var _toFind = 'files//';
        var _regExp = new RegExp( _toFind, 'g' );
        _obj = _obj.replace( _regExp, 'files/' );
        $("#audioPalabra").get(0).src = _obj;
        $("#audioPalabra").get(0).load();
    		//$('#respuestas').append('<audio id="audioPalabra" src="'+url_files+'/'+audios[palabra]+'" preload="auto"></audio>');
    		
	    // }
    }

    $('.respuesta').bind('keyup', function(evnt) {
        //detectar el codigo de la tecla pulsada
        var ev = (evnt) ? evnt : event;
        code=(ev.which) ? ev.which : event.keyCode;
//alert(code);
        //si ha pulsado una letra comprobar, si ha pulsado borrar no hacer nada
        //if(code!==8&&code!==222){
        if((code>=65&&code<=90)||(code>=97&&code<=122)||(code==186)||(code==191)||(code==192)){
            comprobarRespuesta(palabras[palabra]);
        }
    });
    $('#megafono').bind('click', function() {
        reproducirPalabra();
    });
}

/*
* valida el contenido de las cajas de respuesta
*/
function comprobarRespuesta(palabraCorrecta){
  var elementoActivo, siguienteElemento;
    //determinar cual es el proximo elemento que debe recibir el foco
    elementoActivo = parseInt(document.activeElement.id.substring(10,11)) + 1;
    //si la caja siguiente esta verde (readonly), determinar el proximo disponible
    while( $('#respuesta_'+elementoActivo).attr('readonly')=='readonly' ){
        elementoActivo++;
    }
    siguienteElemento = elementoActivo;
    //contar cajas completas
    letrasCompletadas = 0;
    for(i=0;i<$('.respuesta').length;i++){
        if($('.respuesta')[i].value !== ''){
            letrasCompletadas++;
        }
    }
    //si todas las cajas estan completas, verificar si estan correctas. Sino, marcar en verde las correctas, en rojo los errores, limpiar y pasar el foco a la proxima caja
    if(letrasCompletadas==$('.respuesta').length){
        //contar correctas e incorrectas. Pintarlas de rojo o verde
        correctas = 0;
        incorrectas = 0;  
        for(i=0;i<$('.respuesta').length;i++){
            if(quitarAcentos($('.respuesta')[i].value.toLowerCase())==quitarAcentos(palabraCorrecta.substring(i,i+1)).toLowerCase()){
                $('#respuesta_'+i).addClass('green');
                correctas++;
            }else{
                $('#respuesta_'+i).addClass('red');
                incorrectas++;
            }
        }    
        //si todas las cajas son correctas, finalizar la palabra.
        //como la palabra se da por buena haya puesto o no las tildes, actualizar las cajas con las letras con tildes (palabra correcta real)
        //sino, limpiar las cajas incorrectas
        if(correctas == $('.respuesta').length){
            //$('#ilustracion').addClass('iluminado');//el req. orig. establecia iluminar la imagen
            mostrarPalabraCorrecta(palabraCorrecta);
            //deshabilitar las cajas verdes
            $('.green').attr('disbled','disabled');
            $('.green').attr('readonly','readonly');
            ims.interfaz.playSound('result_good');
            ims.interfaz.disableSound('result_good');
            ims.interfaz.disable("versolucion");
            $("#versolucion").unbind();
            return;
        }else{
            //deshabilitar las cajas verdes
            $('.green').attr('disbled','disabled');
            $('.green').attr('readonly','readonly');

            ims.interfaz.disable("versolucion");
            $("#versolucion").unbind();
            setTimeout(function(){
                $.each( $('.red'), function(){
                    this.value = '';
                });
                $('.red').removeClass('red');
                //resetear las cajas rojas
                ims.interfaz.playSound('result_bad');
                //si no ha completado todas las cajas correctamente, pasar el foco a la siguiente
                $('#respuesta_'+siguienteElemento).focus();
                ims.interfaz.enable("versolucion");
                ims.interfaz.bind("versolucion", "versolucion()");
            },1000);
            return;
        }
    }else{
        $('#respuesta_'+siguienteElemento).focus();
        return;
    }
}

/**
 * reproduce el sonido del archivo asociado al tag audioPalabra
 * @@param  
 * @return void
 */
function reproducirPalabra(){
    document.getElementById('audioPalabra').play();
    return;
}

/**
 * obtiene las palabras correspondientes a una dificultad
 * @@param int idDificultad: numero de dificultad 
 * @return array
 */
function obtenerPalabras(idDificultad){
    if(!$.isNumeric(idDificultad)) {
        return false;
    }
    var palabras = [];
    for(i=0;i<config_json.dificultades[idDificultad].palabras.length;i++){
        palabras[i]=config_json.dificultades[idDificultad].palabras[i].palabra;
    }
    return palabras;
}

/**
 * obtiene las imagenes correspondientes a una dificultad
 * @@param int idDificultad: numero de dificultad 
 * @return array
 */
function obtenerImagenes(idDificultad){
    if(!$.isNumeric(idDificultad)) {
        return false;
    }
    imagenes =[];
    for(i=0;i<config_json.dificultades[idDificultad].imagenes.length;i++){
        imagenes[i]=config_json.dificultades[idDificultad].imagenes[i].imagen;
    }
    return imagenes;
}

/**
 * obtiene los audios (locuciones de palabras) correspondientes a una dificultad
 * @@param int idDificultad: numero de dificultad 
 * @return array
 */
function obtenerAudios(idDificultad){
    if(!$.isNumeric(idDificultad)) {
        return false;
    }
    var audios = [];
    for(i=0;i<config_json.dificultades[idDificultad].audios.length;i++){
        audios[i]=config_json.dificultades[idDificultad].audios[i].audio;
    }
    return audios;
}

/**
 * recibe la cantidad de palabras cargadas y devuelve un array desordenado con enteros de 0 a cantidadPalabras
 * ej: 6 palabras retorna [3,5,0,1,2,4]
 * @@param int cantidadPalabras 
 * @return array
 */
function desordenarPalabras(cantidadPalabras){
    if(!$.isNumeric(cantidadPalabras)) {
        return false;
    }
    var array = [];
    for(i=0; i<cantidadPalabras;i++){
        array[i]=i;
    }   
    var currentIndex = array.length;
    var temporaryValue;
    var randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}

/**
 * despliega la palabra siguiente segun el array ordenPalabras
 * @@param  
 * @return bool
 */
function desplegarPalabraAleatoria(){
    palabrasResueltas++;
    jugarPalabra(ordenPalabras[palabrasResueltas]);
    return true;
}

//quita los elementos presente y limpia el visor
// -------------------------------------------------------------------------
function emptyStage(){
    $("#right").empty();
    $("#left").empty();
    $(".tooltip").hide();
}

//agrega los botones, los bindea y los habilita
// --------------------------------------------------------------
function cargarCommonStage(){
    var aleatorio = (config_json.textos.aleatorio !== "" ) ? config_json.textos.aleatorio : "";
    var silenciar = (config_json.textos.silenciar !== "" ) ? config_json.textos.silenciar : "";
    var volver = (config_json.textos.volver !== "" ) ? config_json.textos.volver : "Volver";
    var txt_versolucion = (config_json.textos.solucion !== "") ? config_json.textos.solucion : "";

    if (silenciar) {
        ims.interfaz.addButton("mute","left","silenciar",silenciar);
        ims.interfaz.addButton("unmute","left","silenciar_on",silenciar);
    }
    ims.interfaz.addButton("Anterior", "left", "anterior", volver);

    if (txt_versolucion) {
        ims.interfaz.addButton("versolucion","right","versolucion",txt_versolucion);
    }
    if (aleatorio) {
        ims.interfaz.addButton("aleatorio","right","aleatorio",aleatorio);
    }
    ims.interfaz.bind("aleatorio","desplegarPalabraAleatoria()");
    ims.interfaz.bind("mute","silenciar()");
    ims.interfaz.bind( "unmute", "nosilenciar()" );
    ims.interfaz.enable("mute");
    ims.interfaz.bind( "versolucion", "versolucion()" );
    ims.interfaz.enable("versolucion");
    $('#unmute').css('display','none');
    if(palabrasResueltas+1<cantidadPalabras){
        ims.interfaz.enable("aleatorio");   
    }else{
        ims.interfaz.disable("aleatorio");
    $("#aleatorio").unbind( "click" );
    $("#aleatorio").css("opacity",".5");
    }
    mostrarBotonVolver();
}

function versolucion(){
    if ( $("#versolucion").hasClass("notdisabled") ){
        clearTimeout();
        ims.interfaz.disable("versolucion");
        $("#versolucion").unbind();
        mostrarPalabraCorrecta( palabras[ ordenPalabras[palabrasResueltas] ] );
        $(".respuesta").addClass("green");
    }
}

/*
* reemplaza las vocales acentuadas por las no acentuadas, solo para español
*/
function quitarAcentos(letra){
    switch (letra){
        case 'á':
            return 'a';
        case 'é':
            return 'e';
        case 'í':
            return 'i';
        case 'ó':
            return 'o';
        case 'ú':
                return 'u';
        default:
                return letra; 
    }
}

/*
* establece el volumen a 0, oculta el boton mute y muestra el unmute
*/
function silenciar(){
    document.getElementById('audioPalabra').volume = 0;
    $("#mute").css("display","none");
    $("#unmute").css("display","block");
    $("#unmute").addClass("notdisabled");
    ims.interfaz.disableSound();
}

/*
* reestablece el volumen, oculta el boton unmute y muestra el mute
*/
function nosilenciar(){
    document.getElementById('audioPalabra').volume = 1;
    ims.interfaz.enableSound();
    $("#mute").css("display","block");
    $("#unmute").css("display","none");
}

/*
* Agrega el boton volver a la barra de botones, siempre que no exista, y lo bindea a history.back
*/
function mostrarBotonVolver(){
	introduce_retorno();
}

/*
* Remueve los elementos del escenario y vuelve a mostrar los botones de dificultad
*/
function volverInicio(){
    $('#overall').remove();
    emptyStage();
    palabrasResueltas = 0;
    desplegarMenuDificultad();
}

/*
* carga los input de la respuesta con una palabra
*/
function mostrarPalabraCorrecta(palabraCorrecta){
    for(i=0;i<$('.respuesta').length;i++){
        $('.respuesta')[i].value = palabraCorrecta.substring(i,i+1);
    }
}
