if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
	
	window.addEventListener( 'DOMContentLoaded', function(e) {

		ruta = $("#url_editable").text();
		rutaInterfaz = $("#urlInterfaz").text();
		tipo = $(config_xml).find("tipo").text();
		hots_class = "editable-hotedit";
		editable_class = 'editable';

		$("#fondo").css("background-image", "none");
		
		switch(ims.interfaz.getSkin()) {
			case 'tablet':
				$("#fondo").height($("#fondo").height() - 57);
				break;
			case 'musica':
				$("#fondo").height($("#fondo").height() - 47);
				break;
		}

		var titulo = $(config_xml).find('titulo').text(), 
			enunciado = $(config_xml).find('textos > enunciado').text();

		// $("#header").append(titulo);
		$("#header").html(titulo + "<div style=\"clear:both;\"></div>");
		titulo = "<div class='titulo'>" + enunciado + "</div>";
		$("#fondo").append(titulo);
		$("#header").append('<div class="sprite background logo"></div>');
		
		if(logo !== undefined){
			$('.logo').css({
				"background": "url("+logo+".png) no-repeat scroll left top transparent",
				"background-size": "135px 35px"
			});	
		}

		$(".button_left,canvas,.row , .button_right , .item_marcar , .hot_marcar,#presentacion").remove();
		ims.interfaz.addButton("save", "right", "save", $(config_xml).find('textos > guardar').text());
		ims.interfaz.bind("save", 'save()');
		ims.interfaz.enable("save");
		ims.interfaz.addButton("grid", "left", "grid", $(config_xml).find('textos > grid').text());
		ims.interfaz.bind("grid", 'grid()');
		ims.interfaz.enable("grid");

		var borderradius = "";
		switch(ims.interfaz.getSkin()) {
			case 'primaria':
			case 'primaria_3er':
				borderradius = "border-radius:60px;-webkit-border-radius:60px;-ms-border-radius:60px;-moz-border-radius:60px;";
				break;
			default:
				borderradius = "border-radius:0px;-webkit-border-radius:0px;-ms-border-radius:0px;-moz-border-radius:0px;";
		}

		ims.interfaz.setWidthLimit = 1024;
		ims.interfaz.setHeightLimit = 600;
		ims.interfaz.resize();
		var pasador = '<div id="boxPasaPaginas" style="width:800px; height:29px" class="ui-state-default"><div id="pasaPaginas" style=""></div></div>', pasadorTitle = '<div id="tituloNumPagina" style="float:left; margin:5px; background-color:#FFFFFF; padding: 2px 10px 2px 10px; font-size: 13px;" class="ui-corner-all"> Dificultad ' + pantalla + '</div>', pasadorFlechaIzq = '<div id="pasadorIzq" style="float:left; margin:5px; cursor:pointer;" class="ui-state-default ui-corner-all"><span class="ui-icon ui-icon-triangle-1-w"></span></div>', pasadorFlechaDer = '<div id="pasadorDer" style="float:left; margin:5px; cursor:pointer;" class="ui-state-default ui-corner-all"><span class="ui-icon ui-icon-triangle-1-e"></span></div>';
		$("#limit").prepend(pasador);
		$('#pasaPaginas').prepend(pasadorFlechaDer);
		$('#pasaPaginas').prepend(pasadorTitle);
		$('#pasaPaginas').prepend(pasadorFlechaIzq);
		$('#pasadorIzq').bind('click', function() {
			if (pantalla > 1) {
				if (confirm('Si cambia de dificultad no se guardaran los cambios ¿Esta seguro?')) {
					pantalla--;
					loadPantalla(pantalla);
				}
			}
		});
		$('#pasadorDer').bind('click', function() {
			maxPaginas = $(config_xml).find('dificultades > dificultad').length;
			if (pantalla < maxPaginas) {
				if (confirm('Si cambia de dificultad no se guardaran los cambios ¿Esta seguro?')) {
					pantalla++;
					loadPantalla(pantalla);
				}
			}
		});
		$("#boxPasaPaginas").css({
			width : $("#carcasa").outerWidth(true)
		});

		$("#visor_content").html('');
		$("#content").append("<div id='red' style='top:0px;pointer-events:none;" + borderradius + "background-image:url(" + ruta + "css/images/grid.png);background-size:20px 20px;background-position:0px 0px;background-repeat:repeat;width:" + $("#fondo").width() + "px;height:" + $("#fondo").height() + "px;position:absolute;display:none;opacity:0.5;'></div>");
		oldUrlControl = urlControl;
		loadPantalla = function(pantalla) {
			urlControl = oldUrlControl + pantalla + '/';
			if ( typeof (urlJs) != 'undefined') {
				$.ajax({
					url : urlJs,
					data : {},
					success : function() {
						config_xml = $.parseXML(config_xml);
					},
					dataType : 'script'
				});
			}
			$('#tituloNumPagina').html('Dificultad ' + pantalla);

			var overall = "<div id='overall'></div>";
			$("#overall").remove();
			$("#content").prepend(overall);

			$(config_xml).find('[idDif="' + pantalla + '"] > foto').each(function() {
				marcarhot = $(this).text();
				var idw = $(this).attr("idw");
				$("#overall").append("<img id='img' alt='fondo' src='" + $("#url_arc").text() + marcarhot + "'/>");
				$("#img").addClass(editable_class).addClass("imagen").css({
					position : "absolute",
					top : Math.round($(this).attr("y")) + 'px',
					left : Math.round($(this).attr("x")) + 'px',
					width : $(this).attr("width") + 'px',
					height : $(this).attr("height") + 'px',
					"transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-ms-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-moz-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-webkit-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"z-index" : 0
				}).attr("idimg", $(marcarhot).attr("id")).attr("x", (Math.round($(this).attr("x")) - $(this).attr("width") )).attr("y", Math.round($(this).attr("y"))).attr('angle', $(this).attr("rotacion")).attr("rel", idw).addClass("foto-fondo");
				$('#item_' + idw).children().height($(this).attr("height")).width($(this).attr("width"));
			});

			$(config_xml).find('[idDif="' + pantalla + '"] > hots > hot').each(function() {
				marcarhot = '<div posicion="-1" x="' + (Math.round($(this).attr("x")) - $(this).attr("width") ) + '" y="' + ( Math.round($(this).attr("y")) ) + '">' + $(this).find('nombre').text().replace('<p>', '').replace('</p>', '') + '</div>';
				var idw = $(this).attr("idw");
				var id = $(this).attr("id");

				var y = Math.round($(this).attr("y"));
				if (y <= 5)
					y = $("#header").outerHeight() + $("hr").outerHeight();

				var x = Math.round($(this).attr("x"));

				var width = Math.round($(this).attr("width"));
				if (width <= 5)
					width = 40;
				var height = Math.round($(this).attr("height"));
				if (height <= 5)
					height = 40;

				$("#overall").append($(marcarhot).addClass(editable_class).addClass(hots_class).addClass("hot_marcar").addClass('editable-hotspot').css({
					position : "absolute",
					top : y + 'px',
					left : x + 'px',
					width : width + 'px',
					height : height + 'px',
					"transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-ms-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-moz-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"-webkit-transform" : "rotate(" + $(this).attr("rotacion") + "deg)",
					"z-index" : 1
				}).attr('idw', idw).attr('id', 'hot_' + id).attr('rel', idw).attr('angle', $(this).attr("rotacion")));
				if ($(this).find('nFondo').text() != '') {
					$("#hot_" + id).css({
						'background-image' : 'url("' + $("#url_arc").text() + $(this).find('nFondo').text() + '")',
						'background-repeat' : 'no-repeat'
					});
				}
				$("#hot_" + id).click(function() {
					$(this).toggleClass('clicked');
				});
			});

			$("#editable-itemList").remove();
			$("#editable-itemProps").remove();

			$("#limit").unbind('Jhandler');
			resetVarDisplay();
			$("#limit").Jhandler('editable');
			$("#editable-itemList").css({
				left : $("#carcasa").outerWidth(true),
				top : 0,
				height : $("#carcasa").outerHeight(true) + $("#editable-itemProps").outerHeight(),
				width : $(document).width() - $("#carcasa").outerWidth(true),
				'min-width' : '300px'
			});
			$("#editable-itemProps").css({
				top : $("#carcasa").outerHeight(true),
				left : 0,
				width : $("#carcasa").outerWidth(true)
			});
			$("#overall").css({
				height : $("#fondo").outerHeight(),
				width : $("#fondo").outerWidth(),
				"top" : "0px",
				"left" : "0px",
				"z-index" : 0
			});
			if (ims.interfaz.getSkin() == "musica")
				$("#overall").css("margin-top", "0px");

			$("#overall").children().each(function() {
				if (!$(this).hasClass("editable"))
					$(this).remove();
			});

			$("#overall").children().each(function() {
				$(".rotation").remove();
				var css = "width:" + (parseInt($(this).width()) + 40) + "px;" + "height:" + (parseInt($(this).height()) + 40) + "px;" + "top:" + (parseInt($(this).css("top")) - 20) + "px;" + "left:" + (parseInt($(this).css("left")) - 20) + "px;position:absolute;";

				$(this).css("z-index", 1);
				$("#overall").append("<div class='rotation' idw='" + $(this).attr("id") + "' style='" + css + "'></div>");
			});

			//$("#overall").top("-23px");
		}
		removeElementFromArray = function(e, tipo, data) {
			switch(tipo) {
				case 'hotspot':
					$.ajax({
						url : url_prefix + '/eliminarHot.html',
						type : "POST",
						dataType : 'json',
						data : {
							id_recurso : id_recurso,
							id_pantalla : id_pantalla,
							id_hot : data
						},
						success : function(json_data) {
							if (json_data.response == 'eliminado') {
								recursoActualizado();
							}
						}
					});
					break;
			}
			deselectAll();
		}
		crearItemEditable = function(Objeto) {
			var _this = Objeto, obj = Objeto.displayObject, numele = Objeto.id, tipo = "Elemento " + numele, elemento = $('<div id="item_' + numele + '" idw="' + obj.attr('idw') + '" />').addClass("editable-item"), texto = $('<span class="texto" />').html(tipo), aspa = $('<img/>').attr('id', 'borrarElemento_' + obj.attr('idw')).attr("src", ruta + "css/images/borrar.png").css("float", "right").height(20), ojo = $("<div />").css({
				background : "url(" + ruta + "css/images/ojo.png)",
				float : "left",
				"margin-right" : "10px",
				"margin-top" : "0px",
				width : "20px",
				height : "15px"
			});

			$(obj).css("position", "absolute").attr("id", "do_" + _this.id);

			aspa.bind("click", function(e, confirmed) {
				e.preventDefault();
				e.stopPropagation();
				if (!_this.blocked) {
					if (confirm('¿Esta seguro de que desea eliminar este elemento?')) {
						_this.displayObject.remove();
						_this.listItem.remove();
						switch(Objeto.type) {
							case 'hotspot':
								$(document).trigger('removeElementFromArray', ['hotspot', obj.attr('idw')]);
								break;
							case 'fondo':
								break;
						}
					}
				}
			});

			ojo.bind("click", function(e) {
				e.preventDefault();
				e.stopPropagation();
				if (_this.visible) {
					$(this).css("background-position", "bottom");
					obj.css("display", "none");
					_this.visible = false;
				} else {
					$(this).css("background-position", "top");
					obj.css("display", "block");
					_this.visible = true;
				}
				if (this.selected)
					$(document).trigger('deselectAll');
			});

			switch(Objeto.type) {
				case 'hotspot':
					_this.position = 'editable-hotspots';
					if (obj.html() == "") {
						texto.html('Hotspot ' + numele);
					} else {
						texto.html('' + obj.html().substring(0, 25));
					}
					obj.addClass("editable-" + obj.attr("c"));
					elemento.append(texto).append(ojo);
					break;
				case 'fondo':
					_this.position = 'editable-configuracion';
					texto.html('Fondo ' + obj.html());
					if (obj.attr('src') != undefined) {
						var imagen = $('<img />').attr('class', 'item' + ucfirst(Objeto.type)).attr("src", obj.attr('src')).height(40).width(40);
						ojo.css("margin-top", "10px");
						elemento.append(imagen);
					} else {
						elemento.append(texto);
					}

					ojo.css("margin-top", "10px");
					elemento.append(ojo);
					break;
			}
			elemento.bind("click", selectElemento);
			Objeto.listItem = elemento;

			return Objeto.listItem;
		}
		addHotsHeader = function() {
			var header_hots = $("<div />").attr("id", "editable-header-hotspots").addClass("editable-header").addClass('ui-state-default').css('font-weight', 'bold').text("HOTSPOTS");
			$('#editable-itemList').append($("<div />").attr("id", "editable-hotspots").append(header_hots));

			var blockhot = $("<div />").css({
				"background" : "url(" + ruta + "css/images/block.png)",
				float : "left",
				cursor : "pointer"
			}).width(20).height(15);
			header_hots.append(blockhot);
			blockhot.click(blockhotFn);
		};
		addElementosHeader = function() {
		};
		addOthersHeaders = function() {
			var header_elem = $("<div />").attr("id", "editable-header-pantalla").addClass("editable-header").addClass('ui-state-default').css('font-weight', 'bold').text("FONDO");
			$('#editable-itemList').prepend($("<div />").attr("id", "editable-configuracion").append(header_elem));

			var blockelem = $("<div />").css({
				"background" : "url(" + ruta + "css/images/block.png)",
				float : "left",
				cursor : "pointer"
			}).width(20).height(15);
			header_elem.append(blockelem);
			blockelem.click(blockConfigFn);
		};
		blockConfigFn = function() {
			deselectAll();
			candado = this;
			_display = giveMeVarDisplay();
			for (var i = 0; i < _display.length; i++) {
				if (_display[i] != undefined) {
					if (_display[i].getPosition() == 'editable-configuracion') {
						if (!_display[i].blocked) {
							_display[i].blocked = true;
							_display[i].displayObject.unbind("click", setSelection);
							_display[i].listItem.css("opacity", ".5");
							$(candado).css('background-position-y', '-15px');
						} else {
							_display[i].blocked = false;
							_display[i].displayObject.bind("click", setSelection);
							_display[i].listItem.css("opacity", "1");
							$(candado).css('background-position-y', '0px');
						}
					}
				}
			}
		};
		savexml = function() {
			var hots = "\n<hots>\n", fotoFondo = "", xml = "";
			_display = giveMeVarDisplay();

			for (var i = 0; i < _display.length; i++) {
				if (_display[i] != undefined) {
					var __do = _display[i].displayObject;
					__do			= '#'+$(__do).attr('id');
					rotacion = $(__do).attr("angle");
					if (isNaN(rotacion) || (rotacion == 'undefined')) {
						rotacion = 0;
					}
					if (_display[i].type == "hotspot") {
						hots += "\t<hot id='" + i + "' rotation='" + rotacion + "' x='" + $(__do).css("left").replace("px", "") + "' y='" + $(__do).css("top").replace("px", "") + "' width='" + $(__do).width() + "' height='" + $(__do).height() + "' />\n";
					}
					if (_display[i].type == "fondo") {
						fotoFondo = "\t<foto rotacion='" + rotacion + "' x='" + $(__do).css("left").replace("px", "") + "' y='" + $(__do).css("top").replace("px", "") + "' width='" + $(__do).width() + "' height='" + $(__do).height() + "' ><![CDATA[" + $(__do).attr("src") + "]]></foto>\n";
					}
				}
			}
			hots += "</hots>";
			xml = "<?xml version='1.0' encoding='ISO-8859-1'?>\n<data>\n" + fotoFondo + hots + "\n</data>";
			console.log(xml);
			return xml;
		}
		loadPantalla(pantalla);
		$("#limit").css("margin", "0px");
		$("#url_editable,#url_arc,#urlInterfaz").hide();
		$("#right,#left").css("z-index", "1");

		$(document).mouseup(function() {
			rot = false;
			if (draggingObj != "" && angulo != "") {
				draggingObj.attr("angle", angulo);
				angulo = 0;
			}
		});
		$(document).mousemove(function(e) {
			if (rot == true) {
				rotateRow(e.pageX, e.pageY);
				$(".rotate").css({
					"left" : parseInt($(".ord-n").css("left")),
					"top" : -25
				});
			}
		});
		$("#overall").css("z-index", "1");

		$(window).resize(function() {
			$("#editable-itemList").css({
				width : $(window).width() - $("#carcasa").outerWidth(true)
			});
		});
	});
}
function ucfirst(str) {
	str += '';
	var f = str.charAt(0).toUpperCase();
	return f + str.substr(1);
}
