var url_files = "";

if  (typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener ) {
    window.addEventListener('DOMContentLoaded', function(e) {
        init();
        window.addEventListener("scroll", posicionar, false);
        window.addEventListener("resize", posicionar, false);
        window.addEventListener("load", posicionar, false);
        if (isMobile){
            document.addEventListener( "touchmove", preventMove(), false );
        }
    });
}
else {
    $(window).ready(function() {
        init();
    });
    $(window).resize(function() {
        posicionar();
    });
    $(window).load(function() {
        posicionar();
    });
    $(window).scroll(function() {
        posicionar();
    });
}

function preventMove(e) {
    e.preventDefault();
    return false;
}

function posicionar() {

    ims.interfaz.resize();

    //NOTA.- Hay introduccion !???
    if ( $("#intro_text").html() == null ) {
        if ( !$('#visor').hasClass("jspScrollable") ){

            $("#carcasa").children().not(".pop_up").not("#visor").height( $("#carcasa").height() );
            $('#visor').width( $('#content').width() );

            $('#visor').jScrollPane({
                contentWidth: 0,
                horizontalGutter: -30,
                verticalGutter: -30,
                autoReinitialise: true
            });
        }

    }
    else {
        if ( !$('#visor').hasClass("jspScrollable") ){

            $('#visor').width( $('#content').width() );

            $('#visor').jScrollPane({
                contentWidth: 0,
                horizontalGutter: -30,
                verticalGutter: -30,
                autoReinitialise: true
            });
        }
    }
}

function init() {
    document.title = "Santillana";
    // if ($("#url_interfaz").text() != "") {
    //     url_interfaz = $("#url_interfaz").text()
    // }
    $("#url_interfaz,.ui-page,.ui-loader").remove();

    config_xml = $.parseXML(config_xml);
    url_files = $(config_xml).find('path').text();

    ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
    ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
    ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');

    ims.interfaz.init();
    inmediastudio.TRAZA.init();

    if ( isMobile ) {
        $(".notdisabled").bind("touchstart", function() {
            $(this).addClass("active");
        }).bind("touchend", function() {
            $(this).removeClass("active");
        });
    }

    if ( typeof editable == "undefined" && $(config_xml).find("introduccion").find("texto1").text().length != 0 ) {
        inicializar();
    }
    else {
        cargar_actividad();
    }
}

function inicializar() {

    var a = $(config_xml).find("palabras").find("introduccion").text();
    var b = $(config_xml).find("introduccion").find("texto1").text();
    var c = $(config_xml).find("comenzar").text();

    ims.interfaz.setTitle( $(config_xml).find("introduccion").find("titulo").text() );

    $("#visor").append('<div id="intro_title">'+ a +'</div><div id="intro_text">'+ b +'</div>');
    $('#overall').hide();

    ims.interfaz.addButton("Siguiente", "right", "siguiente ", c);
    ims.interfaz.enable("Siguiente");
    ims.interfaz.bind("Siguiente", 'nextPage()');

    posicionar();
}

function cargar_actividad() {

    loadContent();

    $(config_xml).find("pregunta").each(function() {
        var c = '<div id="id_respuesta_block" style="margin-top: 110px;">';

        $(this).find("respuesta").each(function() {
            var a = $(this).attr("id");
            var b = $(this).attr("caracter");

            c += '<div id="'+ a +'" class="respuesta"><div class="redondo"><span>'+ b +'</span></div>'+ $(this).text() +'<div style="clear: both;"></div></div>';
        });

        c += '</div>';

        $("#visor").append(c);

        $(config_xml).find("respuesta").each(function() {
            var a = $(this).attr("id");

            ims.interfaz.bind(a, 'marcar('+ a +')');
        })
    });

    bindClick();

    posicionar();

}

function toggle_enunciado(){
    $('#pregunta').fadeToggle();
}

function loadContent() {

    var a = $(config_xml).find("introduccion").find("titulo").text();
    var b = $(config_xml).find("enunciado").text();

    ims.interfaz.setTitle( a );

    $("#pregunta").append( b );

    if ($(config_xml).find("pregunta").find("foto").length != 0) {
        var c = $(config_xml).find("pregunta").find("foto");
        var d = c.text();
        var e = c.attr("rotation");
        var f = c.attr("width");
        var g = c.attr("height");
        var x = parseInt( c.attr("x") );
        var y = parseInt( c.attr("y") );

        if ( !showHeader ){
            y = y - HEADER_HEIGTH;
        }

        if (d != '') {
            if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
                var h = new Number(RegExp.$1);
                if (h >= 8) {
                    if (url_files != "") {
                        d = url_files + d
                    } else {
                        d = "fotos/" + d
                    }
                    $("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + f + "px; height:" + g + "px; \" src=\"" + d + "\"/></div>");
                    if (x == "" && y == "") {
                        g = parseInt($('#fondo div img').height());
                        f = parseInt($('#fondo div img').width());
                        if (f < $("#fondo").width() || g < $("#fondo").height()) {
                            x = $("#fondo").offset().left + $("#fondo").width() - f;
                            y = $("#fondo").offset().top + $("#fondo").height() - g;
                            $('#fondo div img').css({
                                "margin-left": x + "px ",
                                "margin-top": +y + "px"
                            })
                        }
                    }
                }
            }
            else {
                if ( url_files != "" ) {
                    $('#fondo').css("background-image", "url("+ url_files + d +")");
                }
                else {
                    $('#fondo').css("background-image", "url(fotos/"+ d +")");
                }

                $('#fondo').css("background-repeat", "no-repeat");

                if (e != '') {

                    $('#fondo').css("rotation", e);

                    if (x != '' || y != '') {
                        $('#fondo').css("background-position", x +"px "+ y +"px");
                        if (f != '' && g != '') {
                            $('#fondo').css("background-size", f +"px " + g +"px");
                        }
                        else {
                            if (g != '') {
                                $('#fondo').css("background-size", "auto "+ g +"px");
                            }
                            else {
                                if (f != '') {
                                    $('#fondo').css("background-size", f +"px auto");
                                }
                            }
                        }
                    }
                }
            }

            url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');

            bgImg = $('<img/>');

            bgImg.hide();

            if (x == "" && y == "") {

                bgImg.bind('load', function() {

                    g = parseInt( $(this).height() );
                    f = parseInt( $(this).width() );
                    if ( f < $("#fondo").width() || g < $("#fondo").height() ) {
                        x = $("#fondo").offset().left + $("#fondo").width() - f;
                        y = $("#fondo").offset().top + $("#fondo").height() - g;
                        $('#fondo').css("background-position", x +"px "+ y +"px");
                    }
                    bgImg.remove();
                });
            }

            $('#fondo').append(bgImg);

            bgImg.attr('src', url);
        }

        $('#pregunta').addClass('pregunta_inf');
        $('#pregunta').css('position', 'absolute');
    }

    var i = $(config_xml).find("silenciar").text();
    var j = $(config_xml).find("palabras").find("ayuda").text();
    var k = $(config_xml).find("comprobar").text();
    var l = $(config_xml).find("desarrollo").text();
    var m = $(config_xml).find("imprimir").text();
    var n = $(config_xml).find("versolucion").text();
    var o = $(config_xml).find("reiniciar").text();
    var p = $(config_xml).find("volver").text();


    if ( !isMobile && $(config_xml).find("urlimprimir").text().length > 0 ){
        ims.interfaz.addButton( "imprimir", "left", "imprimir", m );
    }

    if ( !isMobile ){
        ims.interfaz.addButton("silenciar", "left", "silenciar", i);
    }
    if ( $(config_xml).find("sonido").text() != '' ) {
        ims.interfaz.addButton("pausar", "left", "pause", $(config_xml).find("pausa").text());
        ims.interfaz.addButton("player", "left", "play", $(config_xml).find("reproducir").text())
    }
    ims.interfaz.addButton("Anterior", "left", "anterior", p);
    if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {
        ims.interfaz.enable("Anterior");
        ims.interfaz.bind("Anterior", 'prevPage()')
    }

    var orden = $(config_xml).find('orden').text();

    if(orden != ""){
        ims.interfaz.addButton("orden1", "left", "orden", orden);
        ims.interfaz.bind("orden1", "toggle_enunciado()");
        ims.interfaz.enable("orden1");
    }

    ims.interfaz.addButton("ayuda", "right", "ayuda", j);
    ims.interfaz.addButton("comprobar", "right", "comprobar", k);
    ims.interfaz.addButton("versolucion", "right", "versolucion", n);
    ims.interfaz.addButton("clave", "right", "clave", l);
    ims.interfaz.addButton("reiniciar", "right", "reiniciar", o);

    if ( !isMobile ){
        ims.interfaz.enable("silenciar");
        if (ims.interfaz.sound) {
            ims.interfaz.bind("silenciar", "mute()");
        }
        else {
            ims.interfaz.bind("silenciar", "play()");
        }
    }

    if ( $(config_xml).find("ayuda").find("texto1").text().length != 0 ) {
        ims.interfaz.addPopup( "ayuda", "ayuda" );
        var q = $(config_xml).find("ayuda").find("titulo").text();
        var r = $(config_xml).find("ayuda").find("texto1").text();

        $('#pop_ayuda').prepend("<span class='pop_up_title'>"+ q +"</span>");
        $('#content_ayuda').append('<div id="contenidoPOP">'+ r +'</div>');

        ims.interfaz.resize();
    }
    ims.interfaz.bind("reiniciar", 'reload()');
    ims.interfaz.bind("comprobar", 'comprobar()');
    ims.interfaz.bind("imprimir", "imprimir()");
    ims.interfaz.enable("reiniciar");
    ims.interfaz.enable("comprobar");
    ims.interfaz.enable("imprimir");

    $("#overall").remove();
}

// NOTA esto es un poco raro...
function bindClick() {

    var s = 0;

    $("#ayuda").click( function() {

        if (s == 0) {
            $("#content_ayuda").width( $("#content_ayuda").width() );
            $('#content_ayuda').jScrollPane({
                showArrows: false,
                hideFocus: true
            });
            s++;
        }

    });
}

function marcar(a) {

    if ($("#comprobar").hasClass("notdisabled")) {

        $(".selected").removeClass("selected");
        $("#respuesta").removeData("respuesta", a);
        $("#respuesta").data("respuesta", a);
        $("#" + a).addClass("selected");
        ims.interfaz.playSound('beep_select');
    }
}

function imprimir() {
    window.open($(config_xml).find("urlimprimir").text(), "Santillana", 'width=800,height=600');
}

function comprobar() {
    var c = 0;
    if ($(".respuesta").hasClass("selected")) {
        if ($("#comprobar").hasClass("notdisabled")) {
            $(".respuesta").unbind('click');
            var d = "";
            ims.interfaz.disable("comprobar");
            if (inmediastudio.TRAZA.mostrarSolucion) {
                ims.interfaz.bind("versolucion", "solucion()");
                ims.interfaz.enable("versolucion");
            }
            else {
                $("#reiniciar").unbind('click');
                $("#reiniciar").removeClass("notdisabled");
                $("#Anterior").unbind('click');
                $("#Anterior").removeClass("notdisabled");
                $("#comprobar").unbind('click');
            }
            if ( $(config_xml).find("solucion").find("texto1").text().length !== 0 ) {
                if (inmediastudio.TRAZA.mostrarSolucion) {
                    ims.interfaz.enable("clave");
                    ims.interfaz.addPopup("solucion", "clave")
                }
                var e = 0;
                $("#clave").click(function() {
                    if (e == 0) {
                        // $("#content_solucion").width( $("#content_solucion").width() );
                        $('#content_solucion').jScrollPane({
                            showArrows: false,
                            hideFocus: true
                        });
                        e++;
                        ims.interfaz.resize();
                    }
                });

                $(config_xml).find("ES > solucion").each( function() {
                    var a = $(this).find("titulo").text();
                    var b = $(this).find("texto1").text();
                    $('#pop_solucion').prepend("<span class='pop_up_title'>" + a + "</span>");
                    $('#content_solucion').append('<div id="contenidoPOP">' + b + '</div>')
                });
            }
            $(config_xml).find("respuesta").each(function() {
                var a = $(this).attr("id");
                var b = $(this).attr("val");
                if ( b == "0" && a == $(".selected").attr("id") ) {
                    if (inmediastudio.TRAZA.mostrarSolucion) {
                        $(".selected").addClass("green");
                        ims.interfaz.showStars( $("#" + a) );
                    }
                    c++;
                }
                else {
                    if (inmediastudio.TRAZA.mostrarSolucion) {
                        $(".selected").addClass("red");
                    }
                }
                $(config_xml).find("feedback").each(function() {
                    if ( a == $(this).attr("id") ) {
                        if ( $("#" + a).hasClass("red") || $("#" + a).hasClass("green") ) {
                            $("#" + a).addClass("feedbacked");
                            $("#" + a).prepend("<div class='img_feedback sprite background'></div>");
                            ims.interfaz.addPopup(a, a);
                            $('#content_' + a).html('<div id="contenidoPOP">'+ $(this).text() +'</div>');
                            $("#" + a).click( function(){
                                // $("#content_" + a).width( $("#content_" + a).width() );
                                $('#content_' + a).jScrollPane({
                                    contentWidth: 0,
                                    showArrows: false,
                                    hideFocus: true
                                })
                            });
                            ims.interfaz.resize();
                        }
                    }
                });
                $(".img_feedback").each(function() {
                    $(this).css("margin-top", ( $(this).parent().height() - $(this).height() ) / 2)
                })
            });
            if (c == 1) {
                d = "<p> 1 / 1 </p>";
                if (inmediastudio.TRAZA.mostrarSolucion) {
                    ims.interfaz.playSound('rGood');
                }
                ims.interfaz.showResults( d );
            } else {
                d = "<p> 0 / 1 </p>";
                if (inmediastudio.TRAZA.mostrarSolucion) {
                    ims.interfaz.playSound('rBad');
                }
                ims.interfaz.showResults( d );
            }
            if (inmediastudio.TRAZA.guardarRespuesta) {
                inmediastudio.RESULTADOS.guardarPuntuacion( c );
            }
        }
    }
}

function solucion() {

    if ( $("#versolucion").hasClass("notdisabled") ){
        $(".selected").removeClass("selected");
        ims.interfaz.disable("versolucion");
        $(".stars").remove();
        $(config_xml).find("respuesta").each( function(){
            var a = $(this).attr("id");
            var b = $(this).attr("val");
            $(".img_feedback").remove();
            $(".red").removeClass("red");
            $(".feedbacked").unbind('click');
            $(".feedbacked").removeClass('feedbacked');
            $("#center").hide();
            $("#center").empty();
            if ( b == 0 ) {
                $("#" + a).addClass("green");
                ims.interfaz.showStars( $("#" + a) );
            }
        });
        ims.interfaz.playSound('good');
    }
}

function prevPage() {

    $(".tooltip").remove("");
    $("#limit").remove("");

    ims.interfaz.init();

    var a = $("#visor").jScrollPane().data().jsp;
    a.destroy();

    $("#overall").remove();
    inicializar();
}

function nextPage() {

    $(".tooltip").remove("");
    $("#limit").remove("");

    ims.interfaz.init();

    var a = $("#visor").jScrollPane().data().jsp;
    a.destroy();

    $("#overall").remove();

    cargar_actividad();
}

function reload() {

    $(".stars, .tooltip").remove("");
    $("#limit").remove("");

    ims.interfaz.init();

    var a = $("#visor").jScrollPane().data().jsp;
    a.destroy();

    $("#overall").remove();

    cargar_actividad();

    if ( !ims.interfaz.sound ) {
        mute();
    }
}

function mute() {

    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar');
    $('#silenciar').addClass('silenciar_on');

    if (!isMobile) {
        $('#silenciar').tooltip()
    }

    ims.interfaz.bind("silenciar", "play()");

    ims.interfaz.disableSound();
}

function play() {

    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar_on');
    $('#silenciar').addClass('silenciar');
    if (!isMobile) {
        $('#silenciar').tooltip();
    }

    ims.interfaz.bind("silenciar", "mute()");
    ims.interfaz.enableSound();
}