var isAndroid = navigator.userAgent.match(/Android/i) != null;
var isiOS = navigator.userAgent.match(/(iPad)|(iPhone)|(iPod)/i) != null;
var isMobile = (isiOS || isAndroid);
var isIE = $.browser.msie;
var isMoz = $.browser.mozilla;
var isOp = $.browser.opera;
var version = parseInt($.browser.version);
var tooltext = "";
var vars = [], hash;
var click = (('ontouchend' in window)) ? 'touchend' : 'click';

//Tomamos la re para el retorno
var q = document.URL.split('?')[1];
if (q != undefined) {
	q = q.split('&');
	for (var i = 0; i < q.length; i++) {
		hash = q[i].split('=');
		vars.push(hash[1]);
		vars[hash[0]] = hash[1];
	}
	var re = vars['re'];
}

$(window).load(function() {

	//Para los que tienen xml y no json
	if ( typeof (config_json) == "undefined") {
		//Para la galeria
		if ( typeof (config_xml) == "undefined") {
			//Para el glosario
			if ( typeof (cat_xml) == "undefined") {
				config_xml = data_xml;
			}else{
				config_xml = cat_xml;
			}
		}
		if ($(config_xml).find('primaria').text() == '1'){
			$('body').addClass('infantil');
		} else {
			$('body').addClass('secundaria');
		}
		
		//Activamos/desactivamos el botón de imprimir
		//Dani 07/8/14 d.C
		if($(config_xml).find('imprimir_btn').text() == '0'){
			$("#imprimir").removeClass("notdisabled");
			$("#imprimir").unbind('click');
		}
	}else{
		if (config_json.primaria == '1'){
			$('body').addClass('infantil');
		} else {
			$('body').addClass('secundaria');
		}

		//Activamos/desactivamos el botón de imprimir
		//Dani 07/8/14 d.C
		if(config_json.imprimir_btn == '0'){
			$("#imprimir").removeClass("notdisabled");
			$("#imprimir").unbind('click');
		}
	}

});

$(".tool").live("mouseover", function(e) {
	tooltext = $(this).data().title;
						
	if (!($(this).hasClass("notdisabled"))) {
		$(".tooltip").hide();
	}
});

if ( typeof ims == "undefined") {
	var ims = {
		test : function() {
			console.log("ims existe");
		}
	};
};

//Añadimos el botón de retorno al recurso
$(window).load(function(){
	introduce_retorno();
});

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"), results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function introduce_retorno(){
	if (re == 1) {
		// Icono y pasamos parametro a 1
		$('#retorno').remove();

		$('#bottombar').prepend('<div id="retorno"><div id="retorno1" class="button_left sprite background retorno tool notdisabled"></div></div>');

		if (!isMobile){
			$('#left').width($('#left').width()-68);
		}
	}

	$(".retorno").bind(click, function() {
        var urlBack = getParameterByName("url_back");

        if(urlBack !== undefined && urlBack != 'undefined') {
            location.href = urlBack;
        } else {
            history.back();
        }
	});
}

$(window).resize(function() {
	if(typeof(editable)=="undefined") {
		ims.interfaz.resize();
	}
});				

ims.interfaz = {
	sound : true,
	widthLimit : '1024',
	heightLimit : '636',
	iecompatible : true,
	ie8compatible : true,
	Mp3Mp4compatible:true,
	zoomRatio: 1,
	audios : [],
	init : function() {

		if ((!isMobile && isIE) || (!this.Mp3Mp4compatible)){
		    if ((!this.Mp3Mp4compatible) || (!this.iecompatible) || (version <= 7) || ((version==8) && !this.ie8compatible)) {
			    $("body").append('<div class="changeBrowser">Este recurso no es compatible con esta versión de navegador. Le recomendamos usar la ultima versión de Chrome o Safari.<br />Copie el siguiente enlace en su navegador para ver el recurso:<br /><br />' + $(location).attr('href') + '</div>');
			    $(".ui-page").remove();
			    $("*").css({
				    '-webkit-user-select': 'auto',
				    '-khtml-user-select': 'auto',
				    '-moz-user-select': 'auto',
				    '-o-user-select': 'auto',
				    'user-select': 'auto'
			    });
			    $("body").css({
				    'background-color': '#78c3ed'
			    });
			    $(".changeBrowser").css({
				    'background-color': '#ffffff',
				    'width': '800px',
				    'margin': '50px auto 0px auto',
				    'padding': '20px',
				    'overflow': 'auto'
				    
			    });
			    throw "stop execution";
		    }
    	}
		$("body").append('<div id="limit"><div id="carcasa"><div id="fondo"></div><div id="overall"></div><div id="content"><div id="header"><div id="titular" class="bgasignatura_100"><div id="nb"></div></div><div class="sprite background logo"></div><div class="sprite background cerrar"></div></div><div id="visor"><div id="pregunta"></div><div style="clear:both;"></div></div><div id="bottombar"><div id="left"></div><div id="center"></div><div id="right"></div></div></div></div></div>');
		
		if (isMobile) {
		
			$("body").addClass('tabletconv');
			
			if (!isiOS) {
				$("body").addClass('positionbar');
				this.widthLimit = '1091';
				this.heightLimit = '600';

			}
			
		}else{
			$("#header .cerrar").hide();
		}
		
		if (typeof(vars['ud'])!="undefined") {
			$('#nb').text(vars['ud']);
		} else {
			$('#titular').remove();
			$('#header').css('padding-left','30px');
		}

		$("body").addClass('asignatura_'+vars['as']);

		ims.interfaz.resize();
		ims.interfaz.showTooltips();
		
		$("body").css('background-color', '#cccccc');
		$("body").css('overflow', 'auto');
		$("#limit").css('background-color', '#ffffff');
		
		if(typeof(editable)=="undefined") {
			$("#limit").css('margin', 'auto');
		}
		
		$("#limit").css("width", this.widthLimit + "px");
		$("#carcasa").css("width", this.widthLimit + "px");
		$("#content").css("width", this.widthLimit + "px");
		
		$("#limit").css("height", this.heightLimit + "px");
		$("#carcasa").css("height", this.heightLimit + "px");
		$("#content").css("height", this.heightLimit + "px");
		
		if(typeof(editable)=="undefined") {
			$("#limit").css("margin-top", Math.round(($(window).height() - this.heightLimit) / 2));
		}
		
		$('.pop_up').css("margin-left", ($("#limit").width() - $('.pop_up').width()) / 2);
		$("#fondo").width($("#content").width());
		$("#fondo").height($("#content").height());
		$("#overall").width($("#content").width());
		$("#overall").height($("#content").height());
		
		if(typeof(editable)=="undefined") {
			try{
		/*	$(".imsAudio").each(function(){
				
				if($(this)[0].currentTime !=0){
					$(this)[0].pause();
					$(this)[0].currentTime = 0;
				}
			});*/
		}catch(err){
			
		}
		}

	},
	resize : function() {
		var ancho_doc = $(document).width();
		var alto_doc  = $(document).height();
		var ancho_win = $(window).width();
		var alto_win  = $(window).height();

		if(typeof(editable)=="undefined") {
		
	    	if (isMobile) {
				if ((ancho_doc / this.widthLimit) <= (alto_win / this.heightLimit)) {
					ims.interfaz.zoomRatio = (ancho_win-2) / this.widthLimit;
				} else {
					ims.interfaz.zoomRatio = (alto_win-2) / this.heightLimit;
				}
			} else {
				// Controlo si la actividad no cabe en el navegador. Si no cabe habilito el zoom aún siendo un sobremesa.

				if ( (ancho_doc < this.widthLimit) || (alto_doc < this.heightLimit)) {

					if ((ancho_doc / this.widthLimit) <= ((alto_doc-4) / this.heightLimit)) {
						ims.interfaz.zoomRatio = ancho_win / this.widthLimit;
					} else {
						ims.interfaz.zoomRatio = alto_win / this.heightLimit;
					}

				}
			}

			if (ims.interfaz.zoomRatio != 1) {
				$("#limit").css({
					"zoom": ims.interfaz.zoomRatio ,
					"-moz-transform": "scale("+ims.interfaz.zoomRatio+")"
				});
			}
			$("#limit").css("margin-top", Math.round(((alto_win-2) - (this.heightLimit * ims.interfaz.zoomRatio)) / 2));
			$("#limit").css("margin-left", "auto");
						
		}
		//$('.pop_up').css("left", ($('#content').width() - ($('#content').width()/2)) / 2+"px").css("top", ($('#content').height() - ($('#content').height()/2)) / 2);

	},
	getSkin : function() {
		return this.skin
	},
	getSubSkin : function() {
		return this.subSkin
	},
	addButton : function(a, b, c, d) {
		if (d == '' || !(d)) {
			console.log("La variable tooltip no puede estar vacia")
		} else {
			if (b == '' || !(b)) {
				console.log("Especifique la capa")
			} else {
				if ((b != "left") && (b != "right") && (b != "left2") && (b != "right2")) {
					console.log("Capa no válida. Use \"left\" o \"right\"")
				} else {
					var e = "<div id=\"" + a + "\" class=\"button_" + b + " " + "sprite" + " " + "background" + " " + c + " " + "tool\" title=\"" + d + "\"></div>";
					$("#" + b).append(e);
					if (!isMobile) {
						$("#" + a).tooltip()
					}
				}
			}
		}
	},
	enable : function(a) {
		$("#" + a).addClass("notdisabled")
	},
	disable : function(a) {
		$("#" + a).removeClass("notdisabled")
	},
	disableIE: function() {
		this.iecompatible = false;	
	},
	disableIE8: function() {
		this.ie8compatible = false;	
	},
	disableMp3Mp4: function() {
		this.Mp3Mp4compatible = false;	
	},
	bind : function(a, b) {
		$("#" + a).unbind('click');
		if (!(b) || b == '') {
			console.log("El parámetro funcion está vacio o no existe")
		} else {
			$("#" + a).bind("click", function() {
				eval(b)
			})
		}
	},
	setTitle : function(a) {
		if (!(a) || a == '') {
			console.log("El parámetro title está vacio o no existe")
		} else {
			$("#header").prepend(a)
		}
	},
	showTooltips : function() {
	
		$("#left").bind('mousemove', function(e) {
			$(".tooltip").mouseenter(function() {
				$(this).hide();
			});
			$('.tooltip').css({
				left : e.pageX,
				top : e.pageY - 45
			})
		});
		
		$("#right").bind('mousemove', function(e) {

			var flag = false;
			$(".tooltip").each(function(index) {
			
				if ( $(this).text() == tooltext ) {
					if(!flag) {
					
						$('.tooltip').css({
							left : e.pageX - 400,
							top : e.pageY - 80
						});
						
						$('.tooltip').css({
							left : e.pageX - $(this).width(),
							top : e.pageY - 45
						});
						//$(this).show();
						
						flag = true;
					}
				}
				
			}); 

			$(".tooltip").mouseenter(function() {
				$(this).css({
					left : parseInt($(this).css("left")) - 400,
					top : parseInt($(this).css("top")) - 80
				});
			});

		});
		
	},
	addPopup : function(a, b) {
		var c = '<div id="pop_' + a + '" class="pop_up" style="left:'+($('#content').width() - ($('#content').width()/2)) / 2+'px;top:'+($('#content').height() - ($('#content').height()/2)) / 2+'px;"><div id=close_' + a + ' class="pop_up_close sprite background"></div><div id="content_' + a + '" class="pop_up_content"></div></div>';
		$("#content").append(c);
		ims.interfaz.enable(b);
		ims.interfaz.bind(b, "$('#pop_" + a + "').fadeIn('slow');");
		ims.interfaz.bind('close_' + a + '', '$(\'#pop_' + a + '\').fadeOut(\'slow\');');
		$("#pop_" + a).css({"padding":"15px 0px 35px 20px"});
	},
	showResults : function(a) {
		a = a.replace("<p>", "").replace("</p>", "").split("/");
		var _style = '';
		if(a[1].length>2)
			_style = ' style="font-size: 20px;"';
		$("#center").append("<p"+_style+">" + a[0] + "<span class='marc'> / " + a[1] + "</span></p>");
		$("#center").show("");
	},
	setSound : function(a, b) {
			if (isIE && version <=8) {
				this.audios[a] = b;
				return
		} else {
			$("body").append('<audio class="imsAudio" id="' + a + '" name="' + a + '" src="' + b + '" preload="auto"></audio>');
		}
	},
	playSound : function(a) {
		$(".imsAudio").each(function(){
			if($(this)[0].currentTime !=0){
				$(this)[0].pause();
				$(this)[0].currentTime = 0;
			}
		});
		if (this.sound) {
			if (isIE && version <=8) {
					$("body").append('<bgsound src="' + this.audios[a] + '"  AUTOSTART="TRUE"></bgsound>');
					return
			};

			$("#"+a)[0].play()
		}
	},
	pauseSound : function(a) {
		$("#"+a)[0].pause()
	},
	enableSound : function() {
		this.sound = true;
	},
	disableSound : function() {
		this.sound = false;
	},
	setWidthLimit : function(a) {
		this.widthLimit = a;
	},
	setHeightLimit : function(a) {
		this.heightLimit = a;
	},
	centradoVertical : function(capa, clase){
		//Centramos tanto las preguntas como las definiciones en función de las que haya. No hace falta position absolute
		var total_tam_p = 0;
		var p 			= 0;
		//Recorremos cada objeto por si hay alguna que no tenga el mismo tamaño y para calcular su nº
		$('.'+clase).each(function(i) {
			total_tam_p = total_tam_p + $(this).height() + parseInt($(this).css('padding-top')) + parseInt($(this).css('padding-bottom')) + parseInt($(this).css('border-width'))*2;
			p = i+1;
		});
		var margin_p 	= ($('#'+capa).height() - total_tam_p)/(p + 1);
		$('.'+clase).css('margin-top',margin_p);
	},
	showStars : function(obj) {
		var stars = new Array();
		for(var n = 0; n<=5;n++){
			var id = "st_"+obj.attr("id")+"_"+n;
			var myX = parseInt(obj.offset().left-$("#visor").offset().left),
				myY = parseInt(obj.offset().top-$("#visor").offset().top);
			var star = $("<div/>").addClass("stars")
					.attr("id",id)
					.css({
						top:myY,
						left:myX
					});
			stars.push(id);
			$("#visor").append(star);
		}
		var mTop=0,
			mLeft=0,
			index = 0,
			second = false;
		$.each(stars,function(i,id){
			var _this = $("#"+id);

			index++;
			if(index<=3&&second==false){
				var increment = index+"0";
				mTop = parseInt(_this.css("top"))-parseInt(increment);
				_this.css("left",parseInt(_this.css("left"))+obj.width());
				mLeft = parseInt(_this.css("left"))+parseInt(increment);
			}else{

				if(index>3){
					index=0;
					second=true;
				}
				var increment = index+"0";
				mTop = parseInt(_this.css("top"))-parseInt(increment);
				mLeft = parseInt(_this.css("left"))-parseInt(increment);
			}
			_this.animate({
					top:mTop,
					left:mLeft,
					opacity:"0.25"
				}
				,1000
				,function(){
					$(".stars").remove();
				}
			)

		})
	}
}; 