var checked = 0;
var p = 2;
var dragging = false;
var draggingObj = null;
var boxHeight = 67;
var imageBck = "sec_";
var url_files = "";
var iniWidth = 0, iniHeight = 0;

var array_funciones = [];
var aciertos = 0;

if (typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function(e) {
        inicializar();
        window.addEventListener("resize",posicionar,false);
        window.addEventListener("load",posicionar,false);
        if(isMobile){
          window.addEventListener('DOMContentLoaded',preventMove(e),false);

        }
    });
}
else{
   $( window ).ready( function(){
      inicializar();
   }
   );
   $( window ).resize( function(){
      posicionar();
   }
   );
   $( window ).load( function(){
      posicionar();
   }
   );
   $( window ).scroll( function(){
      posicionar();
   }
   );
}

function preventMove(e) {
 e.preventDefault();
 return false;
};

function posicionar(){
 ims.interfaz.resize();
 var _this = $("#image");
 var imageWidth = parseInt(_this.outerWidth());
 var imageHeight = parseInt(_this.outerHeight());
 
 
 $("#visor").height($("#carcasa").height()-60);

}

function inicializar() {
posicionar();
// if ($("#url_interfaz").text() != "") {
// 		url_interfaz = $("#url_interfaz").text();
// 	};
	$("#url_interfaz").remove();
	$(".ui-loader,.ui-page").remove();
	document.title = 'Santillana';

	config_xml = $.parseXML(config_xml);
	url_files = $(config_xml).find("path").text();
	ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
	ims.interfaz.setSound('bad', url_interfaz + 'audio/bad.mp3');

	ims.interfaz.init();
	
	if (isMobile) {
		document.addEventListener("touchmove", function(e) {
			e.preventDefault();
			return false
		}, false);
		if (isiOS) {
			$("body").css("margin-top", "-20px")
		};
		$(".notdisabled").bind("touchstart", function() {
			$(this).addClass("active")
		}).bind("touchend", function() {
			$(this).removeClass("active")
		});
	}
	
		cargar_actividad();
	$("#overall").remove();

}
function cargar_actividad() {

    introduce_retorno();
posicionar();
	$(config_xml).find("pregunta").eq(0).each(function() {
		var visualizar = $(config_xml).find("visualizar").text();
		
		ims.interfaz.addButton("versolucion", "left", "versolucion", $(config_xml).find("versolucion").text());
		ims.interfaz.addButton("comprobar4", "left", "comprobar", $(config_xml).find("comprobar").text());

		ims.interfaz.addButton("aleatorio", "right", "aleatorio", $(config_xml).find("aleatorio").text());
		ims.interfaz.addButton("reiniciar", "right", "reiniciar", $(config_xml).find("reiniciar").text());

  		ims.interfaz.enable("reiniciar");
		ims.interfaz.bind("reiniciar", 'reiniciar()');

		// Enunciados respuestas y caracteres
		var enunciado = $(this).find("enunciado").text();
		
		a_aleatorio();

		ims.interfaz.setTitle($(this).find("titulo").text());
		
		$('#pregunta').append(enunciado.replace(/<br>/g, ""));

/**** INICIO APLICACIÓN *****/		

		// Metemos la capa contenedora
		$('#visor').append('<div id="contenedora"></div>');
		$('#contenedora').append('<div id="contenido"></div>');

		//Recorremos todas las fórmulas y las guardamos en un array
		var i = 0;
		$(config_xml).find("operacion").find("funcion").each(function() {

			array_funciones[i] = $(this).text();
			i++;

		});

		desordenar_array(array_funciones);

		//Capa de la función
		$('#contenido').append('<div id="funcion">'+array_funciones[0]+'</div>');

		//Metemos las cajas de los pasos de la solución
		$('#contenido').append('<div id="paso1"></div>');
		$('#contenido').append('<div id="paso2"></div>');
		$('#contenido').append('<div id="paso3"></div>');
		$('#paso1').append('<div class="texto_paso">'+$(config_xml).find("paso1text").text()+'</div><input id="input1" type="text"  />');
		
		$('#paso1').toggle();

		pulsar_input();

	});
};

function a_comprobar(){
	ims.interfaz.enable("comprobar4");
	ims.interfaz.bind("comprobar4", 'comprobar()');
}

function d_comprobar(){
	ims.interfaz.disable("comprobar4");
	ims.interfaz.bind("comprobar4", 'nohacernada()');
}

function a_solucionar(){
	ims.interfaz.enable("versolucion");
	ims.interfaz.bind("versolucion", 'solucionar()');
}

function d_solucionar(){
	ims.interfaz.disable("versolucion");
	ims.interfaz.bind("versolucion", 'nohacernada()');
}

function a_aleatorio(){
	ims.interfaz.enable("aleatorio");
	ims.interfaz.bind("aleatorio", 'aleatorio()');
}

function d_aleatorio(){
	ims.interfaz.disable("aleatorio");
	ims.interfaz.bind("aleatorio", 'aleatorio()');
}

function nohacernada(){}

function comprobar(){

	var eq_fun = 0;
	//d_comprobar();

	//Contamos los inputs
	var inputs=0;
	$('input').each(function() {
		inputs++;
	});

	//Tomamos la posición en el xml de la función matemática
	var i = 0;
	$(config_xml).find("operacion").find("funcion").each(function() {
		if ($(this).text() == $('#funcion').text()){
			eq_fun = i;
		}
		i++;
	});

	var input_texto = $('input:last').val();
	input_texto = input_texto.replace(/\s+/g, '');
	var input_xml = $(config_xml).find("operacion").eq(eq_fun).find('paso'+inputs).text();
	input_xml = input_xml.replace(/\s+/g, '');

	//Comprobamos el input con el xml sin espacios
	if (input_texto == input_xml){
		$('input:last').addClass('verde');
		$("input").prop('disabled', true);
		$('input:last').prev().css('color','grey');
		d_comprobar();
		aciertos++;
		if (aciertos == 3){
			//Todas correctas
			aplauso_estrella();
		}else{
			ims.interfaz.playSound('good');
			//Como no hemos acabado seguimos mostrando pasos
			var aci = aciertos+1;
			$('#paso'+aci).append('<div class="texto_paso">'+$(config_xml).find("paso"+aci+"text").text()+'</div><input id="input'+aci+'" type="text"  />');
			$('#paso'+aci).slideUp(300).delay(800).fadeIn(400);

			pulsar_input();
		}
	}else{
		$('input:last').addClass('rojo');
		ims.interfaz.playSound('bad');
		$('input:last').bind('click',function() {
			$(this).val('');
			$(this).removeClass('rojo');
			
		});
		a_solucionar();
	}
	d_comprobar();
}

function solucionar(){
	d_solucionar();
	$('input:last').removeClass('rojo');
	$('input:last').addClass('verde');
	$('input:last').val();
	ims.interfaz.playSound('good');

	//Contamos los inputs
	var inputs=0;
	$('input').each(function() {
		inputs++;
	});

	//Tomamos la posición en el xml de la función matemática
	var i = 0;
	$(config_xml).find("operacion").find("funcion").each(function() {
		if ($(this).text() == $('#funcion').text()){
			eq_fun = i;
		}
		i++;
	});

	$('input:last').val($(config_xml).find("operacion").eq(eq_fun).find("paso"+inputs).text());

	comprobar();
}

function aplauso_estrella(){
	//Mostramos estrellitas
	$('.stars').remove();
	$("input").each(function() {
		var id = $(this).attr("id");
		var _this = $(this);
		ims.interfaz.showStars($("#" + id));
		id= id+1;
	});
	ims.interfaz.playSound('good');
}

function aleatorio(){
	array_funciones.shift();
	$('#funcion').text(array_funciones[0]);
	if (array_funciones.length == 1){
		d_aleatorio();
	}

	limpiar();
}

function reiniciar(){
	limpiar();
}

function desordenar_array(bar){
   var m= bar.length-1;
   for (var i=m;i>1;i--){ 
      alea=Math.floor(i*Math.random()); 
      temp=bar[i]; 
       bar[i]=bar[alea]; 
       bar[alea]=temp; 
    }
   return(bar);
}

function pulsar_input(){
	d_solucionar();

	//Desactivamos/activamos el comprobar si se encuentra el input activo vacío
	$('input:last').bind('keyup',function() {
		var caracter_pulsado = $(this).val().substring($(this).val().length,$(this).val().length-1);
		if (caracter_pulsado== 'x' || caracter_pulsado == 'X' || caracter_pulsado == '*' || caracter_pulsado == '•'){
			$(this).val(($(this).val().split('').reverse().join('')).substring(1, $(this).val().length).split('').reverse().join(''));
			$(this).val($(this).val()+'·');
		}
		if (caracter_pulsado== '/' || caracter_pulsado == '÷'){
			$(this).val(($(this).val().split('').reverse().join('')).substring(1, $(this).val().length).split('').reverse().join(''));
			$(this).val($(this).val()+':');
		}
		if (caracter_pulsado== '–'){
			$(this).val(($(this).val().split('').reverse().join('')).substring(1, $(this).val().length).split('').reverse().join(''));
			$(this).val($(this).val()+'-');
		}
		if ($(this).val()== ''){
			d_comprobar();
		}else{
			a_comprobar();
		}
	});

	//Reemplazamos algunos símbolos para que no haya problemas en la comprobación
	$('input:last').bind('keydown',function(event) {
		if ($(this).val()== 'x' || $(this).val() == 'X'){
			$('input_last').val(($('input_last').val.split('').reverse().join('')).substring(1, $('input_last').val.length).split('').reverse().join(''));
		}
	});
}

function limpiar(){
	//Reiniciamos el contador de aciertos
	aciertos = 0;

	//Reiniciamos el estilo de lo que ya hay
	$('.texto_paso').css('color','#000');
	$('#paso2').children().remove();
	$('#paso3').children().remove();
	$('#paso2').css('display','none');
	$('#paso3').css('display','none');

	$('input').val('');
	$('input').removeClass('verde');

	//Activamos de nuevo los inputs
	$("input").prop('disabled', false);

	d_solucionar();
	d_comprobar();
}