var _events = {
	click: isMobile ? "touchstart" : "click"
}
var mySVG;

ims.actividad = {
	hots: [],
	icons: [],
	relations: [],
	zIndex: 1,
	init: function(){
		ims.interfaz.introduce();
	},
	setInterface: function(){
		ims.interfaz.emptyStage();
		
		if ( ( /MSIE (\d+\.\d+);/.test( navigator.userAgent ) && Number( RegExp.$1 ) >= 8 ) ) {
			ims.actividad.setMinZoom(100);
			ims.actividad.setMaxZoom(100);
			  
			$( ".poi" ).unbind( "click" );
			this.disableZoomIn();
			this.disableZoomOut();      
			  
			document.attachEvent( "click", function() {
				ims.actividad.toggleZoom();
			});
		}

		var _background = config_json.elementos.object.configuration;
		ims.interfaz.setBackgroundImage(_background.url_archivo, _background.pos_x, _background.pos_y, _background.width, _background.height);
		
		this.setHotspots();
		this.setIcons();
		
		this.setRelationship();
	},
	setIcons: function(){
		var _self = this;
		var _icons = config_json.elementos.object.icons;
		for(var i in _icons){
			var _icon = new poiManager(_icons[i].id, 'icon_'+i, _icons[i].x, _icons[i].y, _icons[i].width, _icons[i].height, 0, _icons[i].url_archivo, _self.zIndex++, 'icon', false, _icons[i].visible);
			_icon.insert("visor", true);
			_self.icons[_icon.getId()] = _icon;

			var _hot = _self.hots[_icons[i].id_hotspot];
			_icon.setRelationship(_hot);
			
			if(_hot.getFixed() && _icon.hasRelationship()){
				
			}
		}
		
		$("._poi_grl").click(function(){
			var _icon = _self.icons[$(this).attr("id").replace("poi_","")];
			if($(_icon.getRelatedObject().getPublicId()).parent().is(":hidden")){
				$(".zonaexplicacion").hide();
				$(_icon.getRelatedObject().getPublicId()).parent().show();						
			}
		});
	},
	setHotspots: function(){
		var _hotspots = config_json.elementos.object.hotspots;
		for(var i in _hotspots){
			var _hot = new layerManager(_hotspots[i].id_hotspot, _hotspots[i].title, _hotspots[i].x, _hotspots[i].y, _hotspots[i].width, _hotspots[i].height, 0, _hotspots[i].texto, this.zIndex++, _hotspots[i].behavior === "fixed", "hotspot");
			_hot.insert("visor");
			
			this.hots[_hot.getId()] = _hot;
			
			switch(_hotspots[i].behavior){
				case "fixed":
					var _span = $('<span id="close-fixed-hot" />').html('Cerrar').css({position: "absolute", bottom: 0, right: 0}).click(function(){
						var _element = $(this).parent(".ui-wrapper").find('._layer_');
						_element.toggle();
						$(this).html(_element.is(':hidden') ? "Abrir" : "Cerrar");
					});
					$(_hot.getPublicId()).parent().append(_span);
					$(_hot.getPublicId()).parent(".ui-wrapper").addClass("zonaexplicacion");

					if($(".zonaexplicacion").length > 1){
						$(_hot.getPublicId()).parent(".zonaexplicacion").hide();
					}
					break;
				case "collapsed":
					$(_hot.getPublicId()).find(".content-body").hide();
					
					$(_hot.getPublicId()).find(".title").css({cursor: 'pointer'}).click(function(){
						$(this).parent().find(".content-body").toggle();
					});
					break;
				case "hidden":
					//check relationship
					var _relationship = config_json.elementos.relationship[_hot.getId()];
					
					if(_hotspots[i].behavior == "hidden"){
						$(_hot.getPublicId()).hide();						
					}
					
					$("#poi_"+_relationship.id_icon).click(function(){
						$(_hot.getPublicId()).toggle();
					});
					break;
			}
		}
	},
	setRelationship: function(){
		if(config_json.elementos.relationship){
			for(var i in config_json.elementos.relationship){
				if(config_json.elementos.relationship[i].line){
					this.drawRelationship(config_json.elementos.relationship[i].line);	
				}
			}
		}
	},
	drawRelationship: function(line){
console.log('drawRelationship', arguments);

			node1 = this.icons[line.id_icon];
			node2 = this.hots[line.id_hotspot];
console.log('nodes', node1, node2);
			if(!node1 || !node2) return false;

			if(mySVG === undefined){
				mySVG = $('#visor').connect();
//				$('canvas').css({width: $("#visor").width(), height: $("#visor").height(), top: $("#visor").offset().top, left: $("#visor").offset().left});
			}
			mySVG.drawLine({
				left_node: node2.getPublicId(),
				right_node: node1.getPublicId(),
				horizantal_gap: 10,
				style: "solid",
				status: "accepted",
				error: true,
				width: line.height
			});	
	}
}

$(document).ready(function(){
	ims.interfaz.showHeader = false;
	ims.interfaz.init();
});