// var isiPad = navigator.userAgent.match(/iPad/i) != null;
// var isAndroid = navigator.userAgent.match(/Android/i) != null;

var tipoActividad = "Texto Libre";
// var url_interfaz = "";
var url_files = "";

var sonido;
var estado = 'parado';

var url, 
	bgImg, 
	height, 
	width, 
	x, 
	y, 
	foto_object, 
	foto, 
	rotation;

if ( typeof document !== 'undefined' && document.readyState !== 'complete' && typeof window.addEventListener !== "undefined" ){
	
    window.addEventListener('DOMContentLoaded', function(e) {
       	init();
		window.addEventListener("scroll", posicionar, false);
		window.addEventListener("resize", posicionar, false);
		window.addEventListener("load", posicionar, false);
    });
}
else{
	$(window).ready(function(){
		 init();
	});
	$(window).resize(function(){
		posicionar();
	});
	$(window).load(function(){
		posicionar();
	});
	$(window).scroll(function(){
		posicionar();
	});
}

function posicionar(){
	if ( $("#intro_text").html() == null ){
		$("#carcasa").children().not(".pop_up").not("#visor").height( $("#carcasa").height() );
		if ( !$('#visor').hasClass( "jspScrollable" ) ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}
	}
	else {
		// $('#visor').width( $('#content').width() );
		// $('#visor').height( $('#visor').height() );
		if ( !$('#visor').hasClass("jspScrollable") ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}
		$('#visor').width($('#content').width());
	}
	ims.interfaz.resize();
	retornar();
}

function init(){

	document.title = 'Santillana';
	
	$( "#url_interfaz, .ui-loader, .ui-page" ).remove();

	// if ( $("#url_interfaz").text() != "" ) {
	// 	url_interfaz = $("#url_interfaz").text();
	// }
	$("#url_interfaz").remove();
	
	config_xml = $.parseXML(config_xml);

	url_files = $(config_xml).find("path").text();
	
	ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
	ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
	ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
	ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
	
	if ( $(config_xml).find("sonido").text() != '' ){
		ims.interfaz.setSound('sonido', url_files + $(config_xml).find("sonido").text() );
	}

	ims.interfaz.init();
	inmediastudio.TRAZA.init();

	var overall = "<div id='overall'>"+ $("#overall").html() +"</div>";
	$("#overall").remove();
	$("#content").prepend( overall );

	$("#right, #left").css("z-index", "1");

	$("#overall").css("z-index", "0")
		.css("top", 0)
		.css("margin-top", 0)
		.css("position", "absolute");
	
	if ( typeof editable != "undefined" || $(config_xml).find("introduccion").find("texto1").text().length == 0 ){
		cargar_actividad();
	}
	else {
		inicializar();
	}
	posicionar();
}

function inicializar(){

	var IntTit = $(config_xml).find("palabras").find("introduccion").text();
	var IntTex = $(config_xml).find("introduccion").find("texto1").text();

	$("#visor").append( '<div id="intro_title">'+ IntTit +'</div><div id="intro_text">'+ IntTex +'</div>');

	ims.interfaz.setTitle( $(config_xml).find("introduccion").find("titulo").text() );
	
	var comenzar = $(config_xml).find("comenzar").text();

	$('#overall').hide();
	
	ims.interfaz.addButton( "Siguiente", "right", "siguiente ", comenzar );
	ims.interfaz.enable("Siguiente");
	ims.interfaz.bind("Siguiente", 'nextPage()');
}

function crearInputs( i ) {
	//NOTA opciones no se usa...
	// var opciones = $(config_xml).find("combos").find("combo[id=\'"+ i +"\']").text().split("#");
	//NOTA crearInputs
	var input = "<input type='text' class='input'>";
	return input;
}

function Remplazo( texto, i ) {

	var RegExPattern = /\[(.*?)\]/;

	texto.replace(RegExPattern, function(data) {
		if (data != "") {
			var input = crearInputs(i);
			texto = texto.replace(data, input);
			i++;
			texto = Remplazo(texto, i);
		}
	});
	return texto;
}

function palabrasOk( texto, i, palabras_ok ) {
	
	var RegExPattern = /\[(.*?)\]/;

	texto.replace( RegExPattern, function(data) {
		if (data != "") {
			var input = crearInputs(i);
			texto = texto.replace(data, input);
			palabras_ok[i] = data.replace("[", "").replace(/#/g, "").replace("]", "");
			i++;
			texto = palabrasOk(texto, i, palabras_ok);
		}
	});
	return palabras_ok;
}

function cargar_actividad() {

	$(config_xml).find("pregunta").each(function() {

		// Enunciados respuestas y caracteres
		var enunciado = $(this).find("enunciado").text();
		$('#pregunta').append( enunciado.replace(/<br>/g, "") );
		
		var texto = $(this).find("texto").text();
		var palabras_ok = [];
		palabras_ok = palabrasOk(texto, 0, palabras_ok);

		var j = palabras_ok.length;
		$(this).find("palabrafalsa").each(function() {
			palabras_ok[j] = $(this).text();
			j++;
		});

		texto = Remplazo( texto, 0 );
		$("#visor").append( texto );

		var min = 0;
		var max = j - 1;
		
		var A = [];
		while (max >= min){
			A.push(max--);
		}

		A.sort(function() {
			return .5 - Math.random();
		});

		//NOTA fill = "<div id='palabras' style='display:none;'>";
		var fill = "<div id='palabras' style='display:none;'>";
		for (var i = 0; i <= j - 1; i++) {
			fill += "<div class='word' style='display:none;'>" + palabras_ok[ A[i] ] + "</div>";
		}
		fill += "</div>";
		
		$("#visor").append(fill);
		
		$("input").addClass("on");

		if ( $(this).find("palabrasvisibles").text() == "si" ) {
			$("#palabras, .word").css("display", "block");
		}

		for ( var i = 0; i <= j - 1; i++ ) {
			$("body").append("<span class='ghost'>" + palabras_ok[ A[i] ] + "<br/></span>");
		}

		var maxWidth = 0;
		$(".ghost").each( function(c) {
			if ( $(this).outerWidth() > maxWidth ){
				maxWidth = parseInt( $(this).outerWidth() );
			}
		});
		
		$("input").width( parseInt( maxWidth * 1.15 + 15 ) );
		$(".ghost").remove();

		// Imagen de fondo
		if ( $(config_xml).find("pregunta").find("foto").length != 0 ) {

			foto_object = $(config_xml).find("pregunta").find("foto");
			foto = foto_object.text();
			rotation = foto_object.attr("rotation");
			width = parseInt(foto_object.attr("width"));
			height = parseInt(foto_object.attr("height"));
			x = parseInt(foto_object.attr("x"));
			y = parseInt(foto_object.attr("y"));

			if ( !showHeader ){
				y = y - HEADER_HEIGHT;
			}

			if ( foto != '' ) {

				if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
					
					var ieversion = new Number(RegExp.$1);
					if (ieversion >= 8) {
						// if (url_files != "") {
						foto = url_files + foto;
						// } else {
						// 	foto = "fotos/" + foto;
						// };
						$("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");

						if (x == "" && y == "") {

							height = parseInt( $('#fondo div img').height() );
							width = parseInt( $('#fondo div img').width() );

							if (width < $("#fondo").width() || height < $("#fondo").height()) {
								
								x = $("#fondo").offset().left + $("#fondo").width() - width;
								y = $("#fondo").offset().top + $("#fondo").height() - height;
								
								$('#fondo div img').css({
									"margin-left" : x + "px ",
									"margin-top" : +y + "px"
								});
							}
						}
					}
				}
				else {
					// if (url_files != "") {
						$('#fondo').css("background-image", "url(" + url_files + foto + ")");
					// }
					// else {
					// 	$('#fondo').css("background-image", "url(fotos/" + foto + ")");
					// }
					$('#fondo').css("background-repeat", "no-repeat");
					
					if (rotation != '') {
						
						$('#fondo').css("rotation", rotation);
						
						if (x != '' || y != '') {
						
							$('#fondo').css("background-position", x + "px " + y + "px");

							if (width != '' && height != '') {
								$('#fondo').css("background-size", width + "px " + height + "px");
							}
							else {
								if (height != '') {
									$('#fondo').css("background-size", "auto " + height + "px");
								}
								else {
									if (width != '') {
										$('#fondo').css("background-size", width + "px auto");
									}
								}
							}
						}
					}
				}

				url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
				bgImg = $('<img />');
				bgImg.hide();
				
				if (x == "" && y == "") {

					bgImg.bind('load', function() {
				
						height = parseInt($(this).height());
						width = parseInt($(this).width());

						if (width < $("#fondo").width() || height < $("#fondo").height()) {
				
							x = $("#fondo").offset().left + $("#fondo").width() - width;
							y = $("#fondo").offset().top + $("#fondo").height() - height;
				
							$('#fondo').css("background-position", x + "px " + y + "px");
						}

						bgImg.remove();
					});
				}
				
				$('#fondo').append( bgImg );
				bgImg.attr('src', url);
			}
		}

		// Titulo
		ims.interfaz.setTitle( $(config_xml).find("introduccion").find("titulo").text() );
		// Elementos de la izquierda
		var silenciar = $(config_xml).find("silenciar").text();
		var ayuda = $(config_xml).find("palabras").find("ayuda").text();
		var comprobar = $(config_xml).find("comprobar").text();
		var clave = $(config_xml).find("desarrollo").text();
		var imprimir = $(config_xml).find("imprimir").text();
		var versolucion = $(config_xml).find("versolucion").text();
		var reiniciar = $(config_xml).find("reiniciar").text();
		var volver = $(config_xml).find("volver").text();

		if ( !isMobile ){
			ims.interfaz.addButton("silenciar1", "left", "silenciar", silenciar);
		}

		if ($(config_xml).find("sonido").text() != ''){
			ims.interfaz.addButton( "pausar", "left", "pause", $(config_xml).find("pausa").text());
		  	ims.interfaz.addButton( "player", "left", "play", $(config_xml).find("reproducir").text());
		}
		
		if (!isMobile && $(config_xml).find("urlimprimir").text().length>0){
			ims.interfaz.addButton("imprimir1", "left", "imprimir", imprimir);
		}

		ims.interfaz.addButton("Anterior", "left", "anterior", volver);
		ims.interfaz.addButton("ayuda0", "right", "ayuda", ayuda);
		ims.interfaz.addButton("comprobar1", "right", "comprobar", comprobar);
		ims.interfaz.addButton("versolucion2", "right", "versolucion", versolucion);
		ims.interfaz.addButton("clave1", "right", "clave", clave);
		ims.interfaz.addButton("reiniciar4","right", "reiniciar", reiniciar);

		if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {
			ims.interfaz.enable("Anterior");
			ims.interfaz.bind("Anterior", 'prevPage()');
		}

		ims.interfaz.enable("silenciar1");
		ims.interfaz.bind("silenciar1", "mute()");
		
		if ($(config_xml).find("ayuda").find("texto1").text().length != 0) {
		
			ims.interfaz.addPopup("ayuda", "ayuda0");
		
			var ayudaTit = $(config_xml).find("ayuda").find("titulo").text();
			var ayudaTex = $(config_xml).find("ayuda").find("texto1").text();
		
			$('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
			$('#content_ayuda').append('<div id="contenidoPOP">'+ayudaTex+'</div>');
		}

		ims.interfaz.bind("reiniciar4", 'reload()');
		ims.interfaz.bind("comprobar1", 'comprobar()');
		ims.interfaz.bind("imprimir1", "imprimir()");
		ims.interfaz.enable("reiniciar4");
		ims.interfaz.enable("comprobar1");
		ims.interfaz.enable("imprimir1");
	});

	var nWords = ($(".word").length * $(".word").width()) / 635, mlWords = ($("#content").outerWidth() - $("#palabras").width()), hWords = ($(".word").outerHeight() + 22) * nWords;

	$("#palabras").css({
		"height" : hWords,
		"width" : "635px",
		"margin-left" : "60px"
	});

	$('#pausar').css('display','none');
	
	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.enable("player");
		ims.interfaz.bind("player", 'a_player()');
		ims.interfaz.enable("pausar");
		ims.interfaz.bind("pausar", 'a_pausar()');
		sonido = $("#sonido").get(0);
	}

	var Wtop = 0, 
		cont = 0;

	$(".word").each(function() {
		if ( $(this).position().top != Wtop ) {
			cont++;
			Wtop = $(this).position().top;
		}
	});

	$("#palabras").height( $(".word").height()*cont + 60 );

	var tA = 0;
	
	$("#ayuda0").click( function(){

		if (tA == 0) {
			//NOTA toma ya...
			//$("#content_ayuda").width( $("#content_ayuda").width() );
			$('#content_ayuda').jScrollPane({
				showArrows : false,
				hideFocus : true
			});

			tA++;
		}
	});
}

function imprimir() {
	window.open( $(config_xml).find("urlimprimir").text());
}

function comprobar() {

	if ($("#comprobar1").hasClass("notdisabled")) {

		if(estado!='parado'){
			$("#pausar").trigger( click );
		}
		
		var texto = $(config_xml).find("pregunta").find("texto").text();

		var aciertos = "";
		var correcta = 0;
		var palabras_ok = [];
		var i = 0;
		var total = $("input").length;

		if ( $(config_xml).find("ES > solucion").find("texto1").text().length != 0 ) {
			if ( inmediastudio.TRAZA.mostrarSolucion ){
				ims.interfaz.enable("clave1");
				ims.interfaz.addPopup("solucion", "clave1");
			}
			var tS = 0;
			
			$("#clave1").click( function(){
				// $("#content_solucion").width( $("#content_solucion").width() );

				if (tS == 0) {
					$('#content_solucion').jScrollPane({
						showArrows : false,
						hideFocus : true
					});
					tS++;
				}
				
				ims.interfaz.resize();
			});
			
			$(config_xml).find("ES > solucion").each(function() {
			
				var solucionTit = $(this).find("titulo").text();
				var solucionTex = $(this).find("texto1").text();
			
				$('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
				$('#content_solucion').append('<div id="contenidoPOP">'+solucionTex+'</div>');
			});
		}

		palabras_ok = palabrasOk( texto, 0, palabras_ok );

		if ( inmediastudio.TRAZA.mostrarSolucion ) {
			
			ims.interfaz.bind("versolucion2", "solucion()");
			ims.interfaz.enable("versolucion2");
		}
		else {
    		
    		$("#reiniciar4").unbind('click');
    		$("#reiniciar4").removeClass("notdisabled");
    		$("#Anterior").unbind('click');
    		$("#Anterior").removeClass("notdisabled");
		}
		
		ims.interfaz.disable("comprobar1");
		$("#comprobar1").unbind('click');

		$("input").each(function(c) {

			$(this).attr("readonly", "readonly");
			$(this).attr("id", c);

			if ( $(this).val() == palabras_ok[i] ) {

				if ( inmediastudio.TRAZA.mostrarSolucion ) {
					//NOTA interfaz obsoleta
					// if (ims.interfaz.skin == "primaria_3er") {
					// 	var color = "#39B54A";
					// 	$(this).css("border-bottom", "2px dotted " + color);
					// }
					// else {
					var color = "#BDEA01";
					$(this).css({
						//"width"  : $(this).outerWidth(),
						//"border" : "none",
						"height" : $(this).outerHeight()
					});
					//};

					$(this).css({
						"background-color" : color
					});

					$(this).addClass("green");

					ims.interfaz.showStars($("#" + c));
				}
				correcta++;
			}
			else {

				if ( inmediastudio.TRAZA.mostrarSolucion ){
					var color = "red";
					// if (ims.interfaz.skin == "musica") {
					// 	$(this).css("margin", "2px 0px");
					// }
					// if (ims.interfaz.skin == "primaria_3er") {
					// 	$(this).css("border-bottom", "2px dotted " + color);
					// }
					//else {
					// $(this).css({
					// 	//"width" : $(this).outerWidth(),
					// 	//"border" : "none"
					// });
					//}
					$(this).css({
						"background-color" : color
					});
					$(this).addClass("red");
				}
			}
			// if (ims.interfaz.skin == "tablet") {
			// 	$(this).css("margin", "1.5px 0px");
			// }
			$(this).css("margin-right", "0px");
			i++;
		});

		aciertos = "<p> "+ correcta +" / "+ total +" </p>";

		if (correcta == total) {
			
			if ( inmediastudio.TRAZA.mostrarSolucion ){
				ims.interfaz.playSound('rGood');
			}

			ims.interfaz.showResults( aciertos );
			
			if ( inmediastudio.TRAZA.guardarRespuesta ) { 
    			inmediastudio.RESULTADOS.guardarPuntuacion( correcta/total );
			}
			return false;
		}
		else {
			if ( inmediastudio.TRAZA.mostrarSolucion ){
				ims.interfaz.playSound('rBad');
			}	

			ims.interfaz.showResults(aciertos);
			if ( inmediastudio.TRAZA.guardarRespuesta ) { 
    			inmediastudio.RESULTADOS.guardarPuntuacion( correcta/total );
			}
			return false;
		}
		//NOTA... return previo
		ims.interfaz.disable("Anterior");
	}
}

function solucion(){

	if ( $("#versolucion2").hasClass("notdisabled") ){
		
		if(estado!='parado'){
			$("#pausar").trigger(click);
		}

		var texto = $(config_xml).find("pregunta").find("texto").text();
		var palabras_ok = [];
		var i = 0;

		$(".stars").remove();

		$("#center").hide();

		palabras_ok = palabrasOk(texto, 0, palabras_ok);

		$("input").each( function(c) {

			var color = "#";
			$(this).css("background-color", "#BDEA01");
			$(this).val(palabras_ok[i]);
			$(this).addClass("green");

			ims.interfaz.showStars( $("#" + c) );
			// if (ims.interfaz.skin == "tablet") {
			// 	$(this).css("margin", "1.5px 0px");
			// }
			i++;
		});

		ims.interfaz.playSound('good');
		ims.interfaz.disable("versolucion2");
		// ims.interfaz.disable("Anterior");
	}
}

function prevPage() {
	
	if ( $('.pause').length == 1 ){
		a_pausar();
		sonido.currentTime = 0;
	}
	$(".tooltip").remove("");
	$("#limit").remove("");
	
	ims.interfaz.init();
	
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	
	$("#overall").remove();
	
	inicializar();	
	posicionar();
}

function nextPage() {

	$(".tooltip").remove("");
	$("#limit").remove("");

	ims.interfaz.init();

	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();

	$("#overall").remove();

	cargar_actividad();
	posicionar();
}

function retornar(){
	introduce_retorno();
}

function reload() {
	
	$(".tooltip, .stars").remove("");
	$("#limit").remove("");
	
	ims.interfaz.init();
	
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	
	$("#overall").remove();
	
	cargar_actividad();
	posicionar();

    if(ims.interfaz.sound){
        play();
    }else{
        mute();
    }
}

function mute() {

	$('.tooltip').hide();
	
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar');
	$('#silenciar1').addClass('silenciar_on');
	$('#silenciar1').tooltip();
	
	if ($(config_xml).find("sonido").text() != ''){
		$("#sonido").get(0).volume = 0;
	}
	
	ims.interfaz.bind("silenciar1", "play()");
	ims.interfaz.disableSound();
}

function play() {

	$('.tooltip').hide();
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar_on');
	$('#silenciar1').addClass('silenciar');
	$('#silenciar1').tooltip();
	
	if ($(config_xml).find("sonido").text() != ''){
		$("#sonido").get(0).volume = 0.5;
	}
	
	ims.interfaz.bind("silenciar1", "mute()");
	ims.interfaz.enableSound();
}

function a_player(){
	
	estado = 'sonando';
	
	$('#player').css('display','none');
	$('#pausar').css('display','block');
	
	sonido.play();
	
	setTimeout(function() {
		if ( sonido.currentTime == sonido.duration && $('#pausar').css('display') == 'block' ){
			$('#pausar').css('display','none');
			$('#player').css('display','block');
			estado = 'parado';
		}
	}, sonido.duration*1100);
}

function a_pausar(){

	sonido.pause();
	estado = 'parado';
	
	$('#pausar').toggle();
	$('#player').toggle();
}