var tamanoLetra = 30;
var tamanoRow = 30;
var matrizMarginTop = 35;

var correct = 0;
var total = 0;

var url_gen = "";
var url_files = "";

var accionSeleccion = false;
var selecciones = [];
var actividadCorregida = false;
var palabrasSeleccionadas = [];

$(window).resize(function () {
    scroll();
});

function scroll() {
    ims.interfaz.resize();
    if ($("#intro_text").html() === null) {
        $("#carcasa").children().not(".pop_up").not("#visor").height($("#carcasa").height());
        $('#visor').jScrollPane({
            contentWidth: 0,
            horizontalGutter: -30,
            verticalGutter: -30
        });
        $('#visor').width($('#visor').width()).children().width($('#visor').width());
    } else {
        $('#visor').width($('#content').width());
        $("#carcasa").height($("#content").height()).children().height($("#carcasa").height());
        $('#visor').jScrollPane({
            contentWidth: 0,
            horizontalGutter: -30,
            verticalGutter: -30
        });
        $('#visor').width($('#visor').width()).children().not("#header").width($('#visor').width());
    }
}

$(document).ready( function() {
    init();
});

function init(){
    document.title = 'Santillana';
    // if ($("#url_interfaz").text() !== "") {
    //     url_interfaz = $("#url_interfaz").text();
    // }
    $("#url_interfaz").remove();

    config_xml = $.parseXML(config_xml);
    url_files=$(config_xml).find('path').text();
    
    ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
    ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
    ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
    ims.interfaz.init();
    inmediastudio.TRAZA.init();
    if (typeof (editable) != "undefined") {
        cargar_actividad();
    } else {
        inicializar();
    } 
  if (isMobile) {
        $(".notdisabled").bind("touchstart", function () {
            $(this).addClass("active");
        }).bind("touchend", function () {
            $(this).removeClass("active");
        });
    }

    introduce_retorno();
}

function inicializar() {
    if ($(config_xml).find("introduccion").find("texto1").text().length !== 0) {
        var overall = "<div id='overall'>" + $("#overall").html() + "</div>";
        $("#overall").remove();
        $("#content").prepend(overall);
        $("#right,#left").css("z-index", "2");
        $("#overall").css({
            "z-index": "0",
            // width: $("#fondo").width(),
            width: $("#visor").width(),
            height: $("#visor").height()
        });
        var titulo = $(config_xml).find("introduccion").find("titulo").text();
        $("#header").prepend(titulo);
        var IntTit = $(config_xml).find("palabras").find("introduccion").text();
        var IntTex = $(config_xml).find("introduccion").find("texto1").text();
        $("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');
        var comenzar = $(config_xml).find("comenzar").text();
        $('#overall').hide();
        ims.interfaz.addButton("Siguiente", "right", "siguiente ", comenzar);
        ims.interfaz.enable("Siguiente");
        ims.interfaz.bind("Siguiente", 'nextPage()');
        scroll();
    } else {
        cargar_actividad();
    }
}

function cargar_actividad() {
    var overall = "<div id='overall'>" + $("#overall").html() + "</div>";
    $("#overall").remove();
    $("#content").prepend(overall);
    $("#right,#left").css("z-index", "2");
    $("#overall").css({
        "z-index": "1",
        // width: $("#fondo").width(),
        width: $("#visor").width(),
        height: $("#fondo").height()
    });
    $("#visor_content").removeAttr("style");
    var titulo = $(config_xml).find("introduccion").find("titulo").text();
    var enunciado = $(config_xml).find("enunciado").text();
    $("#header").prepend(titulo);
    $("#pregunta").append(enunciado);
    if ($(config_xml).find("pregunta").find("foto").length !== 0) {
        var foto_object = $(config_xml).find("pregunta").find("foto");
        var foto = foto_object.text();
        var rotation = foto_object.attr("rotation");
        var width = foto_object.attr("width");
        var height = foto_object.attr("height");
        var x = foto_object.attr("x");
        var y = parseInt(foto_object.attr("y"));
        if (foto !== '') {
            if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
                var ieversion = new Number(RegExp.$1);
                if (ieversion >= 8) {
                    if (url_files !== "") {
                        foto = url_files + foto;
                    } else {
                        foto = url_files + foto;
                    }
                    $("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
                    if (x === "" && y === "") {
                        height = parseInt($('#fondo div img').height());
                        width = parseInt($('#fondo div img').width());
                        if (width < $("#fondo").width() || height < $("#fondo").height()) {
                            x = $("#fondo").offset().left + $("#fondo").width() - width;
                            y = $("#fondo").offset().top + $("#fondo").height() - height;
                            $('#fondo div img').css({
                                "margin-left": x + "px ",
                                "margin-top": +y + "px"
                            });
                        }
                    }
                }
            } else {
                if (url_files !== "") {
                    $('#fondo').css("background-image", "url(" + url_files + foto + ")");
                } else {
                    $('#fondo').css("background-image", "url("+url_files + foto + ")");
                }
                $('#fondo').css("background-repeat", "no-repeat");
                if (rotation !== '') {
                    $('#fondo').css("rotation", rotation);
                    if (x !== '' || y !== '') {
                        $('#fondo').css("background-position", x + "px " + y + "px");
                        if (width !== '' && height !== '') {
                            $('#fondo').css("background-size", width + "px " + height + "px");
                        } else {
                            if (height !== '') {
                                $('#fondo').css("background-size", "auto " + height + "px");
                            } else {
                                if (width !== '') {
                                    $('#fondo').css("background-size", width + "px auto");
                                }
                            }
                        }
                    }
                }
            }
            url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
            bgImg = $('<img />');
            bgImg.hide();
            if (x === "" && y === "") {
                bgImg.bind('load', function () {
                    height = parseInt($(this).height());
                    width = parseInt($(this).width());
                    if (width < $("#fondo").width() || height < $("#fondo").height()) {
                        x = $("#fondo").offset().left + $("#fondo").width() - width;
                        y = $("#fondo").offset().top + $("#fondo").height() - height;
                        $('#fondo').css("background-position", x + "px " + y + "px");
                    }
                    bgImg.remove();
                });
            }
            $('#fondo').append(bgImg);
            bgImg.attr('src', url);
        }
    }
    var silenciar = $(config_xml).find("silenciar").text();
    var ayuda = $(config_xml).find("palabras").find("ayuda").text();
    var comprobar = $(config_xml).find("comprobar").text();
    var clave = $(config_xml).find("desarrollo").text();
    var imprimir = $(config_xml).find("imprimir").text();
    var versolucion = $(config_xml).find("versolucion").text();
    var reiniciar = $(config_xml).find("reiniciar").text();
    var volver = $(config_xml).find("volver").text();
    
    if ( !isMobile ){
        ims.interfaz.addButton("silenciar", "left", "silenciar", silenciar);
    }

    if ($(config_xml).find("sonido").text() !== '') {
        ims.interfaz.addButton("pausar", "left", "pause", $(config_xml).find("pausa").text());
        ims.interfaz.addButton("player", "left", "play", $(config_xml).find("reproducir").text());
    }
    if (!isMobile && $(config_xml).find("urlimprimir").text().length > 0) ims.interfaz.addButton("imprimir", "left", "imprimir", imprimir);

    ims.interfaz.addButton("ayuda", "right", "ayuda", ayuda);
    ims.interfaz.addButton("anterior", "left", "anterior", volver);
    ims.interfaz.addButton("comprobar", "right", "comprobar", comprobar);
    ims.interfaz.addButton("versolucion", "right", "versolucion", versolucion);
    ims.interfaz.addButton("clave", "right", "clave", clave);
    ims.interfaz.addButton("reiniciar", "right", "reiniciar", reiniciar);
    if ($(config_xml).find("introduccion").find("texto1").text().length !== 0) {
        ims.interfaz.enable("Anterior");
        ims.interfaz.bind("Anterior", 'prevPage()');
    }
    if ( !isMobile ){
        ims.interfaz.enable("silenciar");
        if (ims.interfaz.sound) {
            ims.interfaz.bind("silenciar", "mute()");
        } else {
            ims.interfaz.bind("silenciar", "play()");
        }
    }
  if ($(config_xml).find("ayuda").find("texto1").text().length !== 0) {
        ims.interfaz.addPopup("ayuda", "ayuda");
            var ayudaTit = $(config_xml).find("ayuda").find("titulo").text();
            var ayudaTex = $(config_xml).find("ayuda").find("texto1").text();
            $('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
            $('#content_ayuda').append('<div id="contenidoPOP">'+ayudaTex+'</div>');
        ims.interfaz.resize();
    }
    ims.interfaz.bind("reiniciar", 'reload()');
    ims.interfaz.bind("comprobar", 'comprobar()');
    ims.interfaz.bind("imprimir", "imprimir()");
    ims.interfaz.enable("reiniciar");
    ims.interfaz.enable("comprobar");
    ims.interfaz.enable("imprimir");

    //Diferenciamos entre carcasa Infantil y Primaria
    //determinar texto del tooltip
    orden = $(config_xml).find('orden').text();

    //añadir boton icon de mostrar/ocultar la orden 
    ims.interfaz.addButton("orden1", "left", "orden", orden);
    ims.interfaz.bind("orden1","toggle_enunciado()");
    ims.interfaz.enable("orden1");
    //asignar al p dentro del enunciado la clase pregunta_inf que le pone el borde rojo
    $('#pregunta').addClass('pregunta_inf');
    $('#pregunta').css('position','absolute');


    cargarMatrizLetras();
    var tA = 0;
    $("#ayuda").click(function () {
        if (tA === 0) {
            $("#content_ayuda").width($("#content_ayuda").width());
            $('#content_ayuda').jScrollPane({
                showArrows: false,
                hideFocus: true
            });
            tA++;
        }
    });
    scroll();
}

function cargarMatrizLetras(){
    palabrasSeleccionadas = [];
    $("#overall").append('<div id="matriz" style="position: relative; display: none; margin: 0 auto;"></div>');
    maxAltoMatriz = 0;
    maxAnchoMatriz = 0;
    var y = 0;
    $(config_xml).find( "fila" ).each( function(){
        var letras = $(this).text().split(",");
        var x = 0;
        for ( var len = letras.length; x < len ; x++ ) {
            if ( letras[x] == "" ){
            }
            else {
                $("#matriz").append('<div id="letra_'+ x +'_'+ y +'" class="letra" style="top:'+ y*tamanoLetra +'px; left:'+ x*tamanoLetra +'px; ">'+ letras[x] +'</div>');
                if ( x > maxAnchoMatriz && letras[x] != "" ){
                    maxAnchoMatriz = x;
                }
            }
        }
        y++;
        if ( y > maxAltoMatriz ){
            maxAltoMatriz = y;
        }
    });
    $("#matriz").css( "top", $("#header").outerHeight(true) + $("#pregunta").outerHeight(true) );
    $("#matriz").css( "display", "block" );
    $("#matriz").width( y*tamanoLetra ).height( y*tamanoLetra );
    if ( isMobile ) {
        $(".letra").bind( 'click' , function() {
            if ( !accionSeleccion && !actividadCorregida ){
                accionSeleccion = {};
                var letraOrigen = letraObj( $(this) );
                accionSeleccion.letraOrigen  = letraOrigen;
                $(this).addClass("firstClick");
            }
            else {
                var letraDestino = letraObj( $(this) );
                accionSeleccion.letraDestino  = letraDestino;
                if ( accionSeleccion.letraOrigen.id != letraDestino.id ) {
                    accionSeleccion.lastLetra = letraDestino;
                    // var miSeleccion = {
                    //     letraOrigen: accionSeleccion.letraOrigen,
                    //     letraDestino: accionSeleccion.letraDestino
                    // };
                    repintarSeleccion( true );
                }
                else {
                    var textoConfirmacion = configJson.ES.palabras.eliminar[0] || "confirm delete !?";
                    if ( confirm( textoConfirmacion ) ){
                        console.log( "como son la misma letra será que quiere borrar" );
                        var _palabraAborrar = false;
                        var _letraAborrar = "#"+$(this)[0].id;
                        console.log( $(this) )
                        console.log( "quieres borrar una palabra que tenga la letra "+ _letraAborrar );
                        for ( var i = 0, len = palabrasSeleccionadas.length; i < len; i++ ){
                            if ( palabrasSeleccionadas[i].letra == _letraAborrar ){
                                _palabraAborrar = palabrasSeleccionadas[i].palabra
                            }
                        }
                        console.log( "esta palabra es "+ _palabraAborrar );
                        var _accionSeleccion = accionSeleccion;
                        selecciones.splice( selecciones.indexOf( _accionSeleccion ) , 1 );
                        $( _palabraAborrar ).remove();
                        var _palabrasAborrar = [];
                        for ( var i = 0, len = palabrasSeleccionadas.length; i < len; i++ ){
                            if ( palabrasSeleccionadas[i].palabra == _palabraAborrar ){
                                _palabrasAborrar.push( palabrasSeleccionadas[i] );
                            }
                        }
                        for ( var i = 0, len = _palabrasAborrar.length; i < len; i++ ){
                            palabrasSeleccionadas.splice( palabrasSeleccionadas.indexOf( _palabrasAborrar[i] ) , 1 );
                        }
                        if ( selecciones.length > 0 ){
                            enableButton("comprobar");
                            enableButton("reiniciar");
                        }
                        else{
                            disableButton("comprobar");
                            disableButton("reiniciar");
                        }
                    }
                }
                $(".firstClick").removeClass("firstClick");
                accionSeleccion = false;
            }
        });
    }
    else {
        $(".letra").mousedown( function(e){
            if ( !accionSeleccion && !actividadCorregida){
                accionSeleccion = {};
                var letraOrigen = letraObj( $(this) );
                accionSeleccion.letraOrigen  = letraOrigen;
                accionSeleccion.lastLetra = letraOrigen;
                // console.log( "origen", letraOrigen );
                repintarSeleccion( false );
            }
        });
        $(".letra").mousemove( function(e){
            if ( accionSeleccion && !actividadCorregida ){
                var letraActual = letraObj( $(this) );
                if ( accionSeleccion.lastLetra.id != letraActual.id ){
                    accionSeleccion.lastLetra = letraActual;
                    // console.log( "change", letraActual );
                    repintarSeleccion( false );
                }
            }
        });
        $(".letra").mouseup( function(e){
            if ( accionSeleccion && !actividadCorregida ){
                var letraDestino = letraObj( $(this) );
                // accionSeleccion.letraDestino = letraDestino;
                // console.log( "destino", letraDestino )
                // selecciones.push( accionSeleccion );
                repintarSeleccion( true );
                accionSeleccion = false;
            }
        });
        $(document).mouseup( function(e){
            if ( accionSeleccion && !actividadCorregida ){
                accionSeleccion = false;
                $("#seleccionActual").remove();
            }
        });
    }
}
// var idRespuestas = 0;
function repintarSeleccion( marcar ){
    var origen  = accionSeleccion.letraOrigen;
    var actual  = accionSeleccion.lastLetra;
    var vector = {};
    vector.x = actual.x - origen.x;
    vector.y = actual.y - origen.y;
    vector.phi = vector.x / vector.y;
    vector.long = Math.max( Math.abs(vector.x), Math.abs(vector.y) ) ;
    // var longitud = (vector.long+1)*tamanoLetra;

    var altura = 30;
    var giro;
    if ( Math.abs( vector.phi ) > 2 ){
        vector.phix = vector.x > 0 ? 1 : (-1) ;
        vector.phiy = 0;
        if ( vector.phix > 0 ){
            giro = 0;
        }
        else{
            giro = 180;
        }
        actual.x = parseInt( origen.x ) + vector.long * vector.phix
        actual.y = origen.y;
    }
    else if ( Math.abs( vector.phi ) < 0.5  ){
        vector.phix = 0;
        vector.phiy = vector.y > 0 ? 1 : (-1) ;
        if ( vector.phiy > 0 ){
            giro = 90;
        }
        else{
            giro = 270;
        }
        actual.x = origen.x;
        actual.y = parseInt( origen.y ) + vector.long * vector.phiy;
    }
    else {
        vector.phix = vector.x > 0 ? 1 : (-1) ;
        vector.phiy = vector.y > 0 ? 1 : (-1) ;
        // longitud = Math.round( longitud*Math.sqrt( 2 ) - 12 );
        if( vector.phix == 1 && vector.phiy == 1 ){
            giro = 45;
        }
        else if( vector.phix == 1 ){
            giro = 315;
        } 
        else if( vector.phiy == 1 ){
            giro = 135;
        }
        else{
            giro = 225;
        }
        actual.x = parseInt( origen.x ) + vector.long * vector.phix
        actual.y = parseInt( origen.y ) + vector.long * vector.phiy;
    }
    if ( actual.x < 0 ){
        actual.y = parseInt( actual.y ) + vector.phiy * actual.x;
        actual.x = 0;
    }
    if ( actual.y < 0 ){
        actual.x = parseInt( actual.x ) + vector.phix * actual.y;
        actual.y = 0;
    }
    if ( actual.x > maxAnchoMatriz ){
        // console.log( "a", actual );
        actual.y = actual.y - vector.phiy * ( actual.x - maxAnchoMatriz );
        actual.x = maxAnchoMatriz;
        // console.log( "a!", actual );
    }
    if ( actual.y >= maxAltoMatriz ){
        // console.log( "b", actual );
        actual.x = actual.x - vector.phix * ( actual.y - maxAltoMatriz + 1 );
        actual.y = maxAltoMatriz - 1;
        // console.log( "!b", actual );
    }
    vector.x = actual.x - origen.x;
    vector.y = actual.y - origen.y;
    vector.phi = vector.x / vector.y;
    vector.long = Math.max( Math.abs(vector.x), Math.abs(vector.y) ) ;
    var longitud = (vector.long+1)*tamanoLetra + 2;
    if ( vector.phiy*vector.phix != 0 ){
        longitud = Math.round( longitud*Math.sqrt( 2 ) - 16 );
    }

    var margenIzqCalc = parseInt( origen.x*30 );
    if ( giro == 90 || giro == 270 ){
        margenIzqCalc += 1;
    }
    var margenSupCalc = parseInt( origen.y*30 );
    if ( giro == 45 ) {
    }
    else if ( giro == 135 ){
        margenSupCalc += 1;
    }
    else if ( giro == 225 ){
        margenSupCalc += 1;
    }
    else if ( giro == 315 ){
    }

    if ( !marcar ){
        if ( !$("#seleccionActual").length  ){
            $("#matriz").append( '<div id="seleccionActual"></div>' );
        }
        // $( "#seleccionActual" ).css({
        //     "position": "absolute",
        //     "height": altura+"px",
        //     "width": longitud+"px",
        //     "top": parseInt( origen.y*30 )+"px",
        //     "left": parseInt( origen.x*30 )+"px",
        //     "transform-origin": "15px "+parseInt( altura/2 )+"px",
        //     "-ms-transform": "rotate("+giro+"deg)",/*" translate("+positionString+")", *//* IE 9 */
        //     "-webkit-transform": "rotate("+giro+"deg)", translate("+positionString+")", /* Chrome, Safari, Opera */
        //     "transform": "rotate("+giro+"deg)", /*translate("+positionString+")"*/
        //     "border": "0px solid #000000",
        //     "border-radius": "15px 15px 15px 15px",
        //     "-moz-border-radius": "15px 15px 15px 15px",
        //     "-webkit-border-radius": "15px 15px 15px 15px",
        //     "z-index": "-200",
        //     "background-color": "rgba( 251, 199, 59, .5)"
        // });   
        $( "#seleccionActual" ).css({
            "position": "absolute",
            "height": altura+"px",
            "width": longitud+"px",
            "top": margenSupCalc+"px",
            "left": margenIzqCalc+"px",
            "transform-origin": "15px "+ parseInt( altura/2 )+"px",
            "-ms-transform": "rotate("+giro+"deg)",/*" translate("+positionString+")", *//* IE 9 */
            "-webkit-transform": "rotate("+giro+"deg)", /*translate("+positionString+")",*/ /* Chrome, Safari, Opera */
            "transform": "rotate("+giro+"deg)", /*translate("+positionString+")"*/
            "border-radius": "15px 15px 15px 15px",
            "-moz-border-radius": "15px 15px 15px 15px",
            "-webkit-border-radius": "15px 15px 15px 15px",
            "z-index": "-200",
            // "border": "0px solid #000000",
            // "background-color": "rgba( 251, 199, 59, .5)"
            // "border": "2px solid darkorange",
            "background-color": "orange",
            "opacity": "0.4"
        });   
    }
    else {
        
        if ( isiOS ){
            vector.long ++;
            if ( giro == 90 ){
                margenIzqCalc -= longitud/2 - altura/2;
                margenSupCalc += longitud/2 - altura/2;
            }
            if( giro == 270 ){
                margenIzqCalc -= longitud/2 - altura/2;
                margenSupCalc -= longitud/2 - altura/2;   
            }
            if ( giro == 180 ){
                margenIzqCalc -= longitud - altura;
            }
            if ( giro == 45 ) {
                margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long)*tamanoLetra/2 -2;
                margenSupCalc = margenSupCalc - altura/2 + (vector.long)*tamanoLetra/2 -2;
            }
            else if ( giro == 135 ){
                margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-2)*tamanoLetra/2 -2;
                margenSupCalc = margenSupCalc - altura/2 + (vector.long)*tamanoLetra/2 -2;
            }
            else if ( giro == 225 ){
                margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-2)*tamanoLetra/2 -2;
                margenSupCalc = margenSupCalc - altura/2 - (vector.long-2)*tamanoLetra/2 -2;
            }
            else if ( giro == 315 ){
                margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long)*tamanoLetra/2 -2 ;
                margenSupCalc = margenSupCalc - altura/2 - (vector.long-2)*tamanoLetra/2 -2;
            }
        }

        $("#seleccionActual").remove();
        accionSeleccion.letraDestino = actual;
        var valido = validarPalabraSeleccionada( origen, actual );
        if ( valido ){
            selecciones.push( accionSeleccion );

            for ( var i = 0; i <= vector.long; i++ ){
                palabrasSeleccionadas.push({
                   letra: "#letra_"+( parseInt(origen.x)+i*vector.phix)+"_"+( parseInt(origen.y)+i*vector.phiy),
                   palabra: "#seleccion_"+origen.id+"_"+actual.id
                });

                if ( !isMobile ){
                    $( "#letra_"+(origen.x+i*vector.phix)+"_"+(origen.y+i*vector.phiy) ).on( "dblclick", { letra: "#letra_"+(origen.x+i*vector.phix)+"_"+(origen.y+i*vector.phiy), accion: accionSeleccion }, function( event ){
                        var textoConfirmacion = configJson.ES.palabras.eliminar[0] || "confirm delete !?";
                        if ( confirm( textoConfirmacion ) ){
                            console.log( "quieres borrar una palabra que tenga la letra "+ event.data.letra );
                            var _palabraAborrar = false;
                            var _letraAborrar = event.data.letra;
                            for ( var i = 0, len = palabrasSeleccionadas.length; i < len; i++ ){
                                if ( palabrasSeleccionadas[i].letra == _letraAborrar ){
                                    _palabraAborrar = palabrasSeleccionadas[i].palabra
                                }
                            }
                            console.log( "esta palabra es "+ _palabraAborrar );
                            var _accionSeleccion = event.data.accion;
                            selecciones.splice( selecciones.indexOf( _accionSeleccion ) , 1 );
                            $( _palabraAborrar ).remove();
                            var _palabrasAborrar = [];
                            for ( var i = 0, len = palabrasSeleccionadas.length; i < len; i++ ){
                                if ( palabrasSeleccionadas[i].palabra == _palabraAborrar ){
                                    _palabrasAborrar.push( palabrasSeleccionadas[i] );
                                }
                            }
                            for ( var i = 0, len = _palabrasAborrar.length; i < len; i++ ){
                                palabrasSeleccionadas.splice( palabrasSeleccionadas.indexOf( _palabrasAborrar[i] ) , 1 );
                            }
                            if ( selecciones.length > 0 ){
                                enableButton("comprobar");
                                enableButton("reiniciar");
                            }
                            else{
                                disableButton("comprobar");
                                disableButton("reiniciar");
                            }
                        }
                    });
                }
            }

            
            $("#matriz").append( '<div id="seleccion_'+origen.id+"_"+actual.id+'" class="palabraSeleccionada"></div>' );
            if ( !isiOS ){
                $( "#seleccion_"+origen.id+"_"+actual.id ).css({
                    "transform-origin": "15px "+parseInt( altura/2 )+"px"
                });
            }
            $( "#seleccion_"+origen.id+"_"+actual.id ).css({
                "position": "absolute",
                "height": altura+"px",
                "width": longitud+"px",
                "top": margenSupCalc+"px",
                "left": margenIzqCalc+"px",
                // "transform-origin": "15px "+parseInt( altura/2 )+"px",
                "-ms-transform": "rotate("+giro+"deg)",/*" translate("+positionString+")", *//* IE 9 */
                "-webkit-transform": "rotate("+giro+"deg)", /*translate("+positionString+")",*/ /* Chrome, Safari, Opera */
                "transform": "rotate("+giro+"deg)", /*translate("+positionString+")"*/
                "border-radius": "15px 15px 15px 15px",
                "-moz-border-radius": "15px 15px 15px 15px",
                "-webkit-border-radius": "15px 15px 15px 15px",
                "z-index": "-300",
                // "border": "0px solid #000000",
                "background-color": "orange",
                "opacity": "1"
            });
        }
        else {
            // console.log( configJson );
            var textoConfirmacion = configJson.ES.palabras.eliminar[0] || "confirm delete !?";
            if ( confirm( textoConfirmacion ) ){
                $( "#seleccion_"+origen.id+"_"+actual.id ).remove();
                $( "#seleccion_"+actual.id+"_"+origen.id ).remove();
                selecciones.splice( selecciones.indexOf( accionSeleccion ) , 1 );
            }
            else{
            }
        }
    }
}


function pintarSoluciones( obj ){

    var origen  = {};
    var actual = {};
    
    origen.id = obj.attr("inix")+"_"+obj.attr("iniy");
    origen.x = obj.attr("inix");
    origen.y = obj.attr("iniy");
    actual.id = obj.attr("finx")+"_"+obj.attr("finy");
    actual.x = obj.attr("finx");
    actual.y = obj.attr("finy");
    
    var vector = {};
    
    vector.x = actual.x - origen.x;
    vector.y = actual.y - origen.y;
    vector.phi = vector.x / vector.y;
    vector.long = Math.max( Math.abs(vector.x), Math.abs(vector.y) ) + 1 ;

    var longitud = vector.long*tamanoLetra - 2;
    var altura = 28;
    var giro = 0;

    if ( Math.abs( vector.phi ) > 2 ){
        vector.phix = vector.x > 0 ? 1 : (-1) ;
        vector.phiy = 0;
        if ( vector.phix > 0 ){
            giro = 0;
        }
        else{
            giro = 180;
        }
    }
    else if ( Math.abs( vector.phi ) < 0.5  ){
        vector.phix = 0;
        vector.phiy = vector.y > 0 ? 1 : (-1) ;
        if ( vector.phiy > 0 ){
            giro = 90;
        }
        else{
            giro = 270;
        }
    }
    else {
        vector.phix = vector.x > 0 ? 1 : (-1) ;
        vector.phiy = vector.y > 0 ? 1 : (-1) ;
        longitud = Math.round( longitud*Math.sqrt( 2 ) - 12 );
        if( vector.phix == 1 && vector.phiy == 1 ){
            giro = 45;
        }
        else if( vector.phix == 1 ){
            giro = 315;
        } 
        else if( vector.phiy == 1 ){
            giro = 135;
        }
        else{
            giro = 225;
        }
    }

    var margenIzqCalc = parseInt( origen.x*30 );
    if ( giro == 90 || giro == 270 ){
        margenIzqCalc += 1;
    }
    var margenSupCalc = parseInt( origen.y*30 );
    if ( giro == 45 ) {
    }
    else if ( giro == 135 ){
        margenSupCalc += 1;
    }
    else if ( giro == 225 ){
        margenSupCalc += 1;
    }
    else if ( giro == 315 ){
    }

//    if ( isiOS ){
//        if ( giro == 90 ){
//            margenIzqCalc -= longitud/2 - altura/2;
//            margenSupCalc += longitud/2 - altura/2;
//        }
//        if( giro == 270 ){
//            margenIzqCalc -= longitud/2 - altura/2;
//            margenSupCalc -= longitud/2 - altura/2;   
//        }
//        if ( giro == 180 ){
//            margenIzqCalc -= longitud - altura;
//        }
//        if ( giro == 45 ) {
//            margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//            margenSupCalc = margenSupCalc - altura/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//        }
//        else if ( giro == 135 ){
//            margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//            margenSupCalc = margenSupCalc - altura/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//        }
//        else if ( giro == 225 ){
//            margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//            margenSupCalc = margenSupCalc - altura/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//        }
//        else if ( giro == 315 ){
//            margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long+1)*tamanoLetra/2 -altura/2 ;
//            margenSupCalc = margenSupCalc - altura/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//        }
//    }
//    else 
    //Esto es para centrar las palabras a las lineas pero...qué manera tan hermosa!
    if ( !isMobile ) {
        if ( giro == 0 ){
            margenSupCalc = margenSupCalc + 2;
        }
        if ( giro == 90 ){
            margenSupCalc = margenSupCalc + 4;
        }
        if( giro == 270 ){
            margenSupCalc = margenSupCalc + 2;
            margenIzqCalc = margenIzqCalc - 1;
        }
        if ( giro == 180 ){
            margenSupCalc = margenSupCalc + 4;
            margenIzqCalc = margenIzqCalc - 1;
        }
        if ( giro == 45 ) {
            margenSupCalc = margenSupCalc + 4;
            margenIzqCalc = margenIzqCalc + 1;
        }
        else if ( giro == 135 ){
            margenSupCalc = margenSupCalc + 4;
        }
        else if ( giro == 225 ){
            margenSupCalc = margenSupCalc + 2;
            margenIzqCalc = margenIzqCalc - 2;
        }
        else if ( giro == 315 ){
            margenSupCalc = margenSupCalc + 4;
        }
    }   
        
    $("#matriz").append( '<div id="seleccion_'+origen.id+'_'+actual.id+'" class="jsSeleccion"></div>' );
        $( "#seleccion_"+origen.id+'_'+actual.id ).css({
            "position": "absolute",
            "height": altura+"px",
            "width": longitud+"px",
            "top": margenSupCalc+"px",
            "left": margenIzqCalc+"px",
            "transform-origin": "15px "+parseInt( altura/2 )+"px",
            "-ms-transform": "rotate("+giro+"deg)",/*" translate("+positionString+")", *//* IE 9 */
            "-webkit-transform": "rotate("+giro+"deg)", /*translate("+positionString+")",*/ /* Chrome, Safari, Opera */
            "transform": "rotate("+giro+"deg)", /*translate("+positionString+")"*/
            "border-radius": "15px 15px 15px 15px",
            "-moz-border-radius": "15px 15px 15px 15px",
            "-webkit-border-radius": "15px 15px 15px 15px",
            "z-index": "-300",
            // "border": "2px solid darkgreen",
            "background-color": "green",
        });   
}

function validarPalabraSeleccionada( origen, destino ){
    for ( var i = 0; i < selecciones.length ; i++ ){
        var resOrigenX = selecciones[i].letraOrigen.x;
        var resOrigenY = selecciones[i].letraOrigen.y;
        var resDestinoX = selecciones[i].letraDestino.x;
        var resDestinoY = selecciones[i].letraDestino.y;
        var palabraOrigenX = origen.x;
        var palabraOrigenY = origen.y;
        var palabraDestinoX = destino.x;
        var palabraDestinoY = destino.y;
        var okDerecho = palabraOrigenX == resOrigenX && palabraOrigenY == resOrigenY && palabraDestinoX == resDestinoX && palabraDestinoY == resDestinoY;
        var okReves = palabraOrigenX == resDestinoX && palabraOrigenY == resDestinoY && palabraDestinoX == resOrigenX && palabraDestinoY == resOrigenY;
        if ( okDerecho || okReves ){
            return false;
        }
    }
    return true;
}

// function pintarSoluciones( obj ){

//     var origen  = {};
//     var actual = {};
    
//     origen.id = obj.attr("inix")+"_"+obj.attr("iniy");
//     origen.x = obj.attr("inix");
//     origen.y = obj.attr("iniy");
//     actual.id = obj.attr("finx")+"_"+obj.attr("finy");
//     actual.x = obj.attr("finx");
//     actual.y = obj.attr("finy");
    
//     var vector = {};
    
//     vector.x = actual.x - origen.x;
//     vector.y = actual.y - origen.y;
//     vector.phi = vector.x / vector.y;
//     vector.long = Math.max( Math.abs(vector.x), Math.abs(vector.y) ) + 1 ;

//     var longitud = vector.long*tamanoLetra - 2;
//     var altura = 26;
//     var giro;

//     if ( Math.abs( vector.phi ) > 2 ){
//         vector.phix = vector.x > 0 ? 1 : (-1) ;
//         vector.phiy = 0;
//         if ( vector.phix > 0 ){
//             giro = 0;
//         }
//         else{
//             giro = 180;
//         }
//     }
//     else if ( Math.abs( vector.phi ) < 0.5  ){
//         vector.phix = 0;
//         vector.phiy = vector.y > 0 ? 1 : (-1) ;
//         if ( vector.phiy > 0 ){
//             giro = 90;
//         }
//         else{
//             giro = 270;
//         }
//     }
//     else {
//         vector.phix = vector.x > 0 ? 1 : (-1) ;
//         vector.phiy = vector.y > 0 ? 1 : (-1) ;
//         longitud = Math.round( longitud*Math.sqrt( 2 ) - 12 );
//         if( vector.phix == 1 && vector.phiy == 1 ){
//             giro = 45;
//         }
//         else if( vector.phix == 1 ){
//             giro = 315;
//         } 
//         else if( vector.phiy == 1 ){
//             giro = 135;
//         }
//         else{
//             giro = 225;
//         }
//     }

//     var margenIzqCalc = parseInt( origen.x*30 );
//     if ( giro == 90 || giro == 270 ){
//         margenIzqCalc += 1;
//     }
//     var margenSupCalc = parseInt( origen.y*30 );
//     if ( giro == 45 ) {
//     }
//     else if ( giro == 135 ){
//         margenSupCalc += 1;
//     }
//     else if ( giro == 225 ){
//         margenSupCalc += 1;
//     }
//     else if ( giro == 315 ){
//     }

//     if ( isiOS ){
//         if ( giro == 90 ){
//             margenIzqCalc -= longitud/2 - altura/2;
//             margenSupCalc += longitud/2 - altura/2;
//         }
//         if( giro == 270 ){
//             margenIzqCalc -= longitud/2 - altura/2;
//             margenSupCalc -= longitud/2 - altura/2;   
//         }
//         if ( giro == 180 ){
//             margenIzqCalc -= longitud - altura;
//         }
//         if ( giro == 45 ) {
//             margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//             margenSupCalc = margenSupCalc - altura/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//         }
//         else if ( giro == 135 ){
//             margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//             margenSupCalc = margenSupCalc - altura/2 + (vector.long+1)*tamanoLetra/2 -altura/2;
//         }
//         else if ( giro == 225 ){
//             margenIzqCalc = margenIzqCalc - longitud/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//             margenSupCalc = margenSupCalc - altura/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//         }
//         else if ( giro == 315 ){
//             margenIzqCalc = margenIzqCalc - longitud/2 + (vector.long+1)*tamanoLetra/2 -altura/2 ;
//             margenSupCalc = margenSupCalc - altura/2 - (vector.long-1)*tamanoLetra/2 +altura/2;
//         }
//     }
        
//     $("#matriz").append( '<div id="seleccion_'+origen.id+'_'+actual.id+'" class="jsSeleccion"></div>' );
//         $( "#seleccion_"+origen.id+'_'+actual.id ).css({
//             "position": "absolute",
//             "height": altura+"px",
//             "width": longitud+"px",
//             "top": margenSupCalc+"px",
//             "left": margenIzqCalc+"px",
//             "transform-origin": "15px "+parseInt( altura/2 )+"px",
//             "-ms-transform": "rotate("+giro+"deg)",/*" translate("+positionString+")", *//* IE 9 */
//             "-webkit-transform": "rotate("+giro+"deg)", /*translate("+positionString+")",*/ /* Chrome, Safari, Opera */
//             "transform": "rotate("+giro+"deg)", /*translate("+positionString+")"*/
//             "border-radius": "15px 15px 15px 15px",
//             "-moz-border-radius": "15px 15px 15px 15px",
//             "-webkit-border-radius": "15px 15px 15px 15px",
//             "z-index": "-300",
//             "border": "2px solid darkgreen",
//             "background-color": "green",
//         });   
// }


function letraObj( obj ){
    var id = obj.get(0).id;
    var x = id.split("_")[1];
    var y = id.split("_")[2];
    return {
        id: id,
        x: x,
        y: y
    }
}


function imprimir() {
    window.open($(config_xml).find("urlimprimir").text(), "Santillana", 'width=800,height=600');
}

function prevPage() {
    accionSeleccion = false;
    selecciones = [];
    actividadCorregida = false;
    $(".stars").remove();
    $(".tooltip").remove("");
    $("#limit").remove("");
    ims.interfaz.init();
    var element = $("#visor").jScrollPane().data().jsp;
    element.destroy();
    $("#overall").hide();
    inicializar();
    scroll();
    retornar();
}

function nextPage() {
    $("#overall").show();
    $(".tooltip").remove("");
    $("#limit").remove("");
    ims.interfaz.init();
    var element = $("#visor").jScrollPane().data().jsp;
    element.destroy();
    cargar_actividad();
    scroll();
    retornar();
}

function retornar(){
    introduce_retorno();
}

function reload() {
    // location.reload();
    $(".firstClick").removeClass("firstClick");
    $(".palabraSeleccionada").remove();
    // $(".letra").css({
    //     "background-color": "white"
    // });
    $(".jsSeleccion").remove();
    $("#comprobar").addClass("notdisabled");
    $("#center").html("");
    accionSeleccion = false;
    selecciones = [];
    actividadCorregida = false;
    introduce_retorno();
}

function mute() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar');
    $('#silenciar').addClass('silenciar_on');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "play()");
    ims.interfaz.disableSound();
}

function play() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar_on');
    $('#silenciar').addClass('silenciar');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "mute()");
    ims.interfaz.enableSound();
}

function comprobar() {
    total = 0;
    correct = 0;
    if ( !actividadCorregida ) {
        $(".firstClick").removeClass("firstClick");
        actividadCorregida = true;
        if ( $(config_xml).find("ES > solucion").find("texto1").text().length !== 0 ) {
            if ( inmediastudio.TRAZA.mostrarSolucion ){ 
                ims.interfaz.enable("clave");
                ims.interfaz.addPopup("solucion", "clave");
            }
            var tS = 0;
            $("#clave").click(function () {
                if (tS === 0) {
                    $("#content_solucion").width($("#content_solucion").width());
                    $('#content_solucion').jScrollPane({
                        showArrows: false,
                        hideFocus: true
                    });
                    tS++;
                }
                ims.interfaz.resize();
            });
            $(config_xml).find("ES > solucion").each( function(){
                var solucionTit = $(this).find("titulo").text();
                var solucionTex = $(this).find("texto1").text();
                $('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
                $('#content_solucion').html('<div id="contenidoPOP">'+solucionTex+'</div>');
            });
        }
        $("#overall").css( "z-index", 1 );
        $("#comprobar").removeClass("notdisabled");
        if ( inmediastudio.TRAZA.mostrarSolucion ) { 
            $("#versolucion").addClass("notdisabled");
            ims.interfaz.bind("versolucion", "solucion()");
        }
        else {
            $("#reiniciar").unbind('click');
            $("#reiniciar").removeClass("notdisabled");
            $("#Anterior").unbind('click');
            $("#Anterior").removeClass("notdisabled");
        }
        for( var i = 0 ; i < selecciones.length ; i++ ){
            var respuestaOK = false;
            var miId = selecciones[i].letraOrigen.id+"_"+selecciones[i].letraDestino.id;
            var resOrigenX = selecciones[i].letraOrigen.x;
            var resOrigenY = selecciones[i].letraOrigen.y;
            var resDestinoX = selecciones[i].letraDestino.x;
            var resDestinoY = selecciones[i].letraDestino.y;
            $(config_xml).find("palabra").each( function(){
                var palabraOrigenX = $(this).attr("inix");
                var palabraOrigenY = $(this).attr("iniy");
                var palabraDestinoX = $(this).attr("finx");
                var palabraDestinoY = $(this).attr("finy");
                var okDerecho = palabraOrigenX == resOrigenX && palabraOrigenY == resOrigenY && palabraDestinoX == resDestinoX && palabraDestinoY == resDestinoY;
                var okReves = palabraOrigenX == resDestinoX && palabraOrigenY == resDestinoY && palabraDestinoX == resOrigenX && palabraDestinoY == resOrigenY; 
                if ( okDerecho || okReves ){ 
                    respuestaOK = true;
                    correct++;
                }
            });
            if ( inmediastudio.TRAZA.mostrarSolucion ){ 
                if ( respuestaOK ){
                    $( "#seleccion_"+miId ).css({
                        "background-color": "green"
                    });
                    ims.interfaz.showStars( $( "#seleccion_"+miId ) );
                }
                else {
                    $( "#seleccion_"+miId ).css({
                        "background-color": "red"
                    });
                }
            }
        }
        total = $(config_xml).find("palabra").length;
        if ( inmediastudio.TRAZA.mostrarSolucion ){ 
            $(".selected").addClass("noCheck").removeClass("selected");
        }
        if (ims.interfaz.skin == "musica") {
            ims.interfaz.showResults(correct +" / "+ total);
        }
        else {
            ims.interfaz.showResults("<p>" + correct + " / " + total + "</p>");
        }
        if( correct > 9 ){
            $("#center p").css('font-size','20px');
        }
        if ( inmediastudio.TRAZA.guardarRespuesta ){ 
            inmediastudio.RESULTADOS.guardarPuntuacion( correct/total );
        }
        if (correct === total) {
            var sound = "rGood";
        }
        else {
            var sound = "rBad";
        }
        if ( inmediastudio.TRAZA.mostrarSolucion ){ 
            ims.interfaz.playSound( sound );
        }
    }
}

function solucion() {
    if( $("#versolucion").hasClass('notdisabled') ){
        $(".palabraSeleccionada").remove();
        $(".stars").remove();
        $("#center").html("");
        $(".row").height( 0 );
        $(config_xml).find("palabra").each( function (){
            $(".noCheck").removeClass("noCheck");
            pintarSoluciones( $(this) );
            // ims.interfaz.showStars( $("#letra_"+$(this).attr("inix")+"_"+$(this).attr("iniy") ) );
    });
    if ($("#versolucion").hasClass("notdisabled")) {
        var sound = "good";
        ims.interfaz.playSound(sound);
    }
    ims.interfaz.disable('versolucion');
    } 
}
function toggle_enunciado(){
    $('#pregunta').fadeToggle();
}
