$(document).ready(function() {

	data = jQuery.parseJSON(data);
	
	// Proceso los datos en busca de filtros 
	
	$(data).each(function() {
	
		if (this.name == "config") {
			
			$(this.elementos).each(function(){
			
				if (this.nombre == "buscador" && this.valor == "0") {
				
					$('.buscar').hide();
				
				}
			
			});
			
		}
	
		if (this.name == "filtros") {
		
			// Recorro las opciones de los filtros.
			var count = 0;
			
			$(this.elementos).each(function(){
			
				// Creo el select de cada filtro
				var tmp = '';
				
				$(this.elementos).each(function(item){
					tmp += '<option value="'+this.id+'">'+this.nombre+'</option>';
				});
				$('#header').append('<select name="'+this.name+'"><option value="">'+this.name+'</option>'+tmp+'</select>');
				
				count++;
				
				if (((count >= 3) && $(".buscar").is(":visible")) || (count >= 4 )) {
					$(".buscar").css('margin-right', '0px');
					$(".buscar").width(790);
				}
				$('#main').css("margin-top", ($('#header').height() + 26) + "px");
				
			});
			
			// Bindeo el evento que se lanza al filtrar
			
			$('select').change(function(){
				
				mostrar_caratulas(0);
				
			});
			
			
		}
		
	});
	
	$('.resetFilters').click(function(){
	
		// Reseteo los filtros.
	
		$("select").each( function(){
			$(this).val( $("#" + $(this).attr("id") + " option:first").val() );
			$('.buscar').val("");
			mostrar_caratulas(0);
		});
	
	});
	
	$('.buscar').click(function(){
	
		$(this).val('');
	
	});
	
	$('.buscar').change(function(){
		
		//if ( $(this).val().length == '0') { $(this).val(''); }
		
		mostrar_caratulas(0);
		
	});
	
	$(document).bind('mousemove', function(e){
	    $('.tooltip').css({
	       left:  e.pageX + 10,
	       top:   e.pageY + 2
	    });
	});
	
	/*
	$('#hot_down').click(function(){
		$('#main').animate({ scrollTop: $('#main').scrollTop() + 700 }, 'slow', function() { comprobar_hot_zones(); });	
	});
	
	$('#hot_up').click(function(){
		$('#main').animate({ scrollTop: $('#main').scrollTop() - 700 }, 'slow', function() { comprobar_hot_zones(); });	
	});
	*/
	
	mostrar_caratulas(0);

});


function mostrar_caratulas(inicio) {

	$('.mostrar_mas').remove();

	var caratulas_por_pagina = 50;

	// Borro las caratulas si las hubiese
	if (inicio == 0) {
		$('#main').html('');
	}

	// Proceso los datos en busca de caratulas 
	
	$(data).each(function() {
	
		if (this.name == "caratulas") {
		
			var keywords = $('.buscar').val().split(" ");
			var y = 0;
					
			$(this.elementos).each(function(item){
			
				var flag = true;
				var elemento = this;
				
				$('select').each(function(){
				
					if ( ($(this).find(':selected').val() != '')  && elemento.opciones.indexOf('('+$(this).find(':selected').val()+')') == -1 ) {
					
						flag = false;
					
					}
					
				});
				
				var tmp = this.name.toLowerCase() + '';
				var tmp2 = this.etiquetas.toLowerCase() + '';
				
				if ( $('.buscar').val() != "Buscar" && $('.buscar').val() != "" ) {
				
					for (var i = 0; i < keywords.length; i++) {

						if ( ( this.name.indexOf(keywords[i]) == -1 && tmp.indexOf(keywords[i].toLowerCase()) == -1 ) && ( this.etiquetas.indexOf(keywords[i].toLowerCase()) == -1 && tmp2.indexOf(keywords[i].toLowerCase()) == -1 ) ) {
					
							flag = false;
							
						}
						
					}
						
				}
			
				if (flag) {
					
					if ( (y >= (inicio)) && (y < (inicio + caratulas_por_pagina)) ) {
				
						// Creo cada caratula si ha cumplido con los filtros establecidos.
						if (this.name == "") { this.name = " "; }
						if (this.link == "") { var tmp_class = "off"; } else { var tmp_class = ""; }
						$('#main').append('<div class="elemento elemento_'+item+'" title="'+this.name+'" rel="'+this.link+'"><div class="elem_left"></div><div class="elem_right"></div><div class="elem"><img src="'+this.image+'" /><div class="elem_fade '+tmp_class+'"></div></div></div>'); 
						
						// Le meto un random a la ruta del a imagen para que IE8 no cachee la imágen.
						$("<img/>").attr("src", this.image +'?'+Math.floor(Math.random()*1001)).load(function() {
						
		        			$('.elemento_'+item).width(this.width);
		        			$('.elemento_'+item+' .elem_fade').css('width',this.width);
		        			$('.elemento_'+item+' .elem_left').css('width', Math.floor(this.width / 2) + 23);
		        			$('.elemento_'+item+' .elem_right').css('width', Math.ceil(this.width / 2) + 23);
		        			$('.elemento_'+item).tooltip();
		        			if ($('.elemento_'+item).attr('rel') != "") {
		        				$('.elemento_'+item).click(function(){ window.open( $('.elemento_'+item).attr('rel') ); });
		        			}
		        			
		        			//comprobar_hot_zones();
		        		});
	        		
	        		} else {
		        		
		        		if (y == (inicio + caratulas_por_pagina)) {
			        		
			        		$('#main').append('<div class="mostrar_mas"><div class="button_mostrar_mas">Ver más</div></div>'); 
			        		$('.mostrar_mas').click(function(){ mostrar_caratulas(inicio + caratulas_por_pagina); });
			        		
		        		}
		        		
	        		}
	        		
	        		y++;
        		
        		}
				
			});
			
		}
		
	});
	
}

/*
function comprobar_hot_zones() {

		if ( $('#main')[0].scrollHeight > ($('#main').scrollTop() + 708) ) { 
			$('#hot_down').addClass('enabled'); 
		} else {
			$('#hot_down').removeClass('enabled'); 
		}

		if ( $('#main').scrollTop() > 0 ) { 
			$('#hot_up').addClass('enabled'); 
		} else {
			$('#hot_up').removeClass('enabled'); 
		}

}
*/