/*

    Autor: Daniel Rodríguez
    Fecha: 11/13

*/

var isiPad        = navigator.userAgent.match(/iPad/i) != null;
var isAndroid     = navigator.userAgent.match(/Android/i) != null;
//posiciones para manejar mejor las imágenes
var id_cat        = 0;
var eq_imagen     = 0;
var eq_img_selec  = 0;
var eq_imagen_cat = 0;

var dragging      = false;
var checked       = 0;
var draggingObj   = null;
//si es 'si', alguna imagen tienen audio
var hay_audio     = '';
//el audio global
var audio_global  = '';
//para comprobar si se han de poner o no las flechas de sig/ant al ocultar/mostrar leyenda
var ante2         = '';
var sigue2        = '';
//para ver si hay cats elegidas
var con_cat       = '';

var imagenesSelectorInicial = 0;

if (typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function(e) {
        inicializar();
        window.addEventListener("resize",posicionar,false);
        window.addEventListener("load",posicionar,false);
    });
}
else{
   $( window ).ready( function(){
      inicializar();
   }
   );
   $( window ).resize( function(){
      posicionar();
   }
   );
   $( window ).load( function(){
      posicionar();
   }
   );
   $( window ).scroll( function(){
      posicionar();      
   }
   );
}

var posicionar = function(){
    ims.interfaz.resize();

    var _this = $("#image");
    var imageWidth = parseInt(_this.outerWidth());
    var imageHeight = parseInt(_this.outerHeight());

    if ($('.positionbar').length == 0){
        $("#visor").height($("#carcasa").height()-$('#header').height()-25-$('#bottombar').height());
        $('#visor').css({'top':$('#header').height()+parseInt($('#header').css('padding-top')),'height':$('#carcasa').height()-parseInt($('#header').css('padding-top'))-$('#header').height()-$('#bottombar').height()});
    }else{
        $("#visor").height($("#carcasa").height()-$('#header').height()-25);
        $('#visor').css({'top':$('#header').height()+parseInt($('#header').css('padding-top')),'height':$('#carcasa').height()-parseInt($('#header').css('padding-top'))-$('#header').height()});
    }
    /*
    $('#visor').css('background','red');
    $('#contenedora').css('background','green');
    $('.jspPane').css({'background':'black','margin':0,'padding':0});
    $('#contenedora').css('top','0px');
    */
    centrar_imgs( imagenesSelectorInicial );
}

function inicializar() {
posicionar();
if ($("#url_interfaz").text() != "") {
        url_interfaz = $("#url_interfaz").text();
    };
    $("#url_interfaz").remove();
    if ($("#url_files").text() != "") {
        url_files = $("#url_files").text();
    };
    $("#url_files").remove();
    $(".ui-loader,.ui-page").remove();
    document.title = 'Santillana';
    master_xml = $.parseXML(master_xml);
    config_xml = $.parseXML(cat_xml);

    ims.interfaz.init();
    
    if (isMobile) {
        if (isiOS) {
            $("body").css("margin-top", "-20px")
        };
        $(".notdisabled").bind("touchstart", function() {
            $(this).addClass("active")
        }).bind("touchend", function() {
            $(this).removeClass("active")
        });
    }
    
    cargar_actividad();
    $("#overall").remove();

}

function cargar_actividad() {
    
    posicionar();
    var visualizar = $(master_xml).find("visualizar").text();
    ims.interfaz.addButton("play", "right", "play", ( $( master_xml ).find( "play" ).text() != "" ) ? $( master_xml ).find( "play" ).text() : "Play");
    ims.interfaz.addButton("anterior", "left", "anterior", ( $( master_xml ).find( "atras" ).text() != "" ) ? $( master_xml ).find( "atras" ).text() : "Volver");
    ims.interfaz.addButton("info", "right", "info", ( $( master_xml ).find( "info" ).text() != "" ) ? $( master_xml ).find( "info" ).text() : "Mostrar/ocultar info");

    if (!isMobile){
        ims.interfaz.addButton("resetZoom", "right", "resetZoom", ( $( master_xml ).find( "reset_zoom" ).text() != "" ) ? $( master_xml ).find( "reset_zoom" ).text() : "100%");
        ims.interfaz.addButton("zoomout", "right", "zoomout", ( $( master_xml ).find( "zoomout" ).text() != "" ) ? $( master_xml ).find( "zoomout" ).text() : "Reducir");
        ims.interfaz.addButton("zoomin", "right", "zoomin", ( $( master_xml ).find( "zoomin" ).text() != "" ) ? $( master_xml ).find( "zoomin" ).text() : "Amplicar");
        ims.interfaz.enable("zoomin");
        ims.interfaz.bind("zoomin", 'zoomin()');
    }

    ims.interfaz.enable("anterior");
    ims.interfaz.bind("anterior", 'volver()');
    
    ims.interfaz.enable("info");
    ims.interfaz.bind("info", 'info()');

    //Si es tablet y tiene alguna categoría le metemos el botón
    if ($(config_xml).find('categoria').length > 0){
        if($('.positionbar').length == 0){
            $('#left').prepend('<div id="combo"><div id="desplegable">'+todos+'</div></div>');
        }else{
            ims.interfaz.addButton("desplegable", "left", "categoria", 'Categorías');
            ims.interfaz.enable("desplegable");
        }
    }

    $('#content').append('<ul id="listado_cat"></ul>');
    //Metemos las categorías en el desplegable
    var a = 0;
    $(config_xml).find('categoria').find('nombre').each(function() {
        $('#listado_cat').append('<li>'+$(this).text()+'</li>');
        a++;
    });

    $('#listado_cat').append('<li>'+todos+'</li>');
    if (a == 0){
        $('#combo').remove();
    }

    //Quitamos el último border del li
    $('#listado_cat li:last').css('border-bottom','0px');

    //Mostramos las categorías en un listado
    $("#desplegable").bind(click,function(){

        //Situamos el listado cerca del botón
        if($('.positionbar').length == 0){
            $('#listado_cat').css({'top':$('#carcasa').height()-$('#listado_cat').height()-$('#bottombar').height(),'left':$('#desplegable').position().left});
        }else{
            $('#listado_cat').css({'top':$('#bottombar').position().top+$('#desplegable').position().top,'left':$('#visor').width()-$('#listado_cat').width()-26,'border-radius':'15px 0px 0px 15px'});
        }
        $('#listado_cat').fadeToggle('fast');
    });

    //Seleccionamos una categoria
    $("#listado_cat li").bind(click,function(){
        $(this).parent().fadeToggle('slow');
        $('#abierta').css('display','none');
        $('#anterior').css('display','none');
        $('#zoomout').css('display','none');
        $('#resetZoom').css('display','none');
        $('#zoomin').css('display','none');
        $('#info').css('display','none');

        if (hay_audio == 'si'){
            $('#play').css('display','none');
        }

        if($('.positionbar').length == 0){
            $('#desplegable').text($(this).text());
        }else{
            $('.li_seleccionado').removeClass('li_seleccionado')
            $(this).addClass('li_seleccionado');
        }
        //Centramos de nuevo las imágenes
        mostrar_imagenes($(config_xml).find('id').eq($(this).index()).text());
        centrar_imgs($('.imagen').length)
    });

    //Cargamos los audios de las imgs
    var i = 0;
    $(master_xml).find('imagen').each(function() {
        if ($(this).find('sonido').text().substring($(this).find('sonido').text().length-3, $(this).find('sonido').text().length) == 'mp3'){
            hay_audio = 'si';
            var str = '<audio height="0" width="0" id="audio_imagen_'+i+'" preload="metadata" src="'+$(this).find('sonido').text()+'"></audio>';
            $( "#visor" ).append( str );
        }
        i++;
    });

    imagenesSelectorInicial = i;

    if(hay_audio == 'si'){
        $('#play').css('display','none');
    }else{
        if ($(master_xml).find('sonido').eq(0).text().substring($(master_xml).find('sonido').eq(0).text().length-3, $(master_xml).find('sonido').eq(0).text().length) == 'mp3'){
            var str = '<audio height="0" width="0" id="audio_imagen_0" preload="metadata" src="'+$(master_xml).find('sonido').eq(0).text()+'"></audio>';
            $( "#visor" ).append( str );
            audio_global = 'si';
            activar_play();
        }else{
            $('#play').css('display','none');
        }
    }
    
    ims.interfaz.setTitle('<p>'+$(master_xml).find("tituloGaleria").text()+'</p>');

    // Metemos la capa contenedora
    $('#visor').append('<div id="relojito"><div id="pelotas"></div></div><div id="contenedora"></div>');
    //Ajustamos el relojito de tamaño para dejarlo bien "apañao"
    $('#relojito').width($('#contenedora').width());
    $('#relojito').height($('#visor').height());
    //Le metemos las pelotas dentro (no pienses mal)
    //var loading = $("<div/>").attr("id","relojito").addClass("rotate")
        $('#pelotas').append($("<div/>").attr("id","frotateG_01").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_02").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_03").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_04").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_05").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_06").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_07").addClass("f_circleG"))
        .append($("<div/>").attr("id","frotateG_08").addClass("f_circleG"));

    $('#pregunta').next().remove();
    $('#pregunta').remove();

    mostrar_imagenes(); 

    setTimeout(function() {f_scroll();}, 500);

    //Metemos la capa contenedora de la imagen una vez abierta
    contenidoHtml = '<div id="abierta"><img class="imagen_abierta" src="" /><img class="imagen_abierta2" src="" /><div class="anterior3 sprite"></div><div class="siguiente3 sprite"></div><div id="degradado"></div><div id="texto"><div id="tit"></div><div id="cuerpo"></div></div></div>';
    $('#contenedora').append(contenidoHtml);

    setTimeout(function() {
        posicionar();
        $('.anterior3').css('top',$('#visor').height()/2-$('.anterior3').height()/2);
        $('.siguiente3').css('top',$('#visor').height()/2-$('.siguiente3').height()/2);
        $('#abierta').css({'width':$('#visor').width(),'height':$('#visor').height()+2,'top':0});
    }, 600);

    //$(".imagen").bind(click, efecto_imagen($(this).index));

    if ($('.positionbar').length == 1){$('.imagen').css('width','303px');}

    //Pasamos de imagen una vez abierta
    $(".anterior3").bind(click,function(){
        eq_imagen--;
        eq_imagen_cat--;
        pasar_img('menos');
        zoomreset();
        comprobar_img();
        if (eq_imagen == 0){
            $('.anterior2').css('display','none');
        }
    });
    $(".siguiente3").bind(click,function(){
        eq_imagen++;
        eq_imagen_cat++;
        pasar_img('mas');
        zoomreset();
        comprobar_img();
    });

    //Hacemos el efecto de pasar en tablet con el dedo
    $(".imagen_abierta").swipe({
        swipe:function(event, direction, distance, duration, fingerCount) {
            if (isMobile){
                if (direction == 'right'){
                    if ($('.anterior3').css('display') == 'block'){
                        $('.anterior3').trigger(click);
                    }
                }else{
                    if ($('.siguiente3').css('display') == 'block'){
                        $('.siguiente3').trigger(click);
                    }
                }
            }
        }
    });

    centrar_imgs(i);

};

function pasar_img(pasar){
    if (con_cat == 'no'){
        //Se la ponemos a otra capa oculta...
        $('.imagen_abierta2').attr('src',$(master_xml).find('src').eq(eq_imagen).text());   
        $('.imagen_abierta').attr('src',$(master_xml).find('src').eq(eq_imagen).text());    
        $('#tit').html($(master_xml).find('titulo').eq(eq_imagen).text());
        $('#cuerpo').html($(master_xml).find('descripcion').eq(eq_imagen).text());
        if ($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().substring($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length-3, $(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length) == 'mp3'){
            $('#play').css('display','block');
            if($('#play').attr('class') == 'button_right sprite background play tool'){
                activar_play();
            }
        }else{
            $('#play').css('display','none');
        }
        }else{
        var cont = 0;
        var pass = 0;
        $(master_xml).find('categoria').each(function() {
            if ($(this).text() == id_cat){
                cont++;
                if (eq_imagen_cat < cont && pass == 0){
                    //Se la ponemos a otra capa oculta...
                    $('.imagen_abierta2').attr('src',$(this).parent().find('src').text());
                    $('.imagen_abierta').attr('src',$(this).parent().find('src').text());
                    $('#tit').html($(this).parent().find('titulo').text());
                    $('#cuerpo').html($(this).parent().find('descripcion').text());
                    if ($(this).parent().find('sonido').text().substring($(this).parent().find('sonido').text().length-3, $(this).parent().find('sonido').text().length) == 'mp3'){
                        $('#play').css('display','block');
                    }else{
                        if (hay_audio == 'si'){
                            $('#play').css('display','none');
                        }
                    }
                    pass++;
                }
            }
        });
    }   

    //Mostramos relojito para evitar el cambio de tamaño brusco de la imagen
    var contbucle = 0;
    var bucle     = setInterval(function() {
           var $img = $(".imagen_abierta2");

            //Ponemos el relojito sólo si lleva un poco cargando y vemos que no sale aun la img (así nos lo evitamos con caché o en local)
            contbucle ++;
            if (contbucle > 7){
                $('#relojito').css('display','block');
            }
           if( !!$img.length && $img[0].complete ) {
                //$('.imagen_abierta').attr('src',$('.imagen_abierta2').attr('src'));
                calcular_tam('2');
                
                $('#relojito').css('display','none');
                
                // limpiamos el intervalo
                clearInterval(bucle);
           }

    }, 30);
    
    //Paramos los audios
    var i = 0;
    if (hay_audio == 'si'){
        if ($('.pause').length == 1){
            $('.pause').addClass('play');
            $('.pause').removeClass('pause');
        }
        $('audio').each(function() {
            document.getElementsByTagName('audio')[i].pause();
            i++;
        });
    }
    zoomreset();
}

function comprobar_img(){
    if (con_cat == 'no'){
            if ($(master_xml).find('src').eq(eq_imagen-1).text() == '' || eq_imagen == 0){
                $('.anterior3').css('display','none');
            }else{
                $('.anterior3').css('display','block');
            }
            if ($(master_xml).find('src').eq(eq_imagen+1).text() == ''){
                $('.siguiente3').css('display','none');
            }else{
                $('.siguiente3').css('display','block');
            }
        
    }else{
        var cont = 0;
        var pass1 = 0;
        var pass2 = 0;
        $(master_xml).find('categoria').each(function() {
            if ($(this).text() == id_cat){      
                if (eq_imagen_cat < cont && pass1 == 0){
                    pass1++;
                }
                if (eq_imagen_cat > cont && pass2 == 0){
                    pass2++;
                }
                cont++;
            }
        });
        if (pass1 == 1){
            $('.siguiente3').css('display','block');
        }else{
            $('.siguiente3').css('display','none');
        }
        if (pass2 == 1){
            $('.anterior3').css('display','block');
        }else{
            $('.anterior3').css('display','none');
        }
    }   

    comp_info();
}

function comp_info(){
    //Ocultamos la barra negra del título/descripción si no hay nada de ambos. Si no hay nada deshabilitamos el botón
    if ($('#texto').text() == ''){
        $('#degradado').css('display','none');
        $('#texto').css('display','none');
        ims.interfaz.disable( "info" );
        ims.interfaz.bind( "info", 'nohacernada()' );
    }else{
        //$('#degradado').css('display','block');
        //$('#texto').css('display','block');
        ims.interfaz.enable( "info" );
        ims.interfaz.bind( "info", 'info()' );
    }
}

function mostrar_imagenes(categoria_eq){
    //Recorremos las imágenes y mostramos en función de la categoría escogida
    r_scroll();
    $('.imagen').remove();
    var i = 0;
    var b = -1;
    var c = -1;
    var cat = '';

    //Vemos si hay cats elegidas o no
    if ($('#desplegable').text() == todos || $('#desplegable').text() == ''){
        if (isMobile){
            if($('.li_seleccionado').text() == todos || $('.li_seleccionado').text() == ''){
                con_cat = 'no';
            }else{
                con_cat = 'si'
            }
        }else{
            con_cat = 'no';
        }
    }else{
        con_cat = 'si';
    }

    if(con_cat == 'si'){
        b++;
        //CON categoría
        $(master_xml).find('imagen').find('src').each(function() {
            if ($(this).parent().find('categoria').text() == categoria_eq){
                //Generamos el nombre del thumb
                var thumb = ((($(this).text()).split('').reverse().join('')).substring(4, ($(this).text()).length).split('').reverse().join(''));   
                //Asignamos los eq de las imgs
                var i = 0;
                var z = 0;
                //Cogemos el eq de cada imagen en función del nombre de su imagen
                $(master_xml).find('src').each(function() {     
                    var ext_img = [];
                    var ext_img = $(this).text().split('.');
                    if ($(this).text() == thumb+'.'+$(this).text().substring($(this).text().length-3)){
                        z = i;
                    }
                    i++;
                });
                //Generamos la imagen con _thumb.ext
                var ext  = [];
                var ext2 = [];
                ext = $(this).text().split('/');
                ext2 = ext[ext.length-1].split('.');
                var nom = $(this).text().replace('.'+ext2[ext2.length-1], '');
                var thumb = nom+'_thumb.'+ext2[ext2.length-1];
                if (cat == $(this).parent().parent().find('nombre').text()){
                    c++;
                }else{
                    cat = $(this).parent().parent().find('nombre').text();
                    b++;
                }
                $('#contenedora').append('<img class="imagen dragme" id="imagen_'+z+'" alt="imagen_cat_'+c+'" position="'+b+'" name="cat_'+$(this).parent().find('categoria').text()+'" src="'+thumb+'" />');
                i++;
            }
        });
    }else{
        //Con TODAS las categorías
        $(master_xml).find('src').each(function() {
            if (cat == $(this).parent().parent().find('nombre').text()){
                c++;
            }else{
                cat = $(this).parent().parent().find('nombre').text();
                b++;
            }
            //Generamos la imagen con _thumb.ext
            var ext  = [];
            var ext2 = [];
            ext = $(this).text().split('/');
            ext2 = ext[ext.length-1].split('.');
            var nom = $(this).text().replace('.'+ext2[ext2.length-1], '');
            var thumb = nom+'_thumb.'+ext2[ext2.length-1];
            $('#contenedora').append('<img class="imagen dragme" id="imagen_'+i+'" alt="imagen_cat_'+c+'" position="'+b+'" name="cat_'+$(this).parent().find('categoria').text()+'" src="'+thumb+'" />');
            i++;
        });
    }

    //$( ".imagen").bind(click, efecto_imagen);
    hover_imagenes();
    $( ".imagen").bind(click, efecto_imagen);
    r_scroll();
    setTimeout(function() {f_scroll();}, 500);

    //Quitamos el click de la imagen para el scroll en tablet
    var dragging = true;
    $('.imagen').bind('touchmove',function(){
        dragging = false;
        $( ".imagen").unbind(click);
    });

    $(document).bind( "touchend", function() { 
        $( ".imagen " ).bind(click, efecto_imagen );            
        dragging = true;
    });
}

function hover_imagenes(){
    //Hacemos el efecto del hover en las imágenes
    if (!isMobile){
        $( ".imagen" ).bind('mouseover',function() {
            $('.imagen').css('-webkit-filter','grayscale(70%)');
            $(this).css('-webkit-filter','grayscale(0%)');
        });
    }else{
        $('.imagen').css('-webkit-filter','grayscale(0%)');
    }
}

//Clikamos la imagen y la agrandamos
var efecto_imagen = function(eq_pulsada) {

    //Quitamos el scroll
    r_scroll();
    if ($('.pause').length == 1 && audio_global == 'si'){
        play_audio();
    }

    $('.imagen').css('display','none');
    $('#listado_cat').css('display','none');
    $('#info').css('display','block');
    //$('#degradado').fadeIn('slow');
    //$('#texto').fadeIn('slow');

    //Establecemos todas las posiciones posibles para la imagen cargada y su categoría
    id_cat = parseInt(($(this).attr('name')).replace('cat_',''));
    eq_imagen_cat = parseInt(($(this).attr('alt')).replace('imagen_cat_',''));
    eq_imagen = parseInt(($(this).attr('id')).replace('imagen_',''));
    eq_img_selec = eq_imagen;

    //Le ponemos el audio si lo tuviera
    if (hay_audio == 'si'){
        if (con_cat == 'si'){
            if ($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().substring($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length-3, $(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length) == 'mp3'){
                $('#play').css('display','block');
                activar_play();
            }else{
                $('#play').css('display','none');
            }
        }else{
            if ($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().substring($(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length-3, $(master_xml).find('imagen').eq(eq_imagen).find('sonido').text().length) == 'mp3'){
                $('#play').css('display','block');
                activar_play();
            }else{
                $('#play').css('display','none');
            }
        }
    }

    $('.imagen_abierta2').attr({'src':($(this).attr('src')).replace('_thumb','')+''});

    var contbucle = 0;
    var bucle     = setInterval(function() {
       var $img = $(".imagen_abierta2");

        //Ponemos el relojito sólo si lleva un poco cargando y vemos que no sale aun la img (así nos lo evitamos con caché o en local)
        contbucle ++;
        if (contbucle > 7){
            $('#relojito').css('display','block');
        }
       if( !!$img.length && $img[0].complete ) {
            $('.imagen_abierta').attr('src',$('.imagen_abierta2').attr('src'));
            calcular_tam('2');
            
            $('#relojito').css('display','none');
            
            // limpiamos el intervalo
            clearInterval(bucle);
       }

    }, 30);

    //$('.imagen_abierta').css({'height':$('#visor').height(),'width':$('#visor').width()-250});

    //Ponemos los textos de la imagen
    eq_imagen = parseInt($(this).attr('id').replace("imagen_", ""));
    $('#tit').html($(master_xml).find('titulo').eq(eq_imagen).text());
    $('#cuerpo').html($(master_xml).find('descripcion').eq(eq_imagen).text());

    $('#anterior').css('display','block');
    $('#abierta').css('display','block');
    $('#zoomout').css('display','block');
    $('#resetZoom').css('display','block');
    $('#zoomin').css('display','block');
    $( ".imagen").unbind(click, efecto_imagen);

    var move_x = 0;
    var move_y = 0;
    $( ".imagen_abierta" ).bind( "mousedown", function(e) {
        e.preventDefault();
        e.stopPropagation();
        if (!isMobile){
            $(this).css('cursor','move');
            $('#texto').fadeOut('slow');
            if ($('.anterior3').css('display') == 'block'){ante2 = 'block';}else{ante2 = '';}
            if ($('.siguiente3').css('display') == 'block'){sigue2 = 'block';}else{sigue2 = '';}
            $('.anterior3').fadeOut('slow');
            $('.siguiente3').fadeOut('slow');
            $('#degradado').fadeOut('slow');
            $(this).css({'-webkit-transition':'all 0s ease','-moz-transition':'all 0s ease','-o-transition':'all 0s ease','-ms-transition':'all 0s ease','transition':'all 0s ease'});

            item_width = $( this ).width();
            item_height = $( this ).height();

            move_x = e.pageX - parseInt($(this).css("left"));
            move_y = e.pageY - parseInt($(this).css("top"));

            if( checked == 0 ) {
               draggingObj = $( this );
               dragging = true;
            }
        }
     });

     $( document ).live( "mousemove", function( e ) {
        if (!isMobile){
            var z = parseFloat($("#limit").css("zoom"));
            if(typeof z == 'undefined'){z=1}
            //var tmp_x = (e.pageX - ($('#visor').offset().left*z))/z - $('.imagen_abierta').width()/2;
            //var tmp_y = (e.pageY - ($('#visor').offset().top*z))/z - $('.imagen_abierta').height()/2;
            var tmp_x = (e.pageX - move_x);
            var tmp_y = (e.pageY - move_y);
            move( draggingObj, tmp_x, tmp_y );
        }
     });

     $( document ).live( "mouseup", function( e ) {
        if (!isMobile){
            $('.imagen_abierta').css('cursor','pointer');
            if( dragging ) {
               suelta();
               //$('.imagen_abierta').css({'-webkit-transition':'all 0.4s ease','-moz-transition':'all 0.4s ease','-o-transition':'all 0.4s ease','-ms-transition':'all 0.4s ease','transition':'all 0.4s ease'});
               if (ante2 == 'block'){$('.anterior3').fadeIn('slow');}
               if (sigue2 == 'block'){$('.siguiente3').fadeIn('slow');}
               if ($('#texto').text() != ''){
                   //$('#degradado').fadeIn('slow');
                   //$('#texto').fadeIn('slow');
               }
            }
        }
     });

    //Quitamos las flechas para elegir las anteriores/siguientes imágenes
    var eq_click = $(this).index();
    // Con TODAS las categorías
    if (con_cat == 'no'){
        eq_click ++;
        if ($(master_xml).find('imagen').eq(eq_imagen+1).text() == ''){
            $('.siguiente3').css('display','none');
        }else{
            $('.siguiente3').css('display','block');
        }
        if ($(master_xml).find('imagen').eq(eq_imagen-1).text() == ''){
            $('.anterior3').css('display','none');
        }else{
            $('.anterior3').css('display','block');
        }
    }else{
    //Con categoría elegida
        var cont1 = 0;
        var cont2 = 0;
        var pr1 = '';
        var pr2 = '';

        $(master_xml).find('imagen').each( function() {
            if (eq_imagen < cont1 && $(master_xml).find('categoria').eq(cont1).text() == id_cat){
                pr1 = 'hay';
            }
            cont1++;
        });
        if (pr1 == 'hay'){
            $('.siguiente3').css('display','block');
        }else{
            $('.siguiente3').css('display','none');
        }
        $(master_xml).find('imagen').each( function() {
            if (eq_imagen > cont2 && $(master_xml).find('categoria').eq(cont2).text() == id_cat){
                pr2 = 'hay';
            }
            cont2++;
        });
        if (pr2 == 'hay'){
            $('.anterior3').css('display','block');
        }else{
            $('.anterior3').css('display','none');
        }
    }
    
    if (eq_imagen == 0){
        $('.anterior2').css('display','none');
    }

    //$('.imagen_abierta').load(function(){
    
    //});

    comp_info();
    //Dejamos la imagen a su tamaño...
    zoomreset();
    setTimeout(function() {
        calcular_tam('');
    }, 30);
    //Si la imagen no es muy grande ñapeamos para que redimensione de nuevo con la imagen ya cargada (o empezada a cargar)
    setTimeout(function() {
        calcular_tam('');
    }, 1000);
   
};

function calcular_tam(id){
    //Ancho y alto originales de la imagen
    var ancho_original = $('.imagen_abierta'+id).get(0).naturalWidth;
    var alto_original  = $('.imagen_abierta'+id).get(0).naturalHeight;

    //Ancho y alto final de la imagen
    var alto_final     = $('#visor').height();
    var ancho_final    = (alto_final / alto_original) * ancho_original;
    var ancho_grande   = ancho_final;

    //Si el alto y ancho es menor que el espacio de trabajo hay que aumentarla para que se queda encajada (aunque pierda calidad)
    /*if (alto_original < $('#abierta').height() && ancho_original < $('#abierta').width()){
        if (alto_original < ancho_original){
            //Horizontal
            ancho_final = $('#abierta').width();
            alto_final  = (ancho_final * alto_original) / ancho_original;
        }else{
            //Vertical
            alto_final  = $('#abierta').height();
            ancho_final  = (alto_final * ancho_original) / alto_original;
        }
    }*/

    //Lo centramos
    var cantidad1      = $('#visor').width();
    var cantidad2      = ancho_final;
    $('.imagen_abierta').css('left',(cantidad1-cantidad2)/2);

    //Si la imagen es muy muy horizontal
    if (parseInt($('.imagen_abierta').css('left')) < 0 || ancho_final == $('#abierta').width()){
        $('.imagen_abierta').css('left','0px');
        ancho_final = $('#abierta').width();
        if (parseInt($('.imagen_abierta').css('left')) < 0){
            alto_final  = ancho_final*alto_final/ancho_grande;
        }
        $('.imagen_abierta').css('top',$('#abierta').height()/2-alto_final/2);
    }else{
        $('.imagen_abierta').css('top','0px');
    }

    //console.log('ancho_final: '+ancho_final);
    //console.log('alto_final: '+alto_final);
    //console.log('$("#abierta").height(): '+$('#abierta').height());

    //Config ancho y alto
    $('.imagen_abierta').width(ancho_final);
    $('.imagen_abierta').height(alto_final);
}

function volver(){
    if (hay_audio != '' && $('#play').css('display') == 'block'){
        $('#play').css('display','none');
        $('#play').removeClass('pause').addClass('play');
        pause_audio();
    }
    if ($('positionbar') == 0){
        $('.imagen').css({'width':'304px','height':'137px'});
    }else{
        $('.imagen').css({'width':'303px','height':'137px'});
    }
    $('.imagen').toggle();
    $('.anterior3').css('display','block');
    $('.siguiente3').css('display','block');
    $('#info').toggle();
    $('#anterior').toggle();
    $('#abierta').toggle();
    $('#zoomin').toggle();
    $('#zoomout').toggle();
    $('#resetZoom').toggle();
    $( ".imagen").bind(click, efecto_imagen);

    //Al volver el audio sólo se reproduce automáticamente si tiene un poco de delay
    setTimeout(function() {
        if (audio_global == 'si' && $('.pause').length == 1){
            play_audio();
        }
    }, 600);
    
    r_scroll();
    var no = 'no';
    setTimeout(function() {f_scroll(no);}, 500);
}

//Mostrar/ocultar información de la imagen
function info(){
    //Vemos si tiene flechas de despl. o no
    /*
    if ($('#texto').css('display') == 'block'){
        if ($('.anterior2').css('display') == 'block'){
            ante2 = 'block';
        }else{
            ante2 = '';
        }
        if ($('.siguiente2').css('display') == 'block'){
            sigue2 = 'block';
        }else{
            sigue2 = '';
        }
    }

    if (ante2 == 'block'){$('.anterior2').fadeToggle();}
    if (sigue2 == 'block'){$('.siguiente2').fadeToggle();}
    */
    $('#texto').fadeToggle();
    $('#degradado').fadeToggle();
}

function f_scroll(no){
    //Hacemos la capa scrollable
    $( '#visor' ).jScrollPane( {
      showArrows : false,
      hideFocus : true
    });
    if ($('.pause').length == 1 && no != 'no'){play_audio();}
}
function r_scroll(){
    var element = $("#visor").jScrollPane().data().jsp;
    element.destroy();
}

function resetele( obj ) {
   $( "#" + obj.attr( "posicion" ) ).attr( "rel", "-1" );
   obj.attr( "posicion", "-1" );
   $( ".hotspot_arrastrar" ).each( function() {
      $( this ).css( "background", hotspotDefaultBG );
   }
   );
};

function move( obj, x, y ) {
   if( dragging && z < 3 ) {
    if (parseInt( x ) > 0 && parseInt( x ) < $('#carcasa').width()-$('.imagen_abierta').width()){
      obj.css( "left", ( parseInt( x ) ) + "px" );
    }     
    if (parseInt( y ) > 0 && parseInt( y ) > $('.imagen_abierta').height()){
      obj.css( "top", ( parseInt( y ) ) + "px" );
    }
      $( ".hotspot_arrastrar" ).each( function() {
         if ( hotspotDefaultBG == "" ) {
            hotspotDefaultBG = $( this ).css( "background" );
         }
         var colisiona = intersects( obj, $( this ) );
         if( colisiona ) {
            $( this ).css( "background", "#fbc73b" );
         }
         else {
            $( this ).css( "background", hotspotDefaultBG );
         }
      }
      );
   }
};

function suelta() {

   var obj = draggingObj;
   var counter = 0;
   var topStac = ( $( "#limit" ).height() - $( "#right" ).height() - 40 ) / 2;
   $( ".hotspot_arrastrar" ).each( function() {
      if( intersects( obj, $( this ) ) && ( $( this ).attr( "rel" ) == "-1" ) ) {
         resetele( obj );

         objoff = $( this ).offset();
         obj.css( "left", ( objoff.left - $( '#overall' ).offset().left ) + "px" );
         obj.css( "top", ( ( objoff.top - $( '#overall' ).offset().top ) - obj.height() ) + "px" );

         counter ++ ;
         obj.attr( "posicion", $( this ).attr( "id" ) );
         $( this ).attr( "rel", obj.attr( "rel" ) );
         miCSS = obj.css( "background-color" );
         if( $( master_xml ).find( "tipoInterfaz" ).text()  == "primaria" ){
            color = "#FFAF65";
         }
         else if( $( master_xml ).find( "tipoInterfaz" ).text()  == "primaria_3er" ){
            color = "#9EEAED";
         }
         else{
            color = "#78787B";
         }
         obj.animate( {
            backgroundColor : color,
         }
         , {
            duration : 100,
            easing : "easeOutBack",
            complete : function(){
               // -----------------
               obj.animate( {
                  backgroundColor : miCSS,
               }
               , {
                  duration : 100,
                  easing : "easeOutBack",
               }
               );
               // -----------------
            }
         }
         );


      }
   }
   );
   if( counter == 0 ) {
      obj.css( "left", ( parseInt( obj.attr( "x" ) ) ) + "px" );
      obj.css( "top", obj.attr( "y" ) + "px" );
      resetele( obj );

   }

   dragging = false;
   ims.interfaz.bind( "reiniciar", 'reiniciarEjercicio_dif1()' );
   ims.interfaz.enable( "reiniciar" );
};

var z = 0;
var z2 = 0;
function zoomin(){
    $('.imagen_abierta').css({'width':$('.imagen_abierta').width()*1.3,'height':$('.imagen_abierta').height()*1.3});
    if (z != 3){
        z++;
        z2--;
    }
    if (z == 1){
        a_zoomout();
        ims.interfaz.bind( "resetZoom", 'zoomreset()' );
        ims.interfaz.enable( "resetZoom" );
        z2 = 0;
    }
    if (z == 3){
        d_zoomin();
    }
    //Centramos la imagen
    setTimeout(function() {
        $('.imagen_abierta').css({'top':($('.imagen_abierta').height()/2-$('#visor').height()/2)*-1,'left':($('.imagen_abierta').width()/2-$('#visor').width()/2)*-1});
    }, 500);
}
function zoomout(){
    $('.imagen_abierta').css({'width':$('.imagen_abierta').width()/1.3,'height':$('.imagen_abierta').height()/1.3});
    if (z2 != 3){
        z2++;
        z--;
    }
    if (z == 0){
        d_zoomout();
        ims.interfaz.bind( "resetZoom", 'nohacernada()' );
        ims.interfaz.disable( "resetZoom" );
        a_zoomin();
    }
    //Centramos la imagen
    setTimeout(function() {
        $('.imagen_abierta').css({'top':($('.imagen_abierta').height()/2-$('#visor').height()/2)*-1,'left':($('.imagen_abierta').width()/2-$('#visor').width()/2)*-1});
    }, 500);
}
function zoomreset(){
    //Dejamos la imagen a su tamaño...
    //$('.imagen_abierta').css({'height':$('#visor').height(),'width':$('#visor').width()-250});
    //... y la centramos
    var cantidad1 = $('#visor').width();
    var cantidad2 = $('#visor').width()-250;
    //$('.imagen_abierta').css({'left':(cantidad1-cantidad2)/2,'top':0});
    calcular_tam('');
    ims.interfaz.bind( "resetZoom", 'nohacernada()' );
    ims.interfaz.disable( "resetZoom" );
    a_zoomin();
    d_zoomout();
    z=0;
}

function play(){
    if ($('.play').length > 0){
        $('#play').removeClass('play');
        $('#play').addClass('pause');
        play_audio();
    }else{
        $('#play').removeClass('pause');
        $('#play').addClass('play');
        pause_audio();
    }
}

function play_audio(){
    if (hay_audio == 'si'){
        if (!isiOS){
            document.getElementById('audio_imagen_'+eq_imagen).play();
            //$('audio').get(0).play();
        }else{
            $('#audio_imagen_'+eq_imagen)[0].play();
            //$('#play').trigger(click);
        }
    }else{
        if (!isiOS){
            $('audio').get(0).play();
        }else{
            $('#audio_global')[0].play();
            //$('#play').trigger(click);
        }
    }
}

function pause_audio(){
    if (hay_audio == 'si'){
        if (!isiOS && $('.pause').length == 1){
            document.getElementById('audio_imagen_'+eq_imagen).pause();
        }else{
            $('#audio_imagen_'+eq_imagen)[0].pause();
            //$('#pause').trigger(click);
        }
    }else{
        if (!isiOS){
            $('audio').get(0).pause();
        }else{
            $('#audio_global')[0].pause();
            //$('#pause').trigger(click);
        }
    }
}

function a_zoomin(){
    ims.interfaz.bind( "zoomin", 'zoomin()' );
    ims.interfaz.enable( "zoomin" );
}
function d_zoomin(){
    ims.interfaz.bind( "zoomin", 'nohacernada()' );
    ims.interfaz.disable( "zoomin" );
}
function a_zoomout(){
    ims.interfaz.bind( "zoomout", 'zoomout()' );
    ims.interfaz.enable( "zoomout" );
}
function d_zoomout(){
    ims.interfaz.bind( "zoomout", 'nohacernada()' );
    ims.interfaz.disable( "zoomout" );
}

function activar_play(){
    setTimeout(function() {
        if($('.imagen').css('display') == 'none' || audio_global == 'si'){
            ims.interfaz.bind( "play", 'play()' );
            ims.interfaz.enable( "play" );
        }else{
            $('#play').css('display','none');
        }
    }, 3000);
}

function nohacernada(){}

function centrar_imgs(cant){
    //Si no está la galería llena de imágenes esto centra a las que haya
    if (cant < 7){
        $('#contenedora').css('margin-top',$('#visor').height()/2-$('#contenedora').height()/2);
    }
    if (cant < 3){
        $('.imagen').eq(0).css('margin-left',$('#visor').width()/2-328*cant/2);
    }
}