var _events = {
	click: isMobile ? "touchstart" : "click"
}
var mySVG;

ims.actividad = {
	hots: [],
	icons: [],
	relations: [],
	zIndex: 1,
	init: function(){
		ims.interfaz.introduce();
	},
	setInterface: function(){
		ims.interfaz.emptyStage();
		
		if ( ( /MSIE (\d+\.\d+);/.test( navigator.userAgent ) && Number( RegExp.$1 ) >= 8 ) ) {
			ims.actividad.setMinZoom(100);
			ims.actividad.setMaxZoom(100);
			  
			this.disableZoomIn();
			this.disableZoomOut();      
			  
			document.attachEvent( "click", function() {
				ims.actividad.toggleZoom();
			});
		}

		$("#visor").append('<div id="zonaexplicacion" />');
		
		var _background = config_json.elementos.object.configuration;
		var _width = (_background.width) ? _background.width : $("#visor").width() - $("#zonaexplicacion").width();
		ims.interfaz.setBackgroundImage(_background.url_archivo, _background.pos_x, _background.pos_y, _width, _background.height, 0, "visor");
//		$("#fondo").css({"z-index": 1});
		
		this.setHotspots();
		this.setIcons();
		
		this.setRelationship();
		
		var _activeHotspotId = $(".explicacion").not(":hidden").first().children("._layer_").attr("id").replace("_layer_","");
		var _activeIconId = config_json.elementos.relationship[_activeHotspotId].id_icon;
		$(this.icons[_activeIconId].getPublicId()).addClass("active");
	},
	setIcons: function(){
		var _self = this;
		var _icons = config_json.elementos.object.icons;
		for(var i in _icons){
			var _icon = new iconManager(_icons[i].id, 'icon_'+i, _icons[i].x, _icons[i].y, _icons[i].width, _icons[i].height, 0, _icons[i].url_archivo, _self.zIndex++, "icon"+_icons[i].width);
			_icon.insert("visor");
			_self.icons[_icon.getId()] = _icon;

			var _hot = _self.hots[_icons[i].id_hotspot];
			_icon.setRelationship(_hot);
/*console.log('relatedObject', _icon.getRelatedObject(), _icon.getPublicId());
			if(_icon.getRelatedObject().getBehavior() == "hidden"){
				$(_icon.getPublicId()).click(function(){
console.log(_icon.getPublicId(), _icon.getRelatedObject().getPublicId());
					$(_icon.getRelatedObject().getPublicId()).toggle();
				});
			}*/
		}
		
		$(".icon").click(function(){
			var _icon = _self.icons[$(this).attr("id").replace("icon_","")];
			$(".icon").not(this).removeClass("active");
			switch(_icon.getRelatedObject().getBehavior()){
				case "fixed":
					if($(_icon.getRelatedObject().getPublicId()).parent().is(":hidden")){
						$(".explicacion").hide();
						$(_icon.getRelatedObject().getPublicId()).parent().toggle();
					}
					$(this).addClass("active");
				break;
				case "hidden":
					$(_icon.getRelatedObject().getPublicId()).parent().toggle();
					$(this).toggleClass("active");
					break;
				default:
					$(this).addClass("active");
					break;
			}
		});
	},
	setHotspots: function(){
		var _hotspots = config_json.elementos.object.hotspots;
		for(var i in _hotspots){
			var _hot = new layerManager(_hotspots[i].id_hotspot, _hotspots[i].title, _hotspots[i].pos_x, _hotspots[i].pos_y, _hotspots[i].width, _hotspots[i].height, 0, _hotspots[i].texto, this.zIndex++, _hotspots[i].behavior === "fixed", "hotspot");
			_hot.setBehavior(_hotspots[i].behavior);
			_hot.insert("zonaexplicacion");
			
			if(_hotspots[i].url_archivo){
				ims.interfaz.setBackgroundImage(_hotspots[i].url_archivo, 0.1, 0.1, _hot.getWidth(), false, 0, _hot.getIdPreffix()+_hot.getId());
			}
			
			this.hots[_hot.getId()] = _hot;
			
			switch(_hotspots[i].behavior){
				case "fixed":
					$(_hot.getPublicId()).parent(".ui-wrapper").addClass("explicacion").addClass("template-"+_hotspots[i].template);

					if($(".explicacion").length > 1){
						$(_hot.getPublicId()).parent(".explicacion").hide();
					}
					
					$(_hot.getPublicId()).find(".content-body").addClass("textoExplicacion");
					break;
				case "collapsed":
					$(_hot.getPublicId()).find(".content-body").hide();
					
					$(_hot.getPublicId()).find(".title").css({cursor: 'pointer'}).click(function(){
						$(this).parent().find(".content-body").toggle();
					});
					break;
				case "hidden":
					//check relationship
					$(_hot.getPublicId()).parent().hide();
					break;
			}
		}
	},
	setRelationship: function(){
		if(config_json.elementos.relationship){
			for(var i in config_json.elementos.relationship){
				if(config_json.elementos.relationship[i].line){
					this.drawRelationship(config_json.elementos.relationship[i].line);	
				}
			}
		}
	},
	drawRelationship: function(line){
console.log('drawRelationship', arguments);

			node1 = this.icons[line.id_icon];
			node2 = this.hots[line.id_hotspot];
console.log('nodes', node1, node2);
			if(!node1 || !node2) return false;

/*			if(mySVG === undefined){
				mySVG = $('#visor').connect();
//				$('canvas').css({width: $("#visor").width(), height: $("#visor").height(), top: $("#visor").offset().top, left: $("#visor").offset().left});
			}
			mySVG.drawLine({
				left_node: node2.getPublicId(),
				right_node: node1.getPublicId(),
//				horizantal_gap: 10,
				style: "solid",
				status: "accepted",
				error: true,
				width: line.height
			});*/
			var x1 = parseInt(node1.getX());
			var y1 = parseInt(node1.getY());
			var x2 = parseInt(node2.getX());
			var y2 = parseInt(node2.getY());
			
			var x1Width = parseInt(node1.getWidth());
			var x1Height = parseInt(node1.getHeight());
			var x2Width = parseInt(node2.getWidth());
console.log('x', x1, x1Width, x2);
			if(x1 > (x2 + x2Width)){
				x2 -= x2Width;
			}else if((x1 + x1Width) < x2){
				x1 += x1Width;
			}
			
//			if(y1 > (y2 + node2.getHeight())){
//				y2 -= node2.getHeight();
//			}else if((y1 + node1.getHeight()) < x2){
//				y1 += node1.getHeight();
//			}
			y1 += x1Height/2;
			y2 += parseInt($(node2.getPublicId()).find(".title").height())/2
			
			createLine(line.color, line.height, x1, y1, x2, y2);
	}
}

$(document).ready(function(){
	ims.interfaz.showHeader = false;
	ims.interfaz.init();
});

function createLine(color, fill, x1,y1, x2,y2){
console.log('createLine', arguments)
    var length = Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
    var angle  = Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
    var transform = 'rotate('+angle+'deg)';

    var line = $('<div>')
        .appendTo('#visor')
        .addClass('line')
        .css({
          'position': 'absolute',
          'transform': transform,
          'transform-origin': '0px 100% 0px',
          'background': color,
          'height': fill,
          'left': x1,
          'top': y1
        })
        .width(length)
//        .offset({left: x1, top: y1})
        ;

    return line;
}