var checked       = 0;
var p             = 2;
var dragging      = false;
var draggingObj   = null;

var soluciones    = [];

var xMouse        = 0;
var yMouse        = 0;
var boxHeight     = 67;

var imageBck      = "sec_";

var url_interfaz  = "";
var url_files     = "";
var iniWidth      = 0, iniHeight = 0;
var numberItems, collapse = true, tipoAleatorio = "", objeto = [];
var count         = 0;

var imgRed        = new Image();
var imgGreen      = new Image();
var imgAzul       = new Image();
var imgRemAzul    = new Image(); 
var myDatas       = new Array(); 

if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {

   window.addEventListener('DOMContentLoaded', function(e) {
      try{
         init();
         imgRemAzul.src = url_interfaz + "images/flecha_remarcada_azul.png";
         imgRemAzul.class = "image";
         
         imgAzul.src = url_interfaz + "images/flecha_azul.png";
         imgAzul.class = "image";
         
         imgGreen.src = url_interfaz + "images/flecha_verde.png";
         imgGreen.class = "image";
         
         imgRed.src = url_interfaz + "images/flecha_roja.png";
         imgRed.class = "image";
         $(".image").hide();
      }
      catch(err){
         console.log(err);
      }
      window.addEventListener("resize", posicionar, false);
      window.addEventListener("load", posicionar, false);
   });
}
else{
	$(window).ready(function () {
        init();
    });
    $(window).resize(function () {
        posicionar();
    });
    $(window).load(function () {
        posicionar();
    });
    $(window).scroll(function () {
        posicionar();
    });
}

$(window).scroll(function(){
   posicionar();
});

function posicionar() {
   ims.interfaz.resize();
   if ($("#intro_text").html() === null) {
      $("#carcasa").not(".pop_up").children().not(".pop_up").height($("#carcasa").height());

      $('#visor').height( 517 );
      $('#visor').width($('#content').width());

      if( $(".jspPane").length === 0 && typeof canvas !== "undefined" ){
         if(($("#colizquierda").outerHeight(true)+$("#header").outerHeight(true)+$("hr").outerHeight(true))>$("#visor").height() || ($("#colderecha").outerHeight(true)+$("#header").outerHeight(true)+$("hr").outerHeight(true))>$("#visor").height())
            $('#visor').jScrollPane({
               contentWidth : '0px',
               horizontalGutter : -30,
               verticalGutter : -30
            });         

         if($(".jspPane").height()<$("#visor").height()){
            canvas.height = $("#visor").height();
         }
         else{
            canvas.height = $(".jspPane").height();
         }
      }
      if( typeof canvas !== "undefined")
         canvas.redraw();
   }
   else{
      $('#visor').width($('#content').width());
      $("#carcasa").height($("#carcasa").height()).children().height($("#carcasa").height());
      $('#visor').height($('#content').height() - 60);
      $('#visor').jScrollPane({
         showArrows : false,
         hideFocus : true,
         contentWidth : '0px',
         autoReinitialise : true
      });
   }
};

function init() {
   if ($("#url_interfaz").text() !== "") {
      url_interfaz = $("#url_interfaz").text();
   }
   $("#url_interfaz,.ui-page,.ui-loader").remove();
   config_xml = $.parseXML(config_xml);
   url_files=$(config_xml).find('path').text();
   var SubTipoInterfaz = $(config_xml).find("subTipoInterfaz").text();

   document.title = "Santillana";

   tipoAleatorio = $(config_xml).find("tipoAleatorio").text();

   ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
   ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
   ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
   ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
   
   ims.interfaz.init();
   inmediastudio.TRAZA.init();
   
   $("#overall").prependTo("#content");
   if (isMobile) {
      $(".notdisabled").bind("touchstart", function() {
         $(this).addClass("active");
      }).bind("touchend", function() {
         $(this).removeClass("active");
      });
   }
   try{
      if( typeof (editable) == "undefined" && $(config_xml).find("introduccion").find("texto1").text().length != 0) {
         inicializar();
      }
      else{
         cargar_actividad();
      }
   }
   catch(err){
      console.log(err);
   }
}

function inicializar() {

   var IntTit = $(config_xml).find("palabras").find("introduccion").text();
   var IntTex = $(config_xml).find("introduccion").find("texto1").text();

   $("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');

   var comenzar = $(config_xml).find("comenzar").text();

   ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());

   $('#overall').hide();

   ims.interfaz.addButton("Siguiente", "right", "siguiente ", comenzar);
   ims.interfaz.enable("Siguiente");
   ims.interfaz.bind("Siguiente", 'nextPage()');

   posicionar();
}

function cargar_actividad() {

   $("#overall").remove();

   objeto = new drawing();
   objeto.init();

   loadContent(); 
   loadItems();

   $("canvas").appendTo("#visor");

   var tA = 0;

   bindClick();
   posicionar();
}

function loadItems() {

   var fill = "";

   $(config_xml).find("pregunta").each( function() {

      fill += "<div id=\"colizquierda\">";
      $(this).find("itemizquierda").each(function() {
         fill += "<div id=\"" + $(this).attr("id") + "\" class=\"item\">" + $(this).text().replace(/\<p(.*?)\>/g, "").replace(/<\/p>/g, "") + "</div>";
      });

      fill += "</div><div id=\"colderecha\">";
      $(this).find("itemderecha").each(function() {
         fill += "<div id=\"" + $(this).attr("id") + "\" class=\"target\"><div class='destino' id='destino'></div>" + $(this).text().replace(/\<p(.*?)\>/g, "").replace(/<\/p>/g, "") + "</div>";
      });

      $("#visor").append("" + fill + "</div>");
   });

   var margDer = Math.round(($("#fondo").height() - $("#colderecha").height()  - parseInt($("#header").outerHeight()) - parseInt($("#pregunta").outerHeight()) - 40) / 2);
   var margIzq = Math.round(($("#fondo").height() - $("#colizquierda").height()  - parseInt($("#header").outerHeight()) - parseInt($("#pregunta").outerHeight())- 40) / 2);

   if (margDer < 0 || margIzq < 0) {
      if ($("#colderecha").height() > $("#colizquierda").height()) {
         $("#visor").height($("#colderecha").height());
         margDer = 0;
      }
      else{
         $("#visor").height($("#colizquierda").height());
         margIzq = 0;
      }
   }

   if ( margDer < 0 ){
      margDer = ($("#colizquierda").height() - $("#colderecha").height()) / 2;
   }
   if ( margIzq < 0 ){
      margIzq = ($("#colderecha").height() - $("#colizquierda").height()) / 2;
   }
   $("#colderecha").css("margin-top", margDer + "px");
   $("#colizquierda").css("margin-top", margIzq + "px"); 

   var imageTarget = url_interfaz + "images/target.png";

   $(".target").each(function() {
      
      var height = $(this).outerHeight();
      var id = $(this).attr("id");
      var imagen = $("<img/>").attr({
            "src": imageTarget,
            "id":"target_" + id,
            "class":"targets"
         }).css({
            "position":"absolute",
            left:-20,
            top:(height/2)-18+'px'
         });

      $(this).append(imagen);
   });

   $("#canvas").css("z-index",0);
   
   $(".item").each(function() {
      
      var x = $(this).offset().left - $("#visor").offset().left;
      var y = $(this).offset().top - $("#visor").offset().top;

      var ancho = $(this).outerWidth(true);
      var height = $(this).outerHeight(true);

      var idi = $(config_xml).find("itemizquierda[id=" + $(this).attr("id") + "]").attr("idi");
      var idis = idi.split(",");
      var n_idis = idis.length;

      var c = 1;

      var pintWidth = $("#carcasa").offset().left + $("#carcasa").width() - 20;
      var myId = $(this).attr("id");
   
      while(c <= n_idis) {
   
         myDatas[myId] = idis ;
   
         if(isIE === true && version === 8) {
            $("#content").append("<div class=\"paint\" id=\"linerow" + c + "_" + $(this).attr("id") + "\"  style=\"position: absolute;  z-index:2000; top:0; left:0;width:730px;height=\"" + ($("#right").offset().top) + "\"  \" ></div>");
         }
         else{

            var imgAzulSrc = url_interfaz + "images/flecha_azul.png";
            var linea = objeto.drawLine(x + ancho, y + (height / 2) - 2, x + ancho + 10, y + (height / 2) - 2, idi, "#48a9da", "5px", imgAzulSrc,myId,false);
            var imagen = $("<img/>").attr({
               "src":imgAzulSrc,
               "id":"row_" + myId,
               "class":"rows",
               "x":x+ ancho + 5,
               "y":y+ (height / 2) - 20,
               "class":"rows",
               "clicked":"false"
            }).css({
               "position":"absolute",
               "top":y+ (height / 2) - 20,
               "left":x+ ancho + 5,
               "z-index":1
            });

            imagen.get(0).myData = idi;
            imagen.get(0).myLine = linea;
            
            $("#visor").append(imagen);
         }
         c++;//C#
      }
   });
}

function bindClick(e){
      
   var tA = 0;

   $("#ayuda").click(function(){
     if (tA === 0) {
        $("#content_ayuda").width($("#content_ayuda").width());
        $('#content_ayuda').jScrollPane({
           showArrows : false,
           hideFocus : true
        });
        tA++;
     }
   });

   if(isMobile){

      $(".rows").live( "click", function(event){

         $(".aspa").remove();

         if( dragging === false ){

            draggingObj = $(this);

            if( $(this).attr("clicked")=="false" ){
               dragging = true;
               var imgRemAzulSrc = url_interfaz + "images/flecha_remarcada_azul.png";
               draggingObj.attr("src",imgRemAzulSrc);
            }
            else {
               var aspa = $("<div/>").css({
                  "top":parseInt($(this).offset().top)-$("#visor").offset().top,
                  "left":parseInt($(this).offset().left)-$("#visor").offset().left+$(this).width(),
               }).append("X").addClass("aspa");

               aspa.get(0).object = draggingObj;

               aspa.bind( "click", function(event){
                  
                  draggingObj = $(this).get(0).object;
                  if(draggingObj.attr( "clicked" ) == "true"){
                     draggingObj.css({
                        top:parseInt(draggingObj.attr("y")),
                        left:parseInt(draggingObj.attr("x"))
                     });
                     var imgAzulSrc = url_interfaz + "images/flecha_azul.png";
                     draggingObj.attr("src",imgAzulSrc).attr("clicked","false");
                     draggingObj.get(0).myLine.end.x = parseInt(draggingObj.attr("x"))+18;
                     draggingObj.get(0).myLine.end.y = parseInt(draggingObj.attr("y"))+18;
                     draggingObj.get(0).compareData = 0;

                     draggingObj.css({
                        "transform": "rotate(0deg)",
                        "-ms-transform": "rotate(0deg)",
                        "-moz-transform": "rotate(0deg)",
                        "-webkit-transform": "rotate(0deg)"
                     });   
   // var w = canvas.width;
   // var h = canvas.height;   // save old width/height
   // canvas.width = canvas.height = 0;  //set width/height to zero
   // canvas.width=w;
   // canvas.height=h;
                     canvas.redraw();
                     draggingObj = null;
                     dragging = false;
                     $(this).remove();
                  }
               });
               
               $("#visor").append(aspa);
            }
         }
         else {

            if(draggingObj!=null && dragging == true && $(this).attr("clicked")=="true"){
            
               var _this = $(this);
            
               draggingObj.css({
                  top:_this.offset().top-$("#visor").offset().top,
                  left:_this.offset().left-$("#visor").offset().left
               });
            
               draggingObj.get(0).myLine.end.x = _this.offset().left-$("#visor").offset().left+18;
               draggingObj.get(0).myLine.end.y = _this.offset().top-$("#visor").offset().top+18;
               draggingObj.get(0).compareData = $(this).get(0).compareData;

   // var w = canvas.width;
   // var h = canvas.height;   // save old width/height
   // canvas.width = canvas.height = 0;  //set width/height to zero
   // canvas.width=w;
   // canvas.height=h;

               canvas.redraw();
               
               var imgAzulSrc = url_interfaz + "images/flecha_azul.png";
               draggingObj.attr("src",imgAzulSrc).attr("clicked","true");
               rotation(draggingObj);
               draggingObj = null;
               dragging = false;
            }
         }
      });

      $(".targets").live("click",function(event){

         if( draggingObj != null && dragging == true ){
            
            var _this = $(this);

            var _desfasajeBarraDesplazamiento = $('#visor').data('jsp') && $('#visor').data('jsp').getContentPositionY() || 0 ;
            
            draggingObj.css({
               top:_this.offset().top-$("#visor").offset().top-4 + _desfasajeBarraDesplazamiento,
               left:_this.offset().left-$("#visor").offset().left-4
            });

            draggingObj.get(0).myLine.end.x = _this.offset().left-$("#visor").offset().left+18-4;
            draggingObj.get(0).myLine.end.y = _this.offset().top-$("#visor").offset().top+18-4 + _desfasajeBarraDesplazamiento;
            draggingObj.get(0).compareData = $(this).attr("id").replace("target_","");

   // var w = canvas.width;
   // var h = canvas.height;   // save old width/height
   // canvas.width = canvas.height = 0;  //set width/height to zero
   // canvas.width=w;
   // canvas.height=h;

            canvas.redraw();
            var imgAzulSrc = url_interfaz + "images/flecha_azul.png";
            draggingObj.attr("src",imgAzulSrc).attr("clicked","true");
            rotation(draggingObj);

            draggingObj = null;
            dragging = false;
         }
      });
   }
   else{

      $(".rows").live( "mousedown", function(event){

         event.preventDefault();
         dragging = true;
         draggingObj = $(this);

         if(isMoz === true){
            var z = ($("#limit").css("-moz-transform"));
         }
         else{
            var z = parseFloat($("#limit").css("zoom"));
         }
         
         if( z == 'none' || typeof z === 'undefined' ){
            z = 1;
         }

         xMouse = event.pageX - $(this).offset().left*z;
         yMouse = event.pageY - $(this).offset().top*z;
         xMouse = xMouse/z;
         yMouse = yMouse/z;
      });

      $(document).bind("mousemove",function(event){

         if( dragging === true ){
         
            var jsTop = 0;

            if(parseInt($(".jspPane").css("top"))){
               jsTop = parseInt($(".jspPane").css("top"));
            }
            
            if(isMoz === true){
               var z = ($("#limit").css("-moz-transform"));
            }
            else {
               var z = parseFloat($("#limit").css("zoom"));
            }
            
            if( z == 'none' || typeof z === 'undefined' ){
               z = 1; 
            } 
            
            var leftOriginalZoom = event.pageX - ( $("#visor").offset().left*z );
            var leftO = leftOriginalZoom/z;
            var topOriginalZoom = event.pageY-( $("#visor").offset().top+ jsTop*z );
            var topO = (topOriginalZoom/z);
            
            move( draggingObj, leftO-xMouse, topO-yMouse );
         }
      });
      
      $(document).bind( "mouseup", function(){
         
         if( draggingObj !== null ){
            suelta();
         }

         dragging = false;
         draggingObj = null;
      });
   }
}

function loadContent() {   
   var titulo = $(config_xml).find("introduccion").find("titulo").text();
   var enunciado = $(config_xml).find("enunciado").text().replace("<p>", "").replace("</p>", "");
   ims.interfaz.setTitle(titulo);
   
   $("#pregunta").append(enunciado);
   if ($(config_xml).find("pregunta").find("foto").length !== 0) {
      var foto_object = $(config_xml).find("pregunta").find("foto");
      var foto = foto_object.text();
      var rotation = foto_object.attr("rotacion");
      var width = foto_object.attr("width");
      var height = foto_object.attr("height");
      var x = foto_object.attr("x");
      var y = parseInt(foto_object.attr("y"));
      if(foto !== ''){
         if(isIE && version === 8){
            foto = url_files + foto;

            $("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
            if(x === "" && y === ""){
               height = parseInt($('#fondo div img').height());
               width = parseInt($('#fondo div img').width());
               if(width < $("#fondo").width() || height < $("#fondo").height()){
                  x = $("#fondo").offset().left + $("#fondo").width() - width;
                  y = $("#fondo").offset().top + $("#fondo").height() - height;
                  $('#fondo div img').css({
                     "margin-left" : x + "px ",
                     "margin-top" : +y + "px"
                  });
               }
            }
         }
         else{
            $('#fondo').css("background-image", "url("+url_files + foto + ")");
            $('#fondo').css("background-repeat", "no-repeat");
            
            if(rotation !== ''){
               $('#fondo').css("rotation", rotation);
               if (x !== '' || y !== '') {
                  $('#fondo').css("background-position", x + "px " + y + "px");
                  if(width !== '' && height !== ''){
                     $('#fondo').css("background-size", width + "px " + height + "px");
                  }
                  else{
                     if(height !== ''){
                        $('#fondo').css("background-size", "auto " + height + "px");
                     }
                     else{
                        if(width !== ''){
                           $('#fondo').css("background-size", width + "px auto");
                        }
                     }
                  }
               }
            }
         }
         url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
         bgImg = $('<img />');
         bgImg.hide();
         if(x === "" && y === ""){
            bgImg.bind('load', function() {
               height = parseInt($(this).height());
               width = parseInt($(this).width());
               if (width < $("#fondo").width() || height < $("#fondo").height()) {
                  x = $("#fondo").offset().left + $("#fondo").width() - width;
                  y = $("#fondo").offset().top + $("#fondo").height() - height;
                  $('#fondo').css("background-position", x + "px " + y + "px");
               }
               bgImg.remove();
            });
         }
         $('#fondo').append(bgImg);
         bgImg.attr('src', url);
      }
   }

   var silenciar   = $(config_xml).find("silenciar").text();
   var ayuda       = $(config_xml).find("palabras").find("ayuda").text();
   var comprobar   = $(config_xml).find("comprobar").text();
   var clave       = $(config_xml).find("desarrollo").text();
   var imprimir    = $(config_xml).find("imprimir").text();
   var versolucion = $(config_xml).find("versolucion").text();
   var reiniciar   = $(config_xml).find("reiniciar").text();
   var volver      = $(config_xml).find("volver").text();
   
   if (!isMobile && $(config_xml).find("urlimprimir").text().length>0){
      ims.interfaz.addButton("imprimir", "left", "imprimir", imprimir);
   }
   if(!isMobile){
      ims.interfaz.addButton("silenciar", "left", "silenciar", silenciar);
   }
   ims.interfaz.addButton("Anterior", "left", "anterior", volver);
   ims.interfaz.addButton("ayuda", "right", "ayuda", ayuda);
   ims.interfaz.addButton("comprobar", "right", "comprobar", comprobar);
   ims.interfaz.addButton("versolucion", "right", "versolucion", versolucion);
   ims.interfaz.addButton("clave", "right", "clave", clave);
   ims.interfaz.addButton("reiniciar", "right", "reiniciar", reiniciar);

    //añadir boton icon de mostrar/ocultar la orden 
    
    $('#pregunta').addClass('pregunta_inf');
    //$('#pregunta').css('position','absolute');

   introduce_retorno();

   if ($(config_xml).find("introduccion").find("texto1").text().length !== 0) {
      ims.interfaz.enable("Anterior");
      ims.interfaz.bind("Anterior", 'prevPage()');
   }
   
   ims.interfaz.enable("silenciar");

   if(ims.interfaz.sound){
      ims.interfaz.bind("silenciar", "mute()");
   }
   else{
      ims.interfaz.bind("silenciar", "play()");
   }

   if($(config_xml).find("ayuda").find("texto1").text().length !== 0){
      ims.interfaz.addPopup("ayuda", "ayuda");
      $(config_xml).find("ayuda").each(function() {
         var ayudaTit = $(this).find("titulo").text();
         var ayudaTex = $(this).find("texto1").text();
         $('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
         $('#content_ayuda').append(ayudaTex);
      });
      ims.interfaz.resize();
   }

   ims.interfaz.bind("reiniciar", 'reload()');
   ims.interfaz.bind("comprobar", 'comprobar()');
   ims.interfaz.bind("imprimir", "imprimir()");
   ims.interfaz.enable("reiniciar");
   ims.interfaz.enable("comprobar");
   ims.interfaz.enable("imprimir");
}

function advancedIntersect( obj1, obj2 ){

   var _indiceInterseccion = 0;
   
   var obj1x = obj1.offset().top;
   var obj1y = obj1.offset().left;
   var obj2x = obj2.offset().top;
   var obj2y = obj2.offset().left;
   var obj1w = obj1.width();
   var obj1h = obj1.height();
   var obj2w = obj2.width();
   var obj2h = obj2.height();

   var ix, iy;

   if( obj1x < obj2x ){
      ix = obj1x + obj1w - obj2x;
   }
   else{
      ix = obj2x + obj2w - obj1x;
   }

   if( obj1y < obj2y ){
      iy = obj1y + obj1h - obj2y;
   }
   else{
      iy = obj2y + obj2h - obj1y;
   }

   ix = ( ix > 0 ) ? ix : 0;
   iy = ( iy > 0 ) ? iy : 0;

   return ix * iy;
}

function suelta() {
   
      var obj = draggingObj;
      var counter = 0;

      // vale aquí vamos a hacer una buena...
      // calculamos el índice de intersección... con el objeto rotado...
      var _destinosPosibles = $(".targets");
      var _indiceInterseccionDestinos = [];

      _destinosPosibles.each( function(){
         var _indiceInterseccion;
         _indiceInterseccion = advancedIntersect( obj, $(this) );
         _indiceInterseccionDestinos.push( _indiceInterseccion );
      });

      var _elMasProbable = Math.max.apply( Math, _indiceInterseccionDestinos );
      var _destinoMasProbable = false;

      if ( _elMasProbable != 0 ){
         _destinoMasProbable = $( _destinosPosibles.get( _indiceInterseccionDestinos.indexOf( _elMasProbable ) ) ); 
      }

      if( _destinoMasProbable && _destinoMasProbable.attr("id") ){

         var _objOff = _destinoMasProbable.offset();

         counter++;

         // $(".jScrollPane").getContentPositionY()
         //console.log( _objOff.top, $("#visor").offset().top, $('#visor').data('jsp').getContentPositionY() );
         var _desfasajeBarraDesplazamiento = $('#visor').data('jsp') && $('#visor').data('jsp').getContentPositionY() || 0 ;

         obj.attr({
            "posicion" : "0"
         }).css({
            'top': _objOff.top - $("#visor").offset().top-4 + _desfasajeBarraDesplazamiento,
            'left': _objOff.left - $("#limit").offset().left-4
         }).get(0).compareData = _destinoMasProbable.attr("id").replace("target_","");

         rotation( obj );

         var _row = obj.get(0).myLine;

         _row.end.x = parseInt(_objOff.left - $("#limit").offset().left)+18 ;
         _row.end.y = parseInt(_objOff.top - $("#visor").offset().top)+18 + _desfasajeBarraDesplazamiento ;

         canvas.redraw();
         //return false;
      }
   
   // $(".targets").each( function(){
   //    if( intersects( obj, $(this) ) && $(this).attr("id") ){
   //       objoff = $(this).offset();
   //       counter++;
   //       obj.attr({
   //          "posicion" : "0"
   //       }).css({
   //          'top':$(this).offset().top-$("#visor").offset().top-4,
   //          'left':$(this).offset().left-$("#limit").offset().left-4
   //       }).get(0).compareData = $(this).attr("id").replace("target_","");
   //       var self = $(this);
   //       rotation(obj);
   //       var _row = obj.get(0).myLine;
   //       _row.end.x = parseInt(self.offset().left-$("#limit").offset().left)+18;
   //       _row.end.y = parseInt(self.offset().top-$("#visor").offset().top)+18;
   //       canvas.redraw();
   //       console.log( $(this) );
   //       return false;
   //    }
   // });
   
   if (counter === 0){
      resetele(obj);
   }

   dragging = false;
}

function resetele(obj) {
   obj.css({
      "left" : obj.attr("x") + "px",
      "top" : obj.attr("y") + "px"
   }).attr("posicion", "-1").get(0).compareData = 0;
   obj.get(0).myLine.end.x = parseInt(obj.attr("x"))+18;
   obj.get(0).myLine.end.y = parseInt(obj.attr("y"))+18;

   // var w = canvas.width;
   // var h = canvas.height;   // save old width/height
   // canvas.width = canvas.height = 0;  //set width/height to zero
   // canvas.width=w;
   // canvas.height=h;

   canvas.redraw();
   
   $("#hotspot_" + obj.attr("id")).attr("id", "");
   $("#" + obj.attr("posicion")).attr("rel", "-1");
   
   obj.css({
      "transform": "rotate(0deg)",
      "-ms-transform": "rotate(0deg)",
      "-moz-transform": "rotate(0deg)",
      "-webkit-transform": "rotate(0deg)"
   });   
}

function move(obj, x, y) {
   if (dragging){
      obj.css({
         "left" : (parseInt(x)) + "px",
         "top" : (parseInt(y)) + "px"
      });
      rotation(obj);
      obj.get(0).myLine.end.x =parseInt(x)+18;
      obj.get(0).myLine.end.y =parseInt(y)+18;
   
      // var w = canvas.width;
      // var h = canvas.height;   // save old width/height
      // canvas.width = canvas.height = 0;  //set width/height to zero
      // canvas.width=w;
      // canvas.height=h;

      canvas.redraw();
   }
}

function intersects(obj1, obj2) {

   obj1x = parseInt(obj1.css("left"));
   obj1y = parseInt(obj1.css("top"));
   obj2x = parseInt(obj2.css("left"));
   obj2y = parseInt(obj2.css("top"));
   
   obj1width = obj1.width();
   obj1height = obj1.height();
   obj2width = obj2.width();
   obj2height = obj2.height();
   
   obj1off = obj1.offset();
   obj2off = obj2.offset();

   if (obj1off.left + obj1width < obj2off.left) {
      return false;
   }
   if (obj1off.top + obj1height < obj2off.top) {
      return false;
   }
   if (obj1off.left > obj2off.left + obj2width) {
      return false;
   }
   if (obj1off.top > obj2off.top + obj2height) {
      return false;
   }
   return true;
}

function getRandomArray(min, max) {
   var A = [];
   while (max >= min)
   A.push(max--);
   A.sort(function() {
      return .5 - Math.random();
   });
   return A[0];
}

function comprobar() {  
   
   if (checked === 0 && $("#comprobar").hasClass("notdisabled")) {
      
      if(isMobile){
         $(".rows").die("click");
      }
      $(".rows").die("mousedown");
   
      // var w = canvas.width;
      // var h = canvas.height;   // save old width/height
      // canvas.width = canvas.height = 0;  //set width/height to zero
      // canvas.width=w;
      // canvas.height=h;
      
      if ($(config_xml).find("solucion").find("texto1").text().length !== 0) {
         if ( inmediastudio.TRAZA.mostrarSolucion ) { 
            ims.interfaz.addPopup("solucion", "clave");
            ims.interfaz.enable("clave");
         }
         $("#content_solucion").height($("#content_solucion").height() - 20);
         var tS = 0;
         $("#clave").click(function() {
            if (tS === 0) {
               $("#content_solucion").width($("#content_solucion").width() );
               $('#content_solucion').jScrollPane({
                  showArrows : false,
                  hideFocus : true
               });
               tS++;
            }
            ims.interfaz.resize();
         });
         $(config_xml).find("solucion").each(function() {
            var solucionTit = $(this).find("titulo").text();
            var solucionTex = $(this).find("texto1").text();
            $('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
            $('#content_solucion').append(solucionTex);
         });
      }
      var sumW = 4;
      var sumH = 2;
      var total = 0;
      var correct = 0, hots, removeData = false, data = "";
      var c=0;
      for (var n = 0; n <= $(".rows").length - 1; n++) {    
         var _this = "";
         _this = $(".rows")[n];
         if ( typeof (_this.myLine) != "undefined") {
            total++;
         }     
         var _this_row = _this.myLine;
         if(typeof _this.myData != "undefined") if(_this.myData.indexOf(",")!=-1) {
            data = _this.myData.split(",");
         
            for(var i = 0;i<= data.length-1;i++) {

               if (data[i] == _this.compareData) {
                  correct++;
                  if ( inmediastudio.TRAZA.mostrarSolucion ) { 
                     var imageItem = url_interfaz + "images/flecha_verde.png";
                     $(_this).attr("src", imageItem);
                     _this_row.stroke = "5px #39B54A";
                     canvas.redraw();
                  }
                  
                  data = jQuery.grep(data, function (a) { return a != data[i]; });
                  removeData = true;
                  i=data.length;
               }
               else{
                  if( typeof (_this_row) != "undefined") {
                     if ( inmediastudio.TRAZA.mostrarSolucion ){ 
                        var imageItem = url_interfaz + "images/flecha_roja.png";
                        $(_this).attr("src", imageItem);
                        _this_row.stroke = "5px #FF0000";
                     }
                  }
                  else{
                     if ( inmediastudio.TRAZA.mostrarSolucion ) { 
                        var imageItem = url_interfaz + "images/flecha_roja.png";
                        $(_this).attr("src", imageItem);
                        _this_row.stroke = "5px #FF0000";
                     }
                  }
               }
            }
         }
         else{
            if (_this.myData == _this.compareData) {
               correct++;  
                  if ( inmediastudio.TRAZA.mostrarSolucion ){ 
                     var imageItem = url_interfaz + "images/flecha_verde.png";
                     $(_this).attr("src", imageItem);
                     _this_row.stroke = "5px #39B54A";
                  }
            }
            else{
               if( typeof (_this_row) != "undefined") {
                  if ( inmediastudio.TRAZA.mostrarSolucion ){ 
                     var imageItem = url_interfaz + "images/flecha_roja.png";
                     $(_this).attr("src", imageItem);
                     _this_row.stroke = "5px #FF0000";
                     canvas.redraw();
                  }
               }
            }
         }
         rotation($(_this));
      }
      canvas.redraw();
      if ( inmediastudio.TRAZA.mostrarSolucion ) { 
         $(".green").each(function() {
            ims.interfaz.showStars($(this).offset().left, $(this).offset().top, "center", $(this).attr("id"));
            ims.interfaz.showStars($(this).offset().left + $(this).width(), $(this).offset().top, "right", $(this).attr("id"));
         });
      }

      ims.interfaz.disable("comprobar");
      $("#comprobar").unbind('click');

      if ( inmediastudio.TRAZA.mostrarSolucion ) { 
         ims.interfaz.bind("versolucion", 'solucion()');
         ims.interfaz.enable("versolucion");
      }
      else {
         $("#reiniciar").unbind('click');
         $("#reiniciar").removeClass("notdisabled");
         $("#Anterior").unbind('click');
         $("#Anterior").removeClass("notdisabled");
      }
      
      if ( correct == total ) {
         var sound = "rGood";
      } 
      else {
         var sound = "rBad";
      }
      
      ims.interfaz.showResults("<p>" + correct + " / " + total + "</p>");
      
      if ( inmediastudio.TRAZA.mostrarSolucion ) { 
         ims.interfaz.playSound(sound);
      }
      if ( inmediastudio.TRAZA.guardarRespuesta ) { 
         inmediastudio.RESULTADOS.guardarPuntuacion( correct/total );
      }  
   }
}

function solucion() {

   if ($("#versolucion").hasClass("notdisabled")) {
      // var w = canvas.width;
      // var h = canvas.height;   // save old width/height
      // canvas.width = canvas.height = 0;  //set width/height to zero
      // canvas.width=w;
      // canvas.height=h;
      
      $(".stars").remove();
      
      var i = 0;
      var _hots = new Array(), 
          _rows = new Array(), 
          nz_rows = 0, 
          removeData = false, 
          data = "";
      var checked = new Array(),
          c=0;
      
      var _desfasajeBarraDesplazamiento = $('#visor').data('jsp') && $('#visor').data('jsp').getContentPositionY() || 0 ;

      for(var n = 0; n<= $(".rows").length-1;n++) {

         var _this = $(".rows").get(n);
         var _line = _this.myLine;
         var _data = _this.myData;
         var _id   = $(".rows").eq(n).attr("id").replace("row_","");
         //console.log(_id)

         if(_data!=="") if(_data.indexOf(",")!=-1){
      
            _data = _data.split(",");
            var _dataL = _data.length;
      
            for(var i = 0; i<=_dataL-1;i++){
      
               var thisData = _data[i];
      
               if(checked[_id]==thisData){
                  var index = _data.indexOf(thisData);
                  //_data.splice(index,1)
               }

               if (( typeof (_this.myLine) != "undefined") && myDatas[_id].indexOf(thisData)!=-1) {
                  var _this_row = _this.myLine;
                  var imageItem = url_interfaz + "images/flecha_verde.png";
                  $(_this).attr("src", imageItem);
                  checked[_id]=thisData;
                  //line
                  _this_row.stroke = "5px #39B54A";
                  $(_this).css({
                     top:parseInt($("#target_"+thisData).offset().top)-($("#visor").offset().top)-4 + _desfasajeBarraDesplazamiento,
                     left:parseInt($("#target_"+thisData).offset().left)-($("#visor").offset().left)-4
                  });
                  _this_row.end.x = parseInt($("#target_"+thisData).offset().left)-($("#visor").offset().left)+18;
                  _this_row.end.y = parseInt($("#target_"+thisData).offset().top)-($("#visor").offset().top)+18 + _desfasajeBarraDesplazamiento;
                  //_this.rotation = objeto.getAngle(_this_row.start.x, _this_row.start.y, _this_row.end.x, _this_row.end.y);
                  var index = myDatas[_id].indexOf(thisData);
                  myDatas[_id].splice(index,1);
                  i=_data.length-1;
                  canvas.redraw();
                  rotation($(_this));
               }
            }
         }
         else{
            if (( typeof (_this.myLine) != "undefined")) {
               var _this_row = _this.myLine;
               _this_row.stroke = "5px #39B54A";

               var imageItem = url_interfaz + "images/flecha_verde.png";
               $(_this).attr("src", imageItem);

               $(_this).css({
               top:parseInt($("#target_"+_data).offset().top-($("#visor").offset().top))-4 + _desfasajeBarraDesplazamiento,
               left:parseInt($("#target_"+_data).offset().left)-($("#visor").offset().left)-4
               });
               _this_row.end.x = parseInt($("#target_"+_data).offset().left)-($("#visor").offset().left)+18;
               _this_row.end.y = parseInt($("#target_"+_data).offset().top)-($("#visor").offset().top)+18 + _desfasajeBarraDesplazamiento;

               canvas.redraw();
               rotation($(_this));
            }
         }
         rotation($(_this));
      }
      //Guardar Elementos
      
      /*for (var n = 0; n <= $(".rows").length - 1; n++) {
         c=0;
         var _this = $(".rows")[n];
         if(typeof _this.myData != "undefined")
            if(_this.myData.indexOf(",")!=-1){
               data = _this.myData.split(",");
               for(var i = 0;i<= data.length-1;i++){
                  if(checked[_this.id]==data[i]){
                     var index = data.indexOf(data[i]);
                     data.splice(index,1)
                     console.log(data)
                  }
                  if (_this.type == "image" && ( typeof (_this.lines) != "undefined") && myDatas.indexOf(data[i])!=-1) {
                     //alert("a")
                        var _this_row = _this.myLine;
                        _this.checked = true;
                        var imageItem = url_interfaz + "images/flecha_verde.png";
                        $(_this).attr("src", imageItem);

                        //polygon
                        _this.x = objCanvasHots[data[i]].x;
                        _this.y = objCanvasHots[data[i]].y;
                        checked[_this.id]=data[i];
                        //line
                        _this_row.stroke = "5px #39B54A";
                        _this_row.end.x = objCanvasHots[data[i]].x;
                        _this_row.end.y = objCanvasHots[data[i]].y;

                        _this.rotation = objeto.getAngle(_this_row.start.x, _this_row.start.y, _this_row.end.x, _this_row.end.y);
                        var index = myDatas.indexOf(data[i])
                        myDatas.splice(index,1);
                        i=data.length;
                        canvas.redraw();
                        
                  }
               }
            }else{

               if (_this.type == "image" && ( typeof (_this.lines) != "undefined") && typeof (objCanvasHots[_this.myData]) != "undefined") {
                  var _this_row = _this.myLine;

                  var imageItem = url_interfaz + "images/flecha_verde.png";
                   $(_this).attr("src", imageItem);

                  //polygon
                  _this.x = objCanvasHots[_this.myData].x;
                  _this.y = objCanvasHots[_this.myData].y;

                  //line
                  _this_row.stroke = "5px #39B54A";
                  _this_row.end.x = objCanvasHots[_this.myData].x;
                  _this_row.end.y = objCanvasHots[_this.myData].y;

                  _this.rotation = objeto.getAngle(_this_row.start.x, _this_row.start.y, _this_row.end.x, _this_row.end.y);

                  canvas.redraw();
               }
            }
      }*/

      $("#center").hide();
      ims.interfaz.disable("versolucion");
      var sound = "good";
      
      ims.interfaz.playSound(sound);

      return false;
   }
}

function imprimir() {
   
   window.open($(config_xml).find("urlimprimir").text());
}

function prevPage() {
   $(".stars").remove();
   $(".tooltip").remove("");
   $("#limit").remove("");
   ims.interfaz.init();
   $("#overall").hide();
   inicializar();
}

function nextPage() {
   checked = 0, collapse = true;
   $("#limit,.tooltip,#intro_text").remove("");
   ims.interfaz.init();
   cargar_actividad();

   if (!ims.interfaz.sound) {
      mute();
   }
   posicionar();
}

function reload() {

   for (var n = 0; n <= canvas.children.length - 1; n++) {
      var _this = canvas.children[n];
      if (_this.type == "image") {
         _this.img.src=url_interfaz + "images/flecha_azul.png";
      }
   }
      
   checked = 0, collapse = true;
   $("#limit,.tooltip").remove("");
   ims.interfaz.init();
   $("#overall").prependTo("#content");
   $(".item-arrastrar").die("mousedown");
   $(".hotspot").die("click");
   cargar_actividad();

   if (!ims.interfaz.sound) {
      mute();
   }
   posicionar();
}

function mute() {
   $('.tooltip').hide();
   $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
   $('#silenciar').removeClass('silenciar');
   $('#silenciar').addClass('silenciar_on');
   $('#silenciar').tooltip();
   ims.interfaz.bind("silenciar", "play()");
   ims.interfaz.disableSound();
}

function play() {
   $('.tooltip').hide();
   $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
   $('#silenciar').removeClass('silenciar_on');
   $('#silenciar').addClass('silenciar');
   $('#silenciar').tooltip();
   ims.interfaz.bind("silenciar", "mute()");
   ims.interfaz.enableSound();
}

var rotation = function(e) {
   var _this = e;
   var y1 = _this.position().top;
   var y2 = parseInt(_this.attr("y"));
   var x1 = _this.position().left+18;
   var x2 = parseInt(_this.attr("x"))-20;
   
   Y = y1 - y2;
   X = x1 - x2;
   angulo = (Math.atan2(Y, X) * 180 / Math.PI);
   _this.css({
      "transform": "rotate(" + angulo + "deg)",
      "-ms-transform": "rotate(" + angulo + "deg)",
      "-moz-transform": "rotate(" + angulo + "deg)",
      "-webkit-transform": "rotate(" + angulo + "deg)"
   });      
};

function toggle_enunciado(){
    $('#pregunta').fadeToggle();
}