var select ="";
var button ="";
var buscador="";
var cabecera=[];
var interfaz;

$(document).ready(function() {	
	
	interfaz = $('body').attr('class');
	
	if(interfaz == 'interfaz_271' || interfaz == 'interfaz_272' || interfaz == 'interfaz_285'){
		$('input[type=text]').remove();
		$('input[type=button]').remove();
		
		buscar = $('#texto_buscar').val();
		todos = $('#texto_todos').val();
		
		$('input[type=button]').attr('class','btn resetFilters');
		buscador =  '<button class="btn resetFilters">'+todos+'</button>'+
					'<div class="input-group buscador">' +
					'	<input type="text" placeholder="'+buscar+'" class="buscar form-control">'+
					'	<span class="input-group-btn">'+
					'		<button type="button" class="btn icon-magnifier"></button>'+
					'	</span>'+
					'</div>';
		$('#header').append(buscador);
	}
	
	//Datos del json
	data = jQuery.parseJSON(data);
	
	// Proceso los datos en busca de filtros  
	$.each(data, function() {
		if (this.name == "config") {
			$(this.elementos).each(function(){
				if (this.nombre == "buscador" && this.valor == "0") {
					$('.buscar').hide();
					if($('.input-group.buscador').size()>0){
						$('.input-group.buscador').css('display','none');
					}
				}
			}); 
		}
		
		if(interfaz == 'interfaz_271' || interfaz == 'interfaz_272' || interfaz == 'interfaz_285'){
			if (this.name == "filtros") {
				$(this.elementos).each(function(i){
					cabecera[i] = this.name;
					name = this.name;
					select+='<div class="dropdown">'+
							'<a class="input-group dropdown-toggle">'+
							'	<span id="'+name.split(' ').join('_')+'" class="form-control" tag="">'+name.split('_').join(' ')+'</span>'+
							'	<span class="input-group-btn">'+
							'		<button type="button" class="btn icon-arrow-down"></button>'+
							'	</span>'+
							'</a>'+
							'<ul class="dropdown-menu">'+
							'		<li><a name="'+name.split(' ').join('_')+'" id="'+i+'" href="#"><b>'+this.name+'</b></a></li>';
					$(this.elementos).each(function(item){
						select+='	<li><a name="'+name.split(' ').join('_')+'" id="'+this.id+'" href="#">'+this.nombre+'</a></li>';
					});
					select+= '</ul></div>';
					
				});
				$('#header').append(select);
				// Bindeo el evento que se lanza al filtrar
				
				var header = $('#header').height()+25;
				//console.log(header);
				$('#main').css('margin-top', header);
				//console.log($('#main').css('margin-top'));
				
				$('.dropdown-menu li a').click(function(e){
					e.stopPropagation();
//					console.log('#'+this.name);
//					console.log(this.text);
					
					$('#'+this.name).text(this.text);
					tag = ($.inArray(this.text, cabecera)!== -1)?'':this.id;
//					console.log('TAG: ',tag);
					$('#'+this.name).attr('tag',tag);
					$(this).parents('.dropdown-menu').slideUp('slow',function(){});
					mostrar_caratulas(0);
					
				});
				
				$('div.dropdown').click(function(event){
					event.preventDefault();
					$('.dropdown-menu').not($(this).children('.dropdown-menu')).slideUp('slow',function(){});
					$(this).children('ul.dropdown-menu').toggle('slow');
				});
				$('.buscar').blur(function(){
					/*if ( $(this).val().length == '0') {
						$(this).val('');
					}*/
					$('.dropdown-menu').slideUp('slow',function(){});
					mostrar_caratulas(0);
				});
				
				$('.interfaz_285').find(".dropdown-menu li").hover(
					function() {
						$( this ).attr('class','active');
					}, function() {
						$( this ).removeAttr('class','active');
					}
				);
			}
			
		}else{
			
			if (this.name == "filtros") {
				// Recorro las opciones de los filtros.
				var count = 0;
				$(this.elementos).each(function(){
				
					// Creo el select de cada filtro
					var tmp = '';
					
					$(this.elementos).each(function(item){
						tmp += '<option value="'+this.id+'">'+this.nombre+'</option>';
					});
					$('#header').append('<select name="'+this.name+'"><option value="">'+this.name+'</option>'+tmp+'</select>');
					count++;
					if (((count >= 3) && $(".buscar").is(":visible")) || (count >= 4 )) {
						$(".buscar").css('margin-right', '0px');
						$(".buscar").width(790);
					}
					$('#main').css("margin-top", ($('#header').height() + 26) + "px");
				});
				
				// Bindeo el evento que se lanza al filtrar
				$('select').change(function(){
					mostrar_caratulas(0);
				});
				$('.buscar').change(function(){
					/*if ( $(this).val().length == '0') {
						$(this).val('');
					}*/
					mostrar_caratulas(0);
				});
			}
		}
	});
	
	
	$('.resetFilters').click(function(){
		if(interfaz == 'interfaz_271' || interfaz == 'interfaz_272' || interfaz == 'interfaz_285'){
			$('span.form-control').each(function(){
				label = $("#" + $(this).attr("id")).attr('id').split('_').join(' ');
				$(this).text(label);
				$(this).attr('tag','');
			});
		}else{
			$("select").each( function(){
				$(this).val( $("#" + $(this).attr("id") + " option:first").val() );
			});
		}
		$('.buscar').val("");
		mostrar_caratulas(0);
	
	});

	$('.buscar').click(function(){
		$(this).val('');
	});
	
	$('.buscar').blur(function(){
		/*if ( $(this).val().length == '0') {
			$(this).val('');
		}*/
		mostrar_caratulas(0);
	});
	
	$(document).bind('mousemove', function(e){
	    $('.tooltip').css({
	       left:  e.pageX + 10,
	       top:   e.pageY + 2
	    });
	});
	/*
	$('#hot_down').click(function(){
		$('#main').animate({ scrollTop: $('#main').scrollTop() + 700 }, 'slow', function() { comprobar_hot_zones(); });	
	});
	
	$('#hot_up').click(function(){
		$('#main').animate({ scrollTop: $('#main').scrollTop() - 700 }, 'slow', function() { comprobar_hot_zones(); });	
	});
	*/
	mostrar_caratulas(0);

});


function mostrar_caratulas(inicio) {
	

	$('.mostrar_mas').remove();
	
	var caratulas_por_pagina = 50;

	// Borro las caratulas si las hubiese
	if (inicio == 0) {
		$('#main').html('');
	}
	
	// Proceso los datos en busca de caratulas 
	$.each(data, function() {
		//Toma las caratulas
		if (this.name == "caratulas") {
		
			var keywords = $('.buscar').val().split(" ");
			var y = 0;
			//console.log(keywords)
			
			$(this.elementos).each(function(item){
			
				var flag = true;
				var elemento = this;
				
				if(interfaz == 'interfaz_271' || interfaz == 'interfaz_272' || interfaz == 'interfaz_285'){
					$('span.form-control').each(function(){
						if ($(this).attr('tag')!='' && elemento.opciones.indexOf('('+$(this).attr('tag')+')') == -1){
							flag = false;
						}
					});
				}else{
					$('select').each(function(){
						if ( ($(this).find(':selected').val() != '')  && elemento.opciones.indexOf('('+$(this).find(':selected').val()+')') == -1 ) {
							flag = false;
						}
					});
				}
				
				
				var tmp = this.name.toLowerCase() + '';
				var tmp2 = this.etiquetas.toLowerCase() + '';
				
				if ( $('.buscar').val() != "Buscar" && $('.buscar').val() != "" ) {
					for (var i = 0; i < keywords.length; i++) {
						if ( ( this.name.indexOf(keywords[i]) == -1 && tmp.indexOf(keywords[i].toLowerCase()) == -1 ) && ( this.etiquetas.indexOf(keywords[i].toLowerCase()) == -1 && tmp2.indexOf(keywords[i].toLowerCase()) == -1 ) ) {
							flag = false;
						}
					}
						
				}
			
				if (flag) {
					
					if ( (y >= (inicio)) && (y < (inicio + caratulas_por_pagina)) ) {
				
						// Creo cada caratula si ha cumplido con los filtros establecidos.
						
						if (this.name == "") { this.name = " "; }
						if (this.link == "") { var tmp_class = "off"; } else { var tmp_class = ""; }
						$('#main').append('<div class="elemento elemento_'+item+'" title="'+this.name+'" rel="'+this.link+'"><div class="elem_left"></div><div class="elem_right"></div><div class="elem"><img src="'+this.image+'" /><div class="elem_fade '+tmp_class+'"></div></div></div>'); 
						
						// Le meto un random a la ruta del a imagen para que IE8 no cachee la imágen.
						$("<img/>").attr("src", this.image +'?'+Math.floor(Math.random()*1001)).load(function() {
						
		        			$('.elemento_'+item).width(this.width);
		        			$('.elemento_'+item+' .elem_fade').css('width',this.width);
		        			$('.elemento_'+item+' .elem_left').css('width', Math.floor(this.width / 2) + 23);
		        			$('.elemento_'+item+' .elem_right').css('width', Math.ceil(this.width / 2) + 23);
		        			$('.elemento_'+item).tooltip();
		        			if ($('.elemento_'+item).attr('rel') != "") {
		        				$('.elemento_'+item).click(function(){ window.open( $('.elemento_'+item).attr('rel') ); });
		        			}
		        			//comprobar_hot_zones();
		        		});
	        		
	        		} else {
		        		
		        		if (y == (inicio + caratulas_por_pagina)) {
			        		
			        		$('#main').append('<div class="mostrar_mas"><div class="button_mostrar_mas"></div></div>'); 
			        		$('.mostrar_mas').click(function(){ mostrar_caratulas(inicio + caratulas_por_pagina); });
			        		
		        		}
		        		
	        		}
	        		
	        		y++;
        		
        		}
				
			});
			
		}
		
	});
	
}




/*
function comprobar_hot_zones() {

		if ( $('#main')[0].scrollHeight > ($('#main').scrollTop() + 708) ) { 
			$('#hot_down').addClass('enabled'); 
		} else {
			$('#hot_down').removeClass('enabled'); 
		}

		if ( $('#main').scrollTop() > 0 ) { 
			$('#hot_up').addClass('enabled'); 
		} else {
			$('#hot_up').removeClass('enabled'); 
		}

}
*/
