var ALTO_FONDO = 510;
var ANCHO_FONDO = 660;
var RATIO_FONDO = ANCHO_FONDO/ALTO_FONDO;

var configuracion = {
	visor: {},
	recurso: {},
};
//
configuracion.visor = {
	conBorde: true,
	conEncabezado: true,
	conPie: false,
};

function getGET() {
    var loc = document.location.href;
    if(loc.indexOf('?')>0)
    {
        var getString = loc.split('?')[1];
        var GET = getString.split('&');
        var get = {};
        for(var i = 0, l = GET.length; i < l; i++){
            var tmp = GET[i].split('=');
            get[ tmp[0] ] = unescape( decodeURI(tmp[1]) );
        }
        return get;
    }
    return {};
}

$(document).ready( function(){

	if ( typeof config_json === "undefined" ){
		var idRecursoSgo = getGET().id || false;
		if ( idRecursoSgo ){
			alert( idRecursoSgo );
		}
		console.log( "no se pudo cargar el recurso" );
	}
	else{

		ejecutarRecurso() ;
	}
    introduce_retorno();
});

function ejecutarRecurso(){
	// console.log( config_json );
	config_json = config_json.replace(/(?:\r\n|\r|\n)/g,"");
	configuracion.recurso = JSON.parse( config_json );
	ims.interfaz.init();
	ims.interfaz.setTitle(configuracion.recurso.textos.titulo);
	crearVisor( configuracion.visor );
	crearRecurso( configuracion.recurso.elementos.elementos );
}

function crearVisor( data ){

	$("#url_interfaz").remove();

	$("#visor").empty();
	$("#visor").append('<div id="cuerpo"></div>');

	$("#overall").remove();
	//$("body").append( '<div id="visor"><div id="cuerpo"></div></div>' );

	if ( data.conBorde ){
		$("#visor").addClass( "conBorde" );
	}
	if ( !data.conEncabezado ){
		// $("#visor").prepend( '<div id="encabezado"></div>' );
		// $("#visor").addClass( "conEncabezado" );
		$("#header").remove();
	} else {
		$("#visor").addClass( "conEncabezado" );
	}
}

function crearRecurso( data ){

	// var ruta = "http://local.santillanago.com/local/archivos/archivos/ESHS0001/files/";
	// var ruta = "files/";
	var ruta = configuracion.recurso.path;
	//aquí debería ir la factoria...
	//pero de momento nada...
	$("#cuerpo").append( '<div id="zonaexplicacion"></div><div id="zonahotspot"></div>' );
	//aqui deberían ir los construct...
	var _fondo = data.fondo && data.fondo.src || "";
	//
	var _hotspots = data.hotspots || [];
	//
	var _intro = data.introduccion || {};
	var _imagenIntro = _intro.imagen && _intro.imagen.src || false;
	var _textoIntro = _intro.texto || false;

	$("#zonahotspot").append( '<img id="fondoZona" class="fondo" src="'+ ruta+_fondo +'" alt="fondoZonaHotspot">' );
	if ( $("#fondoZona").width()/$("#fondoZona").height() < RATIO_FONDO ){
		$("#fondoZona").css({
			"height": "100%"
		});
	}
	else {
		$("#fondoZona").css({
			"width": "100%"
		});
	}

	for ( var i = 0, len = _hotspots.length ; i < len; i++ ){
		//refactorizar esto...
		console.log( unHotspot );
		//constructor...
		var unHotspot = _hotspots[i];
		//constructor dimensiones...
		var _explicacion = unHotspot.explicacion || {};
		var _imagenExplicacion = _explicacion.imagen && _explicacion.imagen.src || false;
		var _textoExplicacion = _explicacion.texto || false;
		
		$("#zonahotspot").append( '<div id="hotspot'+i+'" class="hotspot"></div>' );
		$("#hotspot"+i).css({
			top: unHotspot.posicion.y,
			left: unHotspot.posicion.x,
			width: unHotspot.dimensiones.x,
			height: unHotspot.dimensiones.y
		});
		$("#hotspot"+i).click( function(){
			var _id = $(this).get( 0 ).id ;
			var _index = _id.split( "hotspot" )[1];
			$(".hotspot").removeClass("activo");
			$(this).addClass("activo");
			mostrarExplicacion( _index );
		});

		$("#zonaexplicacion").append( '<div id="explicacion'+i+'" class="explicacion"></div>' );
		$("#explicacion"+i).css({
			"display": "none"
		});
		if ( _imagenExplicacion ) {
			$("#explicacion"+i).css({
				"background-image": "url("+ruta+_imagenExplicacion +")",
				"background-size": "100% auto",
				"background-repeat": "no-repeat"
			});
		}
		if ( _textoExplicacion ) {
			$("#explicacion"+i).append( '<div id="textoExplicacion'+i+'" class="textoExplicacion">'+ _textoExplicacion +'<div>' );
		}
	}
	$("#hotspot0").addClass("activo");
	mostrarExplicacion( 0 );
}

function mostrarExplicacion( i ){ 

	$(".explicacion").hide();
	$("#explicacion"+i).show();

	if ( $("#textoExplicacion"+i)[0] ){
		
		if( $("#textoExplicacion"+i)[0].scrollHeight >  $("#textoExplicacion"+i).innerHeight() ){
			
			if ( $("#desplegador"+i).length == 0 ){

				$("#explicacion"+i).append( '<div id="desplegador'+i+'" class="desplegador"></div>' );
								
				$("#desplegador"+i).click( function(){
					accionDesplegador( i );
				});
				$("#desplegador"+i).css({
					"background-image": 'url( "http://local.santillanago.com/images/flecha.png" )',
					"background-size": "100% auto",
					"background-repeat": "no-repeat"
				});
			}
		}
	}

	if(  $("#desplegador"+i) && $("#desplegador"+i).hasClass( "encogedor" ) ){
		$("#textoExplicacion"+i)[0].scrollTop = 0;
		$("#textoExplicacion"+i).removeClass( "desplegado" );
		$("#desplegador"+i).removeClass( "encogedor" ).addClass( "desplegador" );
	}			
}

function accionDesplegador( i ){
	if( $("#desplegador"+i).hasClass( "encogedor" ) ){
		$("#textoExplicacion"+i)[0].scrollTop = 0;
		$("#textoExplicacion"+i).removeClass( "desplegado" );
		$("#desplegador"+i).removeClass( "encogedor" ).addClass( "desplegador" );
	}
	else{
		$("#textoExplicacion"+i).addClass( "desplegado" );
		$("#desplegador"+i).removeClass( "desplegador" ).addClass( "encogedor" );
	}
}

// function agrandarTextoExplicacion( i ){
	
// 	$("#textoExplicacion"+i).addClass( "desplegado" );
// 	$("#desplegador"+i).remove();
	
// 	$("#explicacion"+i).append( '<div id="encogedor'+i+'" class="encogedor"></div>' );

// 	$("#encogedor"+i).click( function(){
// 		console.log( "encogedor" );
// 		var _id = $(this).get( 0 ).id ;
// 		var _index = _id.split( "encogedor" )[1];
// 		encogerTextoExplicacion( _index );
// 	});
// }

// function encogerTextoExplicacion( i ){
	
// 	$("#textoExplicacion"+i).removeClass( "desplegado" );
// 	$("#encogedor"+i).remove();
	
// 	$("#explicacion"+i).append( '<div id="desplegador'+i+'" class="desplegador"></div>' );
	
// 	$("#desplegador"+i).click( function(){
// 		console.log( "desplegador" );
// 		var _id = $(this).get( 0 ).id ;
// 		var _index = _id.split( "desplegador" )[1];
// 		agrandarTextoExplicacion( _index );
// 	});
// }
