function tooltipManager(id, name, x, y, width, height, rotation, z_index){
	objectManager.call(this, id, name, x, y, width, height, rotation, z_index);
	this.z_index = z_index;
	
	this.idPreffix = "tooltip_";
}

tooltipManager.prototype = new objectManager();
tooltipManager.prototype.constructor = objectManager;

tooltipManager.prototype.getZIndex = function(){return this.z_index;};
tooltipManager.prototype.insert = function(container){
    var string = '<div class="_tool_poi_grl tooltip" id="'+this.getIdPreffix() + this.getId()+'" style="z-index:' + this.getZIndex() + '">';
    string += '<span>' + this.getName() + '</span>';
    string += '</div>';
    
    $( "#"+container).append(string);
    // definimos la posicion de los tooltips _Poi
    var Y_poi_tooltip = Number(this.getY()) - Number($(this.getPublicId() + ' span').outerHeight());
    var X_poi_tooltip = Number(this.getX()) + Number(this.getWidth());
    $(this.getPublicId()).css({
    	"top": Y_poi_tooltip,
    	"left": X_poi_tooltip
    });
};
tooltipManager.prototype.deleteTooltip = function(){
	$("._tool_poi_grl").remove();
};