var id_dif             = 0;
var num_conj            = 0;
var checked             = 0;
var p                   = 2;
var dragging            = false;
var draggingObj         = null;
var click               = (('ontouchend' in window)) ? 'touchend' : 'click';
var cont                = 0;
var soluciones          = [];
var item_width          = '';
var item_height         = '';
var items               = [];
var hots                = [];
var results             = [];
var hotspotDefaultBG    = "";
var url_files           = "";
var activamosAleatorias = 1;
var magnetismo          = 0;
var numPal_Conj         = [];
var palabras            = [];
var vistaSolucion       = 0;
var dobleClick          = 0;
var seleccionado        = 0;
var eq_palabra          = 100;
var cajas_arrastrar     = [];
var pos_over            = 75;
var editable            = null;

var init = function () {
    document.title = 'Santillana';
    // if($("#url_interfaz").text() != "") {
    //     url_interfaz = $("#url_interfaz").text();
    // }
    $("#url_interfaz").remove();
    $(".ui-loader").remove();
    config_xml = $.parseXML(config_xml);
    url_files = $(config_xml).find("path").text();
    ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    ims.interfaz.setSound('bad', url_interfaz + 'audio/bad.mp3');
    ims.interfaz.setSound('result', url_interfaz + 'audio/result.mp3');
    ims.interfaz.init();
    inicializar();
    $("#left2").remove();
    $("#right2").remove();
    document.addEventListener("touchmove", function (e) {
        return false;
    }, false);
    if(isiOS) {
        $("body").css("margin-top", "-20px");
    }
};

var posicionar = function () {
    ims.interfaz.resize();
    $('#overall').height($('#carcasa').height());
    if($('.positionbar').length == '0') {
        $('#overall').height($('#overall').height() - $('#header').height() - $('#bottombar').height() - pos_over);
    }else{
        $('#overall').height($('#overall').height() - $('#header').height() - pos_over);
    }
    $('#overall').css('top', $('#header').height() + pos_over);
    $('#fondo').css('top', $('#overall').css('top'));
    $('#fondo').height($('#overall').height());
};

var posicionarletras = function () {
    filas          = 0;
    columnas       = 0;
    anchoMarco     = 20;
    stageWidth     = $("#overall").width();
    palabra_Alto   = 25;
    numeroColumnas = (Math.floor(palabras.length / 2)) + (palabras.length % 2);
    palabras_Width = numeroColumnas * palabra_ancho;
    posicionPrimerColumna = ((stageWidth / 2) - (palabras_Width / 2)) - anchoMarco;
    alturaPrimerFila      = 105;
    separacionEntreFilas  = 25;
    numConjuntos = $(".conj_arrastrar").size();
    indicesPalabrasPosicion = ranNumArray(($(".item_arrastrar").size() - 1), $(".item_arrastrar").size());
    i = 0;
    while(i < $(".item_arrastrar").size()) {
        for(var j = 0; j < numConjuntos; j++) {
            indicesReales = indicesPalabrasPosicion[i] - 1;
            obj = $("#item_" + indicesReales + "_" + j);
            if(obj.attr("id") != undefined) {
                i++;
                if((filas % 2) == 0) {
                    filas = 0;
                    x = posicionPrimerColumna + ((palabra_ancho + separacionEntreFilas) * columnas);
                    columnas++;
                }
                y = alturaPrimerFila + ((palabra_Alto + separacionEntreFilas) * filas);
                obj.css('left', x);
                obj.css('top', y - pos_over);
                obj.attr('x', x);
                obj.attr('y', y);
                filas++;
            }
        }
    }
};

if(typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function (e) {
        init();
        window.addEventListener("scroll", posicionar, false);
        window.addEventListener("resize", posicionar, false);
        window.addEventListener("load", posicionar, false);
    });
}else{
    $(window).ready(function () {
        init();
    });
    $(window).resize(function () {
        posicionar();
    });
    $(window).load(function () {
        posicionar();
    });
    $(window).scroll(function () {
        posicionar();
    });
}

$(document).ready(function () {
    ims.interfaz.resize();
});

function inicializar() {
    // compruebo si existe introduccion para lanzar la pagina principal, en caso
    // de que no, cargamos la actividad
    if($(config_xml).find("introduccion").find("texto1").text().length != 0) {
        $(config_xml).find("introduccion").each(
            function () {
                var IntTit = $(this).find("titulo").text();
                var IntTex = $(this).find("texto1").text();
                ims.interfaz.setTitle(IntTit);
                $("#visor_content").append(
                    "<div id=\"respuesta\" style=\" padding : 30px 0px; \">" + IntTex + "</div>");
                var comenzar = $(config_xml).find("comenzar").text();
                ims.interfaz.addButton("Siguiente", "right", "siguiente",
                    comenzar);
                ims.interfaz.enable("Siguiente");
                ims.interfaz.bind("Siguiente", 'nextPage()');
            }
        );
    }else{
        cargar_actividad();
    }
    posicionar();
}

function cargar_actividad() {
    var numConjuntos    = 0;
    var borrarConjuntos = 0;
    var numSubConjuntos = 0;
    var pantalla        = 1;
    // Set Interfaz
    setDificultInterface();
}

function ranNumArray(values, limit) {
    var numbers = [];
    if(limit == undefined || limit == null) {
        limit = 3;
    }
    if(values == undefined || values == null) {
        values = limit - 1;
    }
    var count = -1;
    while(numbers.length <= values) {
        var match = false;
        count++;
        var ran = Math.floor((Math.random() * limit) + 1);
        for(var x = 0; x <= numbers.length; x++) {
            if(ran == numbers[x]) {
                match = true;
                break;
            }
        }
        if(!match) {
            numbers[count] = ran;
        }else{
            count--;
        }
    }
    return numbers;
}

// Autor RCBL
// posiciona los elementos de la segunda pantalla
// parametros : void
function setDificultInterface() {
    emptyStage();
    cargarCommunStage();
    // variables y propiedades
    $('#visor').prepend('<div id="pregunta">' + $(config_xml).find("enunciado").text() + '</div>');
    $('#pregunta').addClass('pregunta_inf');
    $('#pregunta').css('position', 'absolute');
    $('#content').css('z-index', '999');
    var tit = $(config_xml).find('introduccion').find("titulo").text().split("</p>");
    $('#header').prepend(tit[0] + '</p>');
    $('#carcasa').prepend('<div id="overall" style="width: ' + $("#carcasa").width() + 'px; height: ' + ($("#carcasa").height() - $("#right").height()) + 'px; "></div>');
    // la carga
    magnetismo = ($(config_xml).find('content').find("conjuntos").attr("snap") == "1") ? 1 : 0;
    conjuntos_visible = ($(config_xml).find('content').find("conjuntos").attr("visible") == "1") ? 1 : 0;
    titulos_visible = ($(config_xml).find('content').find("titulos").attr("visible") == "1") ? 1 : 0;
    $(config_xml).find('content').find('conjuntos').find("conjunto").each(function (j) {
        var id = $(this).attr("id");
        toAppend = '<div id = "conj_' + id + '" class="conj_arrastrar" style="position: absolute; rotation:' + (Math.round($(this).attr("rotation"))) + '; top: ' + (Math.round($(this).attr("y"))) + 'px; left: ' + (Math.round($(this).attr("x"))) + 'px; width: ' + $(this).attr("width") + 'px; height: ' + $(this).attr("height") + 'px;" rel="-1"></div>';
        $("#overall").append(toAppend);
        numPal_Conj['conj_' + id] = [];
    });
    if(titulos_visible == 1) {
        $(config_xml).find('content').find("titulos").find("titulo").each(function (x) {
            var id = $(this).attr("id");
            toAppend = '<div id = "tit_' + id + '" class="titInerfaz" style="position: absolute; rotation:' + (Math.round($(this).attr("rotation"))) + '; top: ' + (Math.round($(this).attr("y"))) + 'px; left: ' + (Math.round($(this).attr("x"))) + 'px; width: ' + $(this).attr("width") + 'px; height: ' + $(this).attr("height") + 'px;">' + $(this).text() + '</div>';
            $("#overall").append(toAppend);
        });
    }
    if(conjuntos_visible == 1) {
        $(".conj_arrastrar").addClass("backComplete");
    }
    //DANIEL  13/08/13
    var eq = 0;
    $('.conj_arrastrar').each(function () {
        cajas_arrastrar[eq] = 0;
        eq++;
    });
    if(activamosAleatorias == 1) {
        palabras = [];
        num_conj++;
        if(num_conj >= $(config_xml).find('content').find('conjuntos').find("conjunto").size()) {
            num_conj = 0;
        }
        conjuntos = [];
        numPalabrasAMostrar = 0;
        indicePalabras = 0;
        $(config_xml).find('content').find('conjuntos').find("conjunto").each(function (k) {
            numPalabrasAMostrar = Number($(this).attr("num_palabras"));
            totalPalabras_a_Mostrar = $(config_xml).find("palabra[id_conjunto=" + k + "]").size();
            if(numPalabrasAMostrar >= totalPalabras_a_Mostrar) {
                numPalabrasAMostrar = totalPalabras_a_Mostrar;
            }
            palabrasAleatorias = ranNumArray((numPalabrasAMostrar - 1), totalPalabras_a_Mostrar);
            $(config_xml).find("palabra[id_conjunto=" + k + "]").each(function (i) {
                for(z = 0; z < palabrasAleatorias.length; z++) {
                    numAle = Number(palabrasAleatorias[z] - 1);
                    if(numAle == i) {
                        palabras[indicePalabras] = $(this).text();
                        conjuntos[indicePalabras] = $(this).attr("id_conjunto");
                        indicePalabras++;
                    }
                }
            });
        });
    }
    // ponemos las palabras
    separacionEntreFilas = 50;
    palabra_ancho = 0;
    $('#overall').append('<div id="contenedor_palabras"></div>');
    for(i = 0; i < palabras.length; i++) {
        palabras[i] = palabras[i].toLowerCase();
        insert = '<span id = "item_' + i + "_" + conjuntos[i] + '" class="item_arrastrar" posicion="-1" style="position: absolute; top:0px; left:0px;" y="0" x="0" rel="-1">' + palabras[i] + '</span>';
        $("#contenedor_palabras").append(insert);
        if($('#item_' + i + "_" + conjuntos[i]).width() > palabra_ancho) {
            palabra_ancho = $('#item_' + i + "_" + conjuntos[i]).width();
        }
    }
    objFoto = $(config_xml).find("foto");
    if(objFoto.text() != "") {
        if(url_files != "") {
            img = url_files + objFoto.text();
        }else{
            img = url_files + objFoto.text();
        }
        img = '<img src="' + img + '" style="width:' + objFoto.attr('width') + 'px; height:' + objFoto.attr('height') + 'px; position: absolute; top:' + (Math.round(objFoto.attr('y'))) + 'px; left:' + (Math.round(objFoto.attr('x'))) + 'px;" >';
        $("#fondo").append(img);
    }
    if(isMobile) {
        //Move nueva carcasa (solución zoom)   Daniel  12/8/13
        $(".item_arrastrar").bind(click, function(){
            if( checked == 0 ) {
                if( seleccionado == 0 ){
                    draggingObj = $( this );
                    dragging = true;
                    seleccionado = 1;
                    eq_palabra = $(this).index('.item_arrastrar');
                }
            }

            if($(this).attr("posicion")!="-1"){
                $(this).css({
                    top:$(this).attr("y")+"px",
                    left:$(this).attr("x")+"px"
                });

            //este elemento vuelve a su posicion original. Si hay pila en el hot, queda el espacio vacio
            //elementos en este hot: item_arrastrar position = conj_2
            //atributo que hay que cambiar: top
            that = $(this);
            var i = 0;
            $('.item_arrastrar').each( function(){
                conjunto = that.attr('posicion');
                if(  ($(this).attr('posicion') == conjunto) && ($(this).attr("id")!=that.attr('id') )  ){
                    //los itmes que estan en el mismo hot del elemento que retiro, EXCEPTO el que estoy quitando
                    //rearmar la pila: top del conjunto + 10 multiplicado por la cant de palabras apiladas (i)
                    nuevoTop = ( parseInt($('#'+conjunto).css('top').replace('px','')) +(25*i)+10 )+'px';
                    $(this).css('top',nuevoTop);
                    i++;
                }
            });
            $(this).attr("posicion","-1");

            //en cajas_arrastrar guarda para cada conjunto la posicion donde debe insertar el proximo elemento. 
            //al retirar un item, reducir (25px, que es lo que le suma cada vez que agrega alguno)
            cajas_arrastrar[conjunto.replace('conj_','')] = cajas_arrastrar[conjunto.replace('conj_','')]-25;
        }
    });

        $('.conj_arrastrar').bind(click, function () {
            if(seleccionado == 1) {
                //Movemos la palabra
                $('.item_arrastrar').eq(eq_palabra).css({
                    'top': parseInt($(this).css('top')) + 10 + cajas_arrastrar[$(this).index()],
                    'left': parseInt($(this).css('left')) - $('.item_arrastrar').eq(eq_palabra).width() / 2 + $(this).width() / 2
                });
                //Le añadimos las propiedades de la caja
                $('.item_arrastrar').eq(eq_palabra).attr('posicion', $(this).attr('id'));
                $('.item_arrastrar').eq(eq_palabra).attr('rel', $(this).index());
                cajas_arrastrar[$(this).index()] = cajas_arrastrar[$(this).index()] + 25;
                seleccionado = 0;
            }
        });
    }else{
        $( ".item_arrastrar" ).live( "mousedown", function( e ) {
         e.preventDefault();
         
         // item_width = (e.pageX-($(this).offset().left*z))/z;
         // item_height = (e.pageY-($(this).offset().top*z))/z+pos_over+60;
         
         if( checked == 0 ) {
	         var z = ims.interfaz.zoomRatio;
	         if(z == 'none' || typeof (z) == 'undefined')
		        z = 1;
            draggingObj = $( this );
            dragging = true;
	        xMouse = e.pageX - parseFloat(($(this).offset().left) * z);
	        yMouse = e.pageY - parseFloat(($(this).offset().top) * z);
	        item_width = xMouse / z;
	        item_height = yMouse / z+pos_over+60;
	        objoff = $(this).offset();
         }

      }
      );

        $(document).live("mousemove", function (e) {
            var z = parseFloat($("#limit").css("zoom"));
            if(typeof (z) == "undefined")
                z = 1;
            var tmp_x = (e.pageX - (($('#limit').offset().left) * z)) / z - item_width;
            var tmp_y = (e.pageY - ($('#limit').offset().top * z)) / z - item_height;
            move(draggingObj, tmp_x, tmp_y);
        });

        $(document).live("mouseup", function (e) {
            if(dragging) {
                suelta();
            }
        });
    }
    posicionarletras();
}

function move(obj, x, y) {
    if(vistaSolucion == 0) {
        if(dragging) {
            obj.css("position", "absolute");
            obj.css("left", (parseInt(x)) + "px");
            //FIX PALAGRAS ENGANCHADAS -20
            obj.css("top", (parseInt(y)-20) + "px");
            $(".conj_arrastrar").each(function (a) {
                if(hotspotDefaultBG == "") {
                    hotspotDefaultBG = $(this).css("background");
                }
                var colisiona = intersects(obj, $(this));
            });
        }
    }
}

function intersects(obj1, obj2) {
    obj1x      = parseInt(obj1.css("left"));
    obj1y      = parseInt(obj1.css("top"));
    obj2x      = parseInt(obj2.css("left"));
    obj2y      = parseInt(obj2.css("top"));
    obj1width  = obj1.width();
    obj1height = obj1.height();
    obj2width  = obj2.width();
    obj2height = obj2.height();
    obj1off    = obj1.offset();
    obj2off    = obj2.offset();
    if(obj1off.left + obj1width < obj2off.left) {
        return false;
    }
    if(obj1off.top + obj1height < obj2off.top) {
        return false;
    }
    if(obj1off.left > obj2off.left + obj2width) {
        return false;
    }
    if(obj1off.top > obj2off.top + obj2height) {
        return false;
    }
    return true;
}

function resetele(obj) {
    $("#" + obj.attr("posicion")).attr("rel", "-1");
    obj.attr("posicion", "-1");
}

function suelta() {
    var obj     = draggingObj;
    var counter = 0;
    var topStac = ($("#limit").height() - $("#right").height() - 40) / 2;
    $(".conj_arrastrar").each(function () {
        if(intersects(obj, $(this)) && ($(this).attr("rel") == "-1")) {
            id_conj = $(this).attr("id").replace("conj_", "");
            resetele(obj);
            objoff = $(this).offset();
            if(magnetismo == 1) {
                unidad = obj.height() + 5;
                x = (objoff.left - $('#overall').offset().left);
                y = (objoff.top - $('#overall').offset().top);
                // - unidad
                ancho_arrastrable = $(obj).width();
                ancho_casilla     = $(this).width();
                alto_casilla      = $(this).height();
                nombreConj        = $(this).attr("id");
                nombrePalabra     = obj.attr("id");
                _alert = "";
                _alert = _alert + ("nombrePalabra = " + nombrePalabra);
                _alert = _alert + "\n //--------------------------------------------";
                for(z = 0; z < $(".conj_arrastrar").size(); z++) {
                    _alert = _alert + "\n //-----------------------";
                    _alert = _alert + ("\n Conjunto = " + z);
                    tam = 0;
                    for(i = 0; i < $(".conj_arrastrar").size(); i++) {
                        _alert = _alert + "\n //-----------------------";
                        _alert = _alert + ("\n grupo = conj_" + i);
                        for(j = 0; j < $(".item_arrastrar").size(); j++) {
                            objArrastrable = $("#item_" + j + "_" + i);
                            objConjunto = $("#conj_" + z);
                            if(objArrastrable.attr("id") != undefined) {
                                _alert = _alert + ("\n nom = " + objArrastrable.html() + " objArras = item_" + j + "_" + i + " " + intersects(objArrastrable, objConjunto));
                                if(intersects(objArrastrable, objConjunto)) {
                                    tam = tam + objArrastrable.outerHeight();
                                    _alert = _alert + " tam = " + tam;
                                    _alert = _alert + "\n y+tam = " + (Math.round(y) + tam);
                                    _alert = _alert + "\n y = " + Math.round(y);
                                    _alert = _alert + "\n height = " + objArrastrable.height();
                                    _alert = _alert + "\n outerheight = " + objArrastrable.outerHeight();
                                    _y_ = Math.round(y) + tam;
                                    // + tam
                                    objArrastrable.css("top", _y_ + "px");
                                }
                            }
                        }
                    }
                }
                _alert = _alert + "\n //--------------------------------------------";
                _x_ = x + ((ancho_casilla / 2) - (ancho_arrastrable / 2));
                // alert( _alert )
                obj.css("left", _x_ + "px");
            }

            counter++;
            obj.attr("posicion", $(this).attr("id"));
            obj.attr("rel", id_conj);
        }
    });
    if(counter == 0) {
        obj.css("left", obj.attr("x") + "px");
        obj.css("top", parseInt(obj.attr("y")) - pos_over + "px");
        obj.attr("rel", "-1");
        resetele(obj);
    }
    dragging = false;
}

function emptyStage() {
    $("#center").height(0);
    $("#center").empty();
    $("#fondo").css("background", "");
    $("body").toggle(1);
    $("#fondo").empty();
    $("#header p").remove();
    $("#pregunta").remove();
    $("#visor_content").remove();
    $("#overall").remove();
    $("#respuesta").empty();
    $("#right").empty();
    $("#left").empty();
    $('.tooltip').hide();
    $("body").toggle(1);
    $("#visor").append('<div id="visor_content" style="height: 495px; "></div>');
}

function cargarCommunStage() {

    var comprobar   = ($(config_xml).find("comprobar").text()) ? $(config_xml).find("comprobar").text() : "";
    var aleatorio   = ($(config_xml).find("aleatorio").text()) ? $(config_xml).find("aleatorio").text() : "";
    var versolucion = ($(config_xml).find("versolucion").text()) ? $(config_xml).find("versolucion").text() : "";
    var reiniciar   = ($(config_xml).find("reiniciar").text()) ? $(config_xml).find("reiniciar").text() : "";
    var silenciar   = ($(config_xml).find("silenciar").text()) ? $(config_xml).find("silenciar").text() : "";
    var orden       = ($(config_xml).find('orden').text() != '') ? $(config_xml).find('orden').text() : "";

    if(isMobile && orden) {
        ims.interfaz.addButton("orden1", "left", "orden", orden);
        ims.interfaz.bind("orden1", "toggle_enunciado()");
        ims.interfaz.enable("orden1");
    }

    if (reiniciar) {
        ims.interfaz.addButton("reiniciar4", "right", "reiniciar", reiniciar);
    }
    if (aleatorio) {
        ims.interfaz.addButton("aleatorio", "right", "aleatorio", aleatorio);
    }
    if(isMobile) {
        if (comprobar) {
            ims.interfaz.addButton("comprobar1", "left", "comprobar", comprobar);
        }
        if (versolucion) {
            ims.interfaz.addButton("versolucion2", "left", "versolucion", versolucion);
        }
    }else{
        if (versolucion) {
            ims.interfaz.addButton("versolucion2", "left", "versolucion", versolucion);
        }
        if (comprobar) {
            ims.interfaz.addButton("comprobar1", "left", "comprobar", comprobar);
        }
    }
    ims.interfaz.bind("comprobar1", 'comprobar()');
    ims.interfaz.bind("aleatorio", "getAleatorio()");
    ims.interfaz.bind("reiniciar4", 'volverEmpezar()');
    ims.interfaz.enable("comprobar1");
    ims.interfaz.enable("aleatorio");
    ims.interfaz.enable("reiniciar4");
    if(!isMobile && silenciar) {
        ims.interfaz.addButton("silenciar", "left", "silenciar", ($(config_xml).find("silenciar").text()) ? $(config_xml).find("silenciar").text() : "Silenciar");
        ims.interfaz.bind("silenciar", 'mute()');
        ims.interfaz.enable("silenciar");
        if(ims.interfaz.sound) {
            ims.interfaz.enable("silenciar");
            ims.interfaz.bind("silenciar", "mute()");
        }else{
            ims.interfaz.bind("silenciar", "play()");
        }

    }
	if (!isMobile && orden) {
        ims.interfaz.addButton("orden1", "left", "orden", orden);
        ims.interfaz.bind("orden1", "toggle_enunciado()");
        ims.interfaz.enable("orden1");
	}

    $(config_xml).find("respuesta").each(function () {
        var id = $(this).attr("id");
        // test simple
        ims.interfaz.bind(id, 'marcar(' + id + ')');
    });
    ims.interfaz.resize();
}

function volverEmpezar() {
    $('.tooltip').remove();
    $('#header p').remove();
    vistaSolucion = 0;
    activamosAleatorias = 0;
    ims.interfaz.enableSound();
    ims.interfaz.disable("versolucion2");
    $("#versolucion2").unbind();
    $(".item_arrastrar").unbind("click");
    $(document).unbind("click");
    setDificultInterface();
    $("#overall").css({
        "top": "140px",
        "height": "457px"
    })
}

function getAleatorio() {
    ims.interfaz.disable("versolucion2");
    $("#versolucion2").unbind('click');
    vistaSolucion = 0;
    activamosAleatorias = 1;
    $(".item_arrastrar").unbind("click");
    $(document).unbind("click");
    setDificultInterface();
    posicionar();
}

// Autor RCBL
// comprueba las frases
function comprobar() {
    id_interval = window.setInterval(toInterval, 3000);
    ims.interfaz.disable("comprobar1");
    $("#comprobar1").unbind('click');
    isAnswer     = 0;
    isMistake    = 0;
    var total    = $(".item_arrastrar").size();
    var aciertos = 0;
    $(".item_arrastrar").each(function () {
        id_item = $(this).attr('id').split("_");
        if($(this).attr('posicion') != undefined) {
            id_conj = $(this).attr('posicion').replace("conj_", "");
            if(id_conj == id_item[2]) {
                $(this).addClass("green2");
                unidad            = $(this).height() + 5;
                ObjConjunto       = $("#" + $(this).attr('posicion'));
                alturaObjConjunto = ObjConjunto.height();
                iniPosArrastrable = alturaObjConjunto - $(this).height();
                aciertos++;
            }else if(id_conj != id_item[2] /*&& id_conj != "-1"*/) {
                $(this).addClass("red2");
                $(this).attr('posicion', "-1");
                isMistake = 1;
            }
        }
    });

    if(aciertos != total) {
        setTimeout(function () {
            ims.interfaz.playSound('bad');
        }, 200);
        $("#versolucion2").unbind('click');
        ims.interfaz.disable("versolucion2");
        setTimeout(function () {
            ims.interfaz.bind("versolucion2", 'solucion()');
            ims.interfaz.enable("versolucion2");
        }, 4000);
    }else{
	    ims.interfaz.disable("comprobar1");
	    $("#comprobar1").unbind(click);
        setTimeout(function () {
            ims.interfaz.playSound('good');
        }, 200);
    }
}

function toInterval() {
    window.clearInterval(id_interval);
    $(".item_arrastrar").each(function () {
        x = $(this).attr("x");
        y = $(this).attr("y");
        posActual_x = Number($(this).css("left").replace("px", ""));
        posActual_y = Number($(this).css("top").replace("px", ""));
        if(posActual_x == x && posActual_y == y) {
            ims.interfaz.bind("versolucion2", 'solucion()');
            ims.interfaz.bind("comprobar1", 'comprobar()');
            ims.interfaz.enable("versolucion2");
            ims.interfaz.enable("comprobar1");
        }
        if($(this).attr('posicion') != undefined) {
            id_conj = $(this).attr('posicion').replace("conj_", "");
            id_item = $(this).attr('id').split("_");
            $(this).removeClass("red2");
            if(id_conj != id_item[2]) {
                $(this).animate({
                    top: y - pos_over,
                    left: x
                }, {
                    duration: 500,
                    easing: "easeOutBack",
                    complete: function () {
                        ims.interfaz.bind("versolucion2", 'solucion()');
                        ims.interfaz.bind("comprobar1", 'comprobar()');
                        ims.interfaz.enable("comprobar1");
                    }
                });
            }
        }
    });
}

function solucion() {
    ims.interfaz.bind("versolucion2", 'solucion()');
    ims.interfaz.enable("versolucion2");
    numCon = $(".conj_arrastrar").size();
    numItems = $(".item_arrastrar").size();
    margenTop = 10;
    margenLeft = 10;
    for(j = 0; j < numCon; j++) {
        num = 0;
        for(i = 0; i < numItems; i++) {
            pos = $("#conj_" + j).offset();
            obj_item = $("#item_" + i + "_" + j);
            if(obj_item.height() != null) {
                topOverAll = $('#overall').offset().top;
                x = (pos.left - $('#overall').offset().left);
                ancho_casilla = $("#conj_" + j).width();
                ancho_arrastrable = obj_item.width();
                _x_ = x + ((ancho_casilla / 2) - (ancho_arrastrable / 2));
                y = (pos.top - topOverAll + (obj_item.height() * num)) + margenTop;
                obj_item.css("left", _x_ + "px");
                obj_item.css("top", y + "px");
                obj_item.addClass("green2");
                num++;
            }
        }
    }
    setTimeout(function () {
        ims.interfaz.playSound('good');
    }, 200);
    ims.interfaz.disable("versolucion2");
    $("#versolucion2").unbind('click');
    ims.interfaz.disable("comprobar1");
    $("#comprobar1").unbind('click');
    $(".item_arrastrar").unbind('click');
    $(".item_arrastrar").unbind('mouseover');
    $(".item_arrastrar").unbind('mouseout');
    $(".item_arrastrar").css("cursor", "default");
    vistaSolucion = 1;
}

function mute() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar');
    $('#silenciar').addClass('silenciar_on');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "play()");
    ims.interfaz.disableSound();
}

function play() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar_on');
    $('#silenciar').addClass('silenciar');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "mute()");
    ims.interfaz.enableSound();
}

function toggle_enunciado() {
    $('#pregunta').fadeToggle();
}
