
ims.actividad = {
   totalTabs: 0,
   init: function(){
      
      if (isiOS) {
         $("body").css("margin-top", "-20px");
      }   
      $("#url_interfaz").remove();
      $("#pregunta").remove();
      ims.interfaz.introduce();
      //ims.interfaz.setStatement(ims.interfaz.getText("enunciado"));
   },
   setInterface: function(){
      ims.interfaz.emptyStage();
      var tabs = config_json.tabs;
      this.totalTabs = tabs.length;
      var html = "";
      // Carga
      //$( '#content' ).height( $( '#carcasa' ).height() - 20 );
      html  = '<div id="tabs"><ul>';
      html += '<div class="ui-tabs ui-tabs-nav navtag prev"><a class="ui-tabs-anchor" href="#" id="previous"> '+ims.interfaz.getText("atras")+' </a></div>';

      for (var i = 0; i < this.totalTabs; i++) {
         html += '<li><a href="#tabs-'+i+'">'+tabs[i].title+'</a></li>';
      }

      html += '<div class="ui-tabs ui-tabs-nav navtag next"> <a class="ui-tabs-anchor" href="#" id="next"> '+ims.interfaz.getText("siguiente")+' </a></div>';
      html += '</ul>';

      for (var i = 0; i < this.totalTabs; i++) {
         var template_txt = '<div class="template_txt">'+tabs[i].html+'</div>';
         if(tabs[i].img){
            var template_img = '<div class="template_img"><img src="'+ims.interfaz.urlFiles+tabs[i].img+'"></div>';
         }else if(tabs[i].vid){
            var template_img = '<div class="template_img"><video controls><source src="'+ims.interfaz.urlFiles+tabs[i].vid+'" >Your browser does not support the video tag.</video></div>';
         }
         var template_html = template_txt + template_img;
         if(tabs[i].template == 2){
            template_html = template_img + template_txt;
         }
         html += '<div class="template_main template_'+tabs[i].template+'" id="tabs-'+i+'">'+template_html+'</div>';
      }

      html += '</div>';
      // -------------
      $( '#visor' ).append( html );

      ims.interfaz.bind("previous","ims.actividad.previous()");
      ims.interfaz.bind("next","ims.actividad.next()");
      this.setSetByStep();
   },
   setSetByStep: function(){
      var self = this;
    
      $( "#tabs" ).tabs();
      $( ".tabs-bottom .ui-tabs-nav, .tabs-bottom .ui-tabs-nav > *" )
      .removeClass( "ui-corner-all ui-corner-top" )
      .addClass( "ui-corner-bottom" );

      // move the nav to the bottom
      $( ".tabs-bottom .ui-tabs-nav" ).appendTo( ".tabs-bottom" );
   },
   next: function(){
      var active  = $( "#tabs" ).tabs( "option", "active" );
      var next    = parseInt(active) + 1;
      if(next == this.totalTabs){
         next = 0;
      }
      $( "#tabs" ).tabs( "option", "active", next );
   },
   previous: function(){
      var active = $( "#tabs" ).tabs( "option", "active" );
      var previous = parseInt(active) - 1;
      $( "#tabs" ).tabs( "option", "active", previous );
   }
};

$(document).ready(function() {
   ims.interfaz.init();
});
